// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassAnimation.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreAnimation.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumVertexAnimationType.h"
#include "EnumInterpolationMode.h"
#include "EnumRotationInterpolationMode.h"


// original function: const String& getName();
void cAn_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: Real getLength();
void cAn_getLength_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setLength(Real len);
void cAn_setLength_c(struct hg3dclass_struct *classptr_c, float len_c);
// original function: NodeAnimationTrack* createNodeTrack(unsigned short handle);
void cAn_createNodeTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, struct hg3dclass_struct * result_c);
// original function: NumericAnimationTrack* createNumericTrack(unsigned short handle);
void cAn_createNumericTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, struct hg3dclass_struct * result_c);
// original function: VertexAnimationTrack* createVertexTrack(unsigned short handle, VertexAnimationType animType);
void cAn_createVertexTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, enum EnumVertexAnimationType animType_c, struct hg3dclass_struct * result_c);
// original function: NodeAnimationTrack* createNodeTrack(unsigned short handle, Node* node);
void cAn_createNodeTrack2_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, struct hg3dclass_struct * node_c, struct hg3dclass_struct * result_c);
// original function: unsigned short getNumNodeTracks();
void cAn_getNumNodeTracks_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: NodeAnimationTrack* getNodeTrack(unsigned short handle);
void cAn_getNodeTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, struct hg3dclass_struct * result_c);
// original function: bool hasNodeTrack(unsigned short handle);
void cAn_hasNodeTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, int * result_c);
// original function: unsigned short getNumNumericTracks();
void cAn_getNumNumericTracks_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: NumericAnimationTrack* getNumericTrack(unsigned short handle);
void cAn_getNumericTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, struct hg3dclass_struct * result_c);
// original function: bool hasNumericTrack(unsigned short handle);
void cAn_hasNumericTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, int * result_c);
// original function: unsigned short getNumVertexTracks();
void cAn_getNumVertexTracks_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: VertexAnimationTrack* getVertexTrack(unsigned short handle);
void cAn_getVertexTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, struct hg3dclass_struct * result_c);
// original function: bool hasVertexTrack(unsigned short handle);
void cAn_hasVertexTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, int * result_c);
// original function: void destroyNodeTrack(unsigned short handle);
void cAn_destroyNodeTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c);
// original function: void destroyNumericTrack(unsigned short handle);
void cAn_destroyNumericTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c);
// original function: void destroyVertexTrack(unsigned short handle);
void cAn_destroyVertexTrack_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c);
// original function: void destroyAllTracks();
void cAn_destroyAllTracks_c(struct hg3dclass_struct *classptr_c);
// original function: void destroyAllNodeTracks();
void cAn_destroyAllNodeTracks_c(struct hg3dclass_struct *classptr_c);
// original function: void destroyAllNumericTracks();
void cAn_destroyAllNumericTracks_c(struct hg3dclass_struct *classptr_c);
// original function: void destroyAllVertexTracks();
void cAn_destroyAllVertexTracks_c(struct hg3dclass_struct *classptr_c);
// original function: void apply(Real timePos, Real weight, Real scale);
void cAn_apply_c(struct hg3dclass_struct *classptr_c, float timePos_c, float weight_c, float scale_c);
// original function: void applyToNode(Node* node, Real timePos, Real weight, Real scale);
void cAn_applyToNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * node_c, float timePos_c, float weight_c, float scale_c);
// original function: void apply(Skeleton* skeleton, Real timePos, Real weight, Real scale);
void cAn_apply2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * skeleton_c, float timePos_c, float weight_c, float scale_c);
// original function: void apply(Entity* entity, Real timePos, Real weight, bool software, bool hardware);
void cAn_apply4_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * entity_c, float timePos_c, float weight_c, int software_c, int hardware_c);
// original function: void setInterpolationMode(InterpolationMode im);
void cAn_setInterpolationMode_c(struct hg3dclass_struct *classptr_c, enum EnumInterpolationMode im_c);
// original function: InterpolationMode getInterpolationMode();
void cAn_getInterpolationMode_c(struct hg3dclass_struct *classptr_c, enum EnumInterpolationMode * result_c);
// original function: void setRotationInterpolationMode(RotationInterpolationMode im);
void cAn_setRotationInterpolationMode_c(struct hg3dclass_struct *classptr_c, enum EnumRotationInterpolationMode im_c);
// original function: RotationInterpolationMode getRotationInterpolationMode();
void cAn_getRotationInterpolationMode_c(struct hg3dclass_struct *classptr_c, enum EnumRotationInterpolationMode * result_c);
// original function: void optimise(bool discardIdentityNodeTracks);
void cAn_optimise_c(struct hg3dclass_struct *classptr_c, int discardIdentityNodeTracks_c);
// original function: Animation* clone(const String& newName);
void cAn_clone_c(struct hg3dclass_struct *classptr_c, char * newName_c, struct hg3dclass_struct * result_c);
// original function: void _keyFrameListChanged();
void cAn__keyFrameListChanged_c(struct hg3dclass_struct *classptr_c);
