// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassArchive.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreArchive.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"


// original function: const String& getName();
void cAr_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: bool isCaseSensitive();
void cAr_isCaseSensitive_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void load();
void cAr_load_c(struct hg3dclass_struct *classptr_c);
// original function: void unload();
void cAr_unload_c(struct hg3dclass_struct *classptr_c);
// original function: bool isReadOnly();
void cAr_isReadOnly_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: DataStreamPtr open(const String& filename, bool readOnly);
void cAr_open_c(struct hg3dclass_struct *classptr_c, char * filename_c, int readOnly_c, struct sharedptr_struct * result_c);
// original function: DataStreamPtr create(const String& filename);
void cAr_create_c(struct hg3dclass_struct *classptr_c, char * filename_c, struct sharedptr_struct * result_c);
// original function: void remove(const String& filename);
void cAr_remove_c(struct hg3dclass_struct *classptr_c, char * filename_c);
// original function: StringVectorPtr list(bool recursive, bool dirs);
void cAr_list_c(struct hg3dclass_struct *classptr_c, int recursive_c, int dirs_c, struct sharedptr_struct * result_c);
// original function: FileInfoListPtr listFileInfo(bool recursive, bool dirs);
void cAr_listFileInfo_c(struct hg3dclass_struct *classptr_c, int recursive_c, int dirs_c, struct sharedptr_struct * result_c);
// original function: StringVectorPtr find(const String& pattern, bool recursive, bool dirs);
void cAr_find_c(struct hg3dclass_struct *classptr_c, char * pattern_c, int recursive_c, int dirs_c, struct sharedptr_struct * result_c);
// original function: bool exists(const String& filename);
void cAr_exists_c(struct hg3dclass_struct *classptr_c, char * filename_c, int * result_c);
// original function: FileInfoListPtr findFileInfo(const String& pattern, bool recursive, bool dirs);
void cAr_findFileInfo_c(struct hg3dclass_struct *classptr_c, char * pattern_c, int recursive_c, int dirs_c, struct sharedptr_struct * result_c);
// original function: const String& getType();
void cAr_getType_c(struct hg3dclass_struct *classptr_c, char * result_c);
