// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassBillboard.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreBillboard.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeRadian.h"
#include "TypeVector3.h"
#include "TypeColour.h"


// original function: const Radian& getRotation();
void cBb_getRotation_c(struct hg3dclass_struct *classptr_c, struct radian_struct * result_c);
// original function: void setRotation(const Radian& rotation);
void cBb_setRotation_c(struct hg3dclass_struct *classptr_c, struct radian_struct * rotation_c);
// original function: void setPosition(const Vector3& position);
void cBb_setPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * position_c);
// original function: void setPosition(Real x, Real y, Real z);
void cBb_setPosition2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: const Vector3& getPosition();
void cBb_getPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void setDimensions(Real width, Real height);
void cBb_setDimensions_c(struct hg3dclass_struct *classptr_c, float width_c, float height_c);
// original function: void resetDimensions();
void cBb_resetDimensions_c(struct hg3dclass_struct *classptr_c);
// original function: void setColour(const ColourValue& colour);
void cBb_setColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colour_c);
// original function: const ColourValue& getColour();
void cBb_getColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: bool hasOwnDimensions();
void cBb_hasOwnDimensions_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: Real getOwnWidth();
void cBb_getOwnWidth_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getOwnHeight();
void cBb_getOwnHeight_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void _notifyOwner(BillboardSet* owner);
void cBb__notifyOwner_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * owner_c);
// original function: bool isUseTexcoordRect();
void cBb_isUseTexcoordRect_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setTexcoordIndex(uint16 texcoordIndex);
void cBb_setTexcoordIndex_c(struct hg3dclass_struct *classptr_c, unsigned short texcoordIndex_c);
// original function: uint16 getTexcoordIndex();
void cBb_getTexcoordIndex_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: void setTexcoordRect(Real u0, Real v0, Real u1, Real v1);
void cBb_setTexcoordRect2_c(struct hg3dclass_struct *classptr_c, float u0_c, float v0_c, float u1_c, float v1_c);
