// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassBillboardChain.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreBillboardChain.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumTexCoordDirection.h"


// original function: void setMaxChainElements(size_t maxElements);
void cBc_setMaxChainElements_c(struct hg3dclass_struct *classptr_c, int maxElements_c);
// original function: size_t getMaxChainElements();
void cBc_getMaxChainElements_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setNumberOfChains(size_t numChains);
void cBc_setNumberOfChains_c(struct hg3dclass_struct *classptr_c, int numChains_c);
// original function: size_t getNumberOfChains();
void cBc_getNumberOfChains_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setUseTextureCoords(bool use);
void cBc_setUseTextureCoords_c(struct hg3dclass_struct *classptr_c, int use_c);
// original function: bool getUseTextureCoords();
void cBc_getUseTextureCoords_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setTextureCoordDirection(TexCoordDirection dir);
void cBc_setTextureCoordDirection_c(struct hg3dclass_struct *classptr_c, enum EnumTexCoordDirection dir_c);
// original function: TexCoordDirection getTextureCoordDirection();
void cBc_getTextureCoordDirection_c(struct hg3dclass_struct *classptr_c, enum EnumTexCoordDirection * result_c);
// original function: void setOtherTextureCoordRange(Real start, Real end);
void cBc_setOtherTextureCoordRange_c(struct hg3dclass_struct *classptr_c, float start_c, float end_c);
// original function: void setUseVertexColours(bool use);
void cBc_setUseVertexColours_c(struct hg3dclass_struct *classptr_c, int use_c);
// original function: bool getUseVertexColours();
void cBc_getUseVertexColours_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setDynamic(bool dyn);
void cBc_setDynamic_c(struct hg3dclass_struct *classptr_c, int dyn_c);
// original function: bool getDynamic();
void cBc_getDynamic_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void removeChainElement(size_t chainIndex);
void cBc_removeChainElement_c(struct hg3dclass_struct *classptr_c, int chainIndex_c);
// original function: size_t getNumChainElements(size_t chainIndex);
void cBc_getNumChainElements_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, int * result_c);
// original function: void clearChain(size_t chainIndex);
void cBc_clearChain_c(struct hg3dclass_struct *classptr_c, int chainIndex_c);
// original function: void clearAllChains();
void cBc_clearAllChains_c(struct hg3dclass_struct *classptr_c);
// original function: const String& getMaterialName();
void cBc_getMaterialName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setMaterialName(const String& name, const String& groupName);
void cBc_setMaterialName_c(struct hg3dclass_struct *classptr_c, char * name_c, char * groupName_c);
// original function: void _notifyCurrentCamera(Camera* cam);
void cBc__notifyCurrentCamera_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cam_c);
