// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassBillboardSet.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreBillboardSet.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeVector3.h"
#include "TypeColour.h"
#include "EnumBillboardOrigin.h"
#include "EnumBillboardRotationType.h"
#include "TypeSharedPtr.h"
#include "EnumBillboardType.h"
#include "EnumSortMode.h"


// original function: Billboard* createBillboard(const Vector3& position, const ColourValue& colour);
void cBs_createBillboard_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * position_c, struct colourvalue_struct * colour_c, struct hg3dclass_struct * result_c);
// original function: Billboard* createBillboard(Real x, Real y, Real z, const ColourValue& colour);
void cBs_createBillboard2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c, struct colourvalue_struct * colour_c, struct hg3dclass_struct * result_c);
// original function: int getNumBillboards();
void cBs_getNumBillboards_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setAutoextend(bool autoextend);
void cBs_setAutoextend_c(struct hg3dclass_struct *classptr_c, int autoextend_c);
// original function: bool getAutoextend();
void cBs_getAutoextend_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setSortingEnabled(bool sortenable);
void cBs_setSortingEnabled_c(struct hg3dclass_struct *classptr_c, int sortenable_c);
// original function: bool getSortingEnabled();
void cBs_getSortingEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setPoolSize(size_t size);
void cBs_setPoolSize_c(struct hg3dclass_struct *classptr_c, int size_c);
// original function: unsigned int getPoolSize();
void cBs_getPoolSize_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void clear();
void cBs_clear_c(struct hg3dclass_struct *classptr_c);
// original function: Billboard* getBillboard(unsigned int index);
void cBs_getBillboard_c(struct hg3dclass_struct *classptr_c, unsigned int index_c, struct hg3dclass_struct * result_c);
// original function: void removeBillboard(unsigned int index);
void cBs_removeBillboard_c(struct hg3dclass_struct *classptr_c, unsigned int index_c);
// original function: void removeBillboard(Billboard* pBill);
void cBs_removeBillboard2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * pBill_c);
// original function: void setBillboardOrigin(BillboardOrigin origin);
void cBs_setBillboardOrigin_c(struct hg3dclass_struct *classptr_c, enum EnumBillboardOrigin origin_c);
// original function: BillboardOrigin getBillboardOrigin();
void cBs_getBillboardOrigin_c(struct hg3dclass_struct *classptr_c, enum EnumBillboardOrigin * result_c);
// original function: void setBillboardRotationType(BillboardRotationType rotationType);
void cBs_setBillboardRotationType_c(struct hg3dclass_struct *classptr_c, enum EnumBillboardRotationType rotationType_c);
// original function: BillboardRotationType getBillboardRotationType();
void cBs_getBillboardRotationType_c(struct hg3dclass_struct *classptr_c, enum EnumBillboardRotationType * result_c);
// original function: void setDefaultDimensions(Real width, Real height);
void cBs_setDefaultDimensions_c(struct hg3dclass_struct *classptr_c, float width_c, float height_c);
// original function: void setDefaultWidth(Real width);
void cBs_setDefaultWidth_c(struct hg3dclass_struct *classptr_c, float width_c);
// original function: Real getDefaultWidth();
void cBs_getDefaultWidth_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setDefaultHeight(Real height);
void cBs_setDefaultHeight_c(struct hg3dclass_struct *classptr_c, float height_c);
// original function: Real getDefaultHeight();
void cBs_getDefaultHeight_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setMaterialName(const String& name, const String& groupName);
void cBs_setMaterialName_c(struct hg3dclass_struct *classptr_c, char * name_c, char * groupName_c);
// original function: const String& getMaterialName();
void cBs_getMaterialName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void _notifyCurrentCamera(Camera* cam);
void cBs__notifyCurrentCamera_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cam_c);
// original function: void beginBillboards(size_t numBillboards);
void cBs_beginBillboards_c(struct hg3dclass_struct *classptr_c, int numBillboards_c);
// original function: void endBillboards();
void cBs_endBillboards_c(struct hg3dclass_struct *classptr_c);
// original function: Real getBoundingRadius();
void cBs_getBoundingRadius_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: const MaterialPtr& getMaterial();
void cBs_getMaterial_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: void setMaterial(const MaterialPtr& material);
void cBs_setMaterial_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * material_c);
// original function: void _notifyBillboardResized();
void cBs__notifyBillboardResized_c(struct hg3dclass_struct *classptr_c);
// original function: void _notifyBillboardRotated();
void cBs__notifyBillboardRotated_c(struct hg3dclass_struct *classptr_c);
// original function: bool getCullIndividually();
void cBs_getCullIndividually_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setCullIndividually(bool cullIndividual);
void cBs_setCullIndividually_c(struct hg3dclass_struct *classptr_c, int cullIndividual_c);
// original function: void setBillboardType(BillboardType bbt);
void cBs_setBillboardType_c(struct hg3dclass_struct *classptr_c, enum EnumBillboardType bbt_c);
// original function: BillboardType getBillboardType();
void cBs_getBillboardType_c(struct hg3dclass_struct *classptr_c, enum EnumBillboardType * result_c);
// original function: void setCommonDirection(const Vector3& vec);
void cBs_setCommonDirection_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * vec_c);
// original function: const Vector3& getCommonDirection();
void cBs_getCommonDirection_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void setCommonUpVector(const Vector3& vec);
void cBs_setCommonUpVector_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * vec_c);
// original function: const Vector3& getCommonUpVector();
void cBs_getCommonUpVector_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void setUseAccurateFacing(bool acc);
void cBs_setUseAccurateFacing_c(struct hg3dclass_struct *classptr_c, int acc_c);
// original function: bool getUseAccurateFacing();
void cBs_getUseAccurateFacing_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: const String& getMovableType();
void cBs_getMovableType_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void _updateBounds();
void cBs__updateBounds_c(struct hg3dclass_struct *classptr_c);
// original function: void _sortBillboards(Camera* cam);
void cBs__sortBillboards_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cam_c);
// original function: SortMode _getSortMode();
void cBs__getSortMode_c(struct hg3dclass_struct *classptr_c, enum EnumSortMode * result_c);
// original function: void setBillboardsInWorldSpace(bool ws);
void cBs_setBillboardsInWorldSpace_c(struct hg3dclass_struct *classptr_c, int ws_c);
// original function: void setPointRenderingEnabled(bool enabled);
void cBs_setPointRenderingEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool isPointRenderingEnabled();
void cBs_isPointRenderingEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: uint32 getTypeFlags();
void cBs_getTypeFlags_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setAutoUpdate(bool autoUpdate);
void cBs_setAutoUpdate_c(struct hg3dclass_struct *classptr_c, int autoUpdate_c);
// original function: bool getAutoUpdate();
void cBs_getAutoUpdate_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void notifyBillboardDataChanged();
void cBs_notifyBillboardDataChanged_c(struct hg3dclass_struct *classptr_c);
