// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassCamera.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreCamera.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumPolygonMode.h"
#include "TypeVector3.h"
#include "TypeRadian.h"
#include "TypeQuaternion.h"
#include "EnumFrustumPlane.h"


// original function: SceneManager* getSceneManager();
void cC_getSceneManager_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setPolygonMode(PolygonMode sd);
void cC_setPolygonMode_c(struct hg3dclass_struct *classptr_c, enum EnumPolygonMode sd_c);
// original function: PolygonMode getPolygonMode();
void cC_getPolygonMode_c(struct hg3dclass_struct *classptr_c, enum EnumPolygonMode * result_c);
// original function: void setPosition(Real x, Real y, Real z);
void cC_setPosition_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: void setPosition(const Vector3& vec);
void cC_setPosition2_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * vec_c);
// original function: const Vector3& getPosition();
void cC_getPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void move(const Vector3& vec);
void cC_move_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * vec_c);
// original function: void moveRelative(const Vector3& vec);
void cC_moveRelative_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * vec_c);
// original function: void setDirection(Real x, Real y, Real z);
void cC_setDirection_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: void setDirection(const Vector3& vec);
void cC_setDirection2_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * vec_c);
// original function: Vector3 getUp();
void cC_getUp_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: Vector3 getRight();
void cC_getRight_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void lookAt(const Vector3& targetPoint);
void cC_lookAt_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * targetPoint_c);
// original function: void lookAt(Real x, Real y, Real z);
void cC_lookAt2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: void roll(const Radian& angle);
void cC_roll_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c);
// original function: void yaw(const Radian& angle);
void cC_yaw_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c);
// original function: void pitch(const Radian& angle);
void cC_pitch_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c);
// original function: void rotate(const Vector3& axis, const Radian& angle);
void cC_rotate_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * axis_c, struct radian_struct * angle_c);
// original function: void rotate(const Quaternion& q);
void cC_rotate2_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * q_c);
// original function: void setFixedYawAxis(bool useFixed, const Vector3& fixedAxis);
void cC_setFixedYawAxis_c(struct hg3dclass_struct *classptr_c, int useFixed_c, struct vector3_struct * fixedAxis_c);
// original function: const Quaternion& getOrientation();
void cC_getOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * result_c);
// original function: void setOrientation(const Quaternion& q);
void cC_setOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * q_c);
// original function: void _renderScene(Viewport * vp, bool includeOverlays);
void cC__renderScene_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * vp_c, int includeOverlays_c);
// original function: void _notifyRenderedFaces(unsigned int numfaces);
void cC__notifyRenderedFaces_c(struct hg3dclass_struct *classptr_c, unsigned int numfaces_c);
// original function: void _notifyRenderedBatches(unsigned int numbatches);
void cC__notifyRenderedBatches_c(struct hg3dclass_struct *classptr_c, unsigned int numbatches_c);
// original function: unsigned int _getNumRenderedFaces();
void cC__getNumRenderedFaces_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: unsigned int _getNumRenderedBatches();
void cC__getNumRenderedBatches_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: const Quaternion& getDerivedOrientation();
void cC_getDerivedOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * result_c);
// original function: const Vector3& getDerivedPosition();
void cC_getDerivedPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: Vector3 getDerivedDirection();
void cC_getDerivedDirection_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: Vector3 getDerivedUp();
void cC_getDerivedUp_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: Vector3 getDerivedRight();
void cC_getDerivedRight_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: const Quaternion& getRealOrientation();
void cC_getRealOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * result_c);
// original function: const Vector3& getRealPosition();
void cC_getRealPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: Vector3 getRealDirection();
void cC_getRealDirection_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: Vector3 getRealUp();
void cC_getRealUp_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: Vector3 getRealRight();
void cC_getRealRight_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: const String& getMovableType();
void cC_getMovableType_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setAutoTracking(bool enabled, SceneNode* target, const Vector3& offset);
void cC_setAutoTracking_c(struct hg3dclass_struct *classptr_c, int enabled_c, struct hg3dclass_struct * target_c, struct vector3_struct * offset_c);
// original function: void setLodBias(Real factor);
void cC_setLodBias_c(struct hg3dclass_struct *classptr_c, float factor_c);
// original function: Real getLodBias();
void cC_getLodBias_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real _getLodBiasInverse();
void cC__getLodBiasInverse_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void _autoTrack();
void cC__autoTrack_c(struct hg3dclass_struct *classptr_c);
// original function: bool isWindowSet();
void cC_isWindowSet_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: Real getBoundingRadius();
void cC_getBoundingRadius_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: SceneNode* getAutoTrackTarget();
void cC_getAutoTrackTarget_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: const Vector3& getAutoTrackOffset();
void cC_getAutoTrackOffset_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: Viewport* getViewport();
void cC_getViewport_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void _notifyViewport(Viewport* viewport);
void cC__notifyViewport_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * viewport_c);
// original function: void setAutoAspectRatio(bool autoratio);
void cC_setAutoAspectRatio_c(struct hg3dclass_struct *classptr_c, int autoratio_c);
// original function: bool getAutoAspectRatio();
void cC_getAutoAspectRatio_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setCullingFrustum(Frustum* frustum);
void cC_setCullingFrustum_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * frustum_c);
// original function: Frustum* getCullingFrustum();
void cC_getCullingFrustum_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: bool isVisible(const Vector3& vert, FrustumPlane* culledBy);
void cC_isVisible3_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * vert_c, enum EnumFrustumPlane * culledBy_c, int * result_c);
// original function: Real getNearClipDistance();
void cC_getNearClipDistance_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getFarClipDistance();
void cC_getFarClipDistance_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setUseRenderingDistance(bool use);
void cC_setUseRenderingDistance_c(struct hg3dclass_struct *classptr_c, int use_c);
// original function: bool getUseRenderingDistance();
void cC_getUseRenderingDistance_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: const Vector3& getPositionForViewUpdate();
void cC_getPositionForViewUpdate_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: const Quaternion& getOrientationForViewUpdate();
void cC_getOrientationForViewUpdate_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * result_c);
