// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassCompositionPass.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreCompositionPass.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumPassType.h"
#include "TypeSharedPtr.h"
#include "TypeColour.h"
#include "EnumCompareFunction.h"
#include "EnumStencilOperation.h"


// original function: void setType(PassType type);
void cCop_setType_c(struct hg3dclass_struct *classptr_c, enum EnumPassType type_c);
// original function: PassType getType();
void cCop_getType_c(struct hg3dclass_struct *classptr_c, enum EnumPassType * result_c);
// original function: void setIdentifier(uint32 id);
void cCop_setIdentifier_c(struct hg3dclass_struct *classptr_c, unsigned int id_c);
// original function: uint32 getIdentifier();
void cCop_getIdentifier_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setMaterial(const MaterialPtr& mat);
void cCop_setMaterial_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * mat_c);
// original function: void setMaterialName(const String & name);
void cCop_setMaterialName_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: const MaterialPtr& getMaterial();
void cCop_getMaterial_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: void setMaterialScheme(const String& schemeName);
void cCop_setMaterialScheme_c(struct hg3dclass_struct *classptr_c, char * schemeName_c);
// original function: const String& getMaterialScheme();
void cCop_getMaterialScheme_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setClearBuffers(uint32 val);
void cCop_setClearBuffers_c(struct hg3dclass_struct *classptr_c, unsigned int val_c);
// original function: uint32 getClearBuffers();
void cCop_getClearBuffers_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setClearColour(ColourValue val);
void cCop_setClearColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * val_c);
// original function: const ColourValue & getClearColour();
void cCop_getClearColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: void setClearDepth(Real depth);
void cCop_setClearDepth_c(struct hg3dclass_struct *classptr_c, float depth_c);
// original function: Real getClearDepth();
void cCop_getClearDepth_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setClearStencil(uint32 value);
void cCop_setClearStencil_c(struct hg3dclass_struct *classptr_c, unsigned int value_c);
// original function: uint32 getClearStencil();
void cCop_getClearStencil_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setStencilCheck(bool value);
void cCop_setStencilCheck_c(struct hg3dclass_struct *classptr_c, int value_c);
// original function: bool getStencilCheck();
void cCop_getStencilCheck_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setStencilFunc(CompareFunction value);
void cCop_setStencilFunc_c(struct hg3dclass_struct *classptr_c, enum EnumCompareFunction value_c);
// original function: CompareFunction getStencilFunc();
void cCop_getStencilFunc_c(struct hg3dclass_struct *classptr_c, enum EnumCompareFunction * result_c);
// original function: void setStencilRefValue(uint32 value);
void cCop_setStencilRefValue_c(struct hg3dclass_struct *classptr_c, unsigned int value_c);
// original function: uint32 getStencilRefValue();
void cCop_getStencilRefValue_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setStencilMask(uint32 value);
void cCop_setStencilMask_c(struct hg3dclass_struct *classptr_c, unsigned int value_c);
// original function: uint32 getStencilMask();
void cCop_getStencilMask_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setStencilFailOp(StencilOperation value);
void cCop_setStencilFailOp_c(struct hg3dclass_struct *classptr_c, enum EnumStencilOperation value_c);
// original function: StencilOperation getStencilFailOp();
void cCop_getStencilFailOp_c(struct hg3dclass_struct *classptr_c, enum EnumStencilOperation * result_c);
// original function: void setStencilDepthFailOp(StencilOperation value);
void cCop_setStencilDepthFailOp_c(struct hg3dclass_struct *classptr_c, enum EnumStencilOperation value_c);
// original function: StencilOperation getStencilDepthFailOp();
void cCop_getStencilDepthFailOp_c(struct hg3dclass_struct *classptr_c, enum EnumStencilOperation * result_c);
// original function: void setStencilPassOp(StencilOperation value);
void cCop_setStencilPassOp_c(struct hg3dclass_struct *classptr_c, enum EnumStencilOperation value_c);
// original function: StencilOperation getStencilPassOp();
void cCop_getStencilPassOp_c(struct hg3dclass_struct *classptr_c, enum EnumStencilOperation * result_c);
// original function: void setStencilTwoSidedOperation(bool value);
void cCop_setStencilTwoSidedOperation_c(struct hg3dclass_struct *classptr_c, int value_c);
// original function: bool getStencilTwoSidedOperation();
void cCop_getStencilTwoSidedOperation_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setInput(size_t id, const String & input, size_t mrtIndex);
void cCop_setInput_c(struct hg3dclass_struct *classptr_c, int id_c, char * input_c, int mrtIndex_c);
// original function: size_t getNumInputs();
void cCop_getNumInputs_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void clearAllInputs();
void cCop_clearAllInputs_c(struct hg3dclass_struct *classptr_c);
// original function: CompositionTargetPass * getParent();
void cCop_getParent_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: bool _isSupported();
void cCop__isSupported_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setQuadCorners(Real left, Real top, Real right, Real bottom);
void cCop_setQuadCorners_c(struct hg3dclass_struct *classptr_c, float left_c, float top_c, float right_c, float bottom_c);
// original function: void setQuadFarCorners(bool farCorners, bool farCornersViewSpace);
void cCop_setQuadFarCorners_c(struct hg3dclass_struct *classptr_c, int farCorners_c, int farCornersViewSpace_c);
// original function: bool getQuadFarCorners();
void cCop_getQuadFarCorners_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool getQuadFarCornersViewSpace();
void cCop_getQuadFarCornersViewSpace_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setCustomType(const String& customType);
void cCop_setCustomType_c(struct hg3dclass_struct *classptr_c, char * customType_c);
// original function: const String& getCustomType();
void cCop_getCustomType_c(struct hg3dclass_struct *classptr_c, char * result_c);
