// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassCompositionTargetPass.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreCompositionTargetPass.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumInputMode.h"


// original function: void setInputMode(InputMode mode);
void cCotp_setInputMode_c(struct hg3dclass_struct *classptr_c, enum EnumInputMode mode_c);
// original function: InputMode getInputMode();
void cCotp_getInputMode_c(struct hg3dclass_struct *classptr_c, enum EnumInputMode * result_c);
// original function: void setOutputName(const String & out);
void cCotp_setOutputName_c(struct hg3dclass_struct *classptr_c, char * out_c);
// original function: const String & getOutputName();
void cCotp_getOutputName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setOnlyInitial(bool value);
void cCotp_setOnlyInitial_c(struct hg3dclass_struct *classptr_c, int value_c);
// original function: bool getOnlyInitial();
void cCotp_getOnlyInitial_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setVisibilityMask(uint32 mask);
void cCotp_setVisibilityMask_c(struct hg3dclass_struct *classptr_c, unsigned int mask_c);
// original function: uint32 getVisibilityMask();
void cCotp_getVisibilityMask_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setMaterialScheme(const String& schemeName);
void cCotp_setMaterialScheme_c(struct hg3dclass_struct *classptr_c, char * schemeName_c);
// original function: const String& getMaterialScheme();
void cCotp_getMaterialScheme_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setShadowsEnabled(bool enabled);
void cCotp_setShadowsEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getShadowsEnabled();
void cCotp_getShadowsEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setLodBias(float bias);
void cCotp_setLodBias_c(struct hg3dclass_struct *classptr_c, float bias_c);
// original function: float getLodBias();
void cCotp_getLodBias_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: CompositionPass * createPass();
void cCotp_createPass_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void removePass(size_t idx);
void cCotp_removePass_c(struct hg3dclass_struct *classptr_c, int idx_c);
// original function: CompositionPass * getPass(size_t idx);
void cCotp_getPass_c(struct hg3dclass_struct *classptr_c, int idx_c, struct hg3dclass_struct * result_c);
// original function: size_t getNumPasses();
void cCotp_getNumPasses_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void removeAllPasses();
void cCotp_removeAllPasses_c(struct hg3dclass_struct *classptr_c);
// original function: CompositionTechnique * getParent();
void cCotp_getParent_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: bool _isSupported();
void cCotp__isSupported_c(struct hg3dclass_struct *classptr_c, int * result_c);
