// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassCompositor.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreCompositor.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"


// original function: CompositionTechnique * createTechnique();
void cCo_createTechnique_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void removeTechnique(size_t idx);
void cCo_removeTechnique_c(struct hg3dclass_struct *classptr_c, int idx_c);
// original function: CompositionTechnique * getTechnique(size_t idx);
void cCo_getTechnique_c(struct hg3dclass_struct *classptr_c, int idx_c, struct hg3dclass_struct * result_c);
// original function: size_t getNumTechniques();
void cCo_getNumTechniques_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void removeAllTechniques();
void cCo_removeAllTechniques_c(struct hg3dclass_struct *classptr_c);
// original function: CompositionTechnique * getSupportedTechnique(size_t idx);
void cCo_getSupportedTechnique_c(struct hg3dclass_struct *classptr_c, int idx_c, struct hg3dclass_struct * result_c);
// original function: size_t getNumSupportedTechniques();
void cCo_getNumSupportedTechniques_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: CompositionTechnique * getSupportedTechnique(const String& schemeName);
void cCo_getSupportedTechnique2_c(struct hg3dclass_struct *classptr_c, char * schemeName_c, struct hg3dclass_struct * result_c);
// original function: const String& getTextureInstanceName(const String& name, size_t mrtIndex);
void cCo_getTextureInstanceName_c(struct hg3dclass_struct *classptr_c, char * name_c, int mrtIndex_c, char * result_c);
// original function: TexturePtr getTextureInstance(const String& name, size_t mrtIndex);
void cCo_getTextureInstance_c(struct hg3dclass_struct *classptr_c, char * name_c, int mrtIndex_c, struct sharedptr_struct * result_c);
