// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassCompositorChain.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreCompositorChain.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"


// original function: CompositorInstance* addCompositor(CompositorPtr filter, size_t addPosition, const String& scheme);
void cCoc_addCompositor_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * filter_c, int addPosition_c, char * scheme_c, struct hg3dclass_struct * result_c);
// original function: void removeCompositor(size_t position);
void cCoc_removeCompositor_c(struct hg3dclass_struct *classptr_c, int position_c);
// original function: size_t getNumCompositors();
void cCoc_getNumCompositors_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void removeAllCompositors();
void cCoc_removeAllCompositors_c(struct hg3dclass_struct *classptr_c);
// original function: CompositorInstance * getCompositor(size_t index);
void cCoc_getCompositor_c(struct hg3dclass_struct *classptr_c, int index_c, struct hg3dclass_struct * result_c);
// original function: CompositorInstance * getCompositor(const String& name);
void cCoc_getCompositor2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: CompositorInstance* _getOriginalSceneCompositor();
void cCoc__getOriginalSceneCompositor_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setCompositorEnabled(size_t position, bool state);
void cCoc_setCompositorEnabled_c(struct hg3dclass_struct *classptr_c, int position_c, int state_c);
// original function: void _markDirty();
void cCoc__markDirty_c(struct hg3dclass_struct *classptr_c);
// original function: Viewport * getViewport();
void cCoc_getViewport_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void _notifyViewport(Viewport* vp);
void cCoc__notifyViewport_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * vp_c);
// original function: void _removeInstance(CompositorInstance * i);
void cCoc__removeInstance_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * i_c);
// original function: void _compile();
void cCoc__compile_c(struct hg3dclass_struct *classptr_c);
// original function: CompositorInstance* getPreviousInstance(CompositorInstance* curr, bool activeOnly);
void cCoc_getPreviousInstance_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * curr_c, int activeOnly_c, struct hg3dclass_struct * result_c);
