// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassCompositorInstance.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreCompositorInstance.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"


// original function: void setEnabled(bool value);
void cCoi_setEnabled_c(struct hg3dclass_struct *classptr_c, int value_c);
// original function: bool getEnabled();
void cCoi_getEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: const String& getTextureInstanceName(const String& name, size_t mrtIndex);
void cCoi_getTextureInstanceName_c(struct hg3dclass_struct *classptr_c, char * name_c, int mrtIndex_c, char * result_c);
// original function: TexturePtr getTextureInstance(const String& name, size_t mrtIndex);
void cCoi_getTextureInstance_c(struct hg3dclass_struct *classptr_c, char * name_c, int mrtIndex_c, struct sharedptr_struct * result_c);
// original function: RenderTarget* getRenderTarget(const String& name);
void cCoi_getRenderTarget_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: Compositor * getCompositor();
void cCoi_getCompositor_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: CompositionTechnique * getTechnique();
void cCoi_getTechnique_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setTechnique(CompositionTechnique* tech, bool reuseTextures);
void cCoi_setTechnique_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * tech_c, int reuseTextures_c);
// original function: void setScheme(const String& schemeName, bool reuseTextures);
void cCoi_setScheme_c(struct hg3dclass_struct *classptr_c, char * schemeName_c, int reuseTextures_c);
// original function: const String& getScheme();
void cCoi_getScheme_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void notifyResized();
void cCoi_notifyResized_c(struct hg3dclass_struct *classptr_c);
// original function: CompositorChain * getChain();
void cCoi_getChain_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void _fireNotifyMaterialSetup(uint32 pass_id, MaterialPtr & mat);
void cCoi__fireNotifyMaterialSetup_c(struct hg3dclass_struct *classptr_c, unsigned int pass_id_c, struct sharedptr_struct * mat_c);
// original function: void _fireNotifyMaterialRender(uint32 pass_id, MaterialPtr & mat);
void cCoi__fireNotifyMaterialRender_c(struct hg3dclass_struct *classptr_c, unsigned int pass_id_c, struct sharedptr_struct * mat_c);
// original function: void _fireNotifyResourcesCreated(bool forResizeOnly);
void cCoi__fireNotifyResourcesCreated_c(struct hg3dclass_struct *classptr_c, int forResizeOnly_c);
