// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassCompositorManager.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreCompositorManager.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"


// original function: void initialise();
void cCom_initialise_c(struct hg3dclass_struct *classptr_c);
// original function: void parseScript(DataStreamPtr& stream, const String& groupName);
void cCom_parseScript_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * stream_c, char * groupName_c);
// original function: CompositorChain * getCompositorChain(Viewport * vp);
void cCom_getCompositorChain_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * vp_c, struct hg3dclass_struct * result_c);
// original function: bool hasCompositorChain(Viewport * vp);
void cCom_hasCompositorChain_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * vp_c, int * result_c);
// original function: void removeCompositorChain(Viewport * vp);
void cCom_removeCompositorChain_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * vp_c);
// original function: CompositorInstance * addCompositor(Viewport * vp, const String & compositor, int addPosition);
void cCom_addCompositor_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * vp_c, char * compositor_c, int addPosition_c, struct hg3dclass_struct * result_c);
// original function: void removeCompositor(Viewport * vp, const String & compositor);
void cCom_removeCompositor_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * vp_c, char * compositor_c);
// original function: void setCompositorEnabled(Viewport * vp, const String & compositor, bool value);
void cCom_setCompositorEnabled_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * vp_c, char * compositor_c, int value_c);
// original function: void removeAll();
void cCom_removeAll_c(struct hg3dclass_struct *classptr_c);
// original function: void _reconstructAllCompositorResources();
void cCom__reconstructAllCompositorResources_c(struct hg3dclass_struct *classptr_c);
// original function: void freePooledTextures(bool onlyIfUnreferenced);
void cCom_freePooledTextures_c(struct hg3dclass_struct *classptr_c, int onlyIfUnreferenced_c);
// original function: void _relocateChain(Viewport* sourceVP, Viewport* destVP);
void cCom__relocateChain_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * sourceVP_c, struct hg3dclass_struct * destVP_c);
