// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassConfigFile.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreConfigFile.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"


// original function: void load(const String& filename, const String& separators, bool trimWhitespace);
void cCf_load_c(struct hg3dclass_struct *classptr_c, char * filename_c, char * separators_c, int trimWhitespace_c);
// original function: void load(const String& filename, const String& resourceGroup, const String& separators, bool trimWhitespace);
void cCf_load2_c(struct hg3dclass_struct *classptr_c, char * filename_c, char * resourceGroup_c, char * separators_c, int trimWhitespace_c);
// original function: void load(const DataStreamPtr& stream, const String& separators, bool trimWhitespace);
void cCf_load3_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * stream_c, char * separators_c, int trimWhitespace_c);
// original function: void loadDirect(const String& filename, const String& separators, bool trimWhitespace);
void cCf_loadDirect_c(struct hg3dclass_struct *classptr_c, char * filename_c, char * separators_c, int trimWhitespace_c);
// original function: void loadFromResourceSystem(const String& filename, const String& resourceGroup, const String& separators, bool trimWhitespace);
void cCf_loadFromResourceSystem_c(struct hg3dclass_struct *classptr_c, char * filename_c, char * resourceGroup_c, char * separators_c, int trimWhitespace_c);
// original function: String getSetting(const String& key, const String& section, const String& defaultValue);
void cCf_getSetting_c(struct hg3dclass_struct *classptr_c, char * key_c, char * section_c, char * defaultValue_c, char * result_c);
