// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassGpuProgram.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreGpuProgram.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumGpuProgramType.h"


// original function: void setSourceFile(const String& filename);
void cGp_setSourceFile_c(struct hg3dclass_struct *classptr_c, char * filename_c);
// original function: void setSource(const String& source);
void cGp_setSource_c(struct hg3dclass_struct *classptr_c, char * source_c);
// original function: const String& getSyntaxCode();
void cGp_getSyntaxCode_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setSyntaxCode(const String& syntax);
void cGp_setSyntaxCode_c(struct hg3dclass_struct *classptr_c, char * syntax_c);
// original function: const String& getSourceFile();
void cGp_getSourceFile_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const String& getSource();
void cGp_getSource_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setType(GpuProgramType t);
void cGp_setType_c(struct hg3dclass_struct *classptr_c, enum EnumGpuProgramType t_c);
// original function: GpuProgramType getType();
void cGp_getType_c(struct hg3dclass_struct *classptr_c, enum EnumGpuProgramType * result_c);
// original function: GpuProgram* _getBindingDelegate();
void cGp__getBindingDelegate_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: bool isSupported();
void cGp_isSupported_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setSkeletalAnimationIncluded(bool included);
void cGp_setSkeletalAnimationIncluded_c(struct hg3dclass_struct *classptr_c, int included_c);
// original function: bool isSkeletalAnimationIncluded();
void cGp_isSkeletalAnimationIncluded_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setMorphAnimationIncluded(bool included);
void cGp_setMorphAnimationIncluded_c(struct hg3dclass_struct *classptr_c, int included_c);
// original function: bool isMorphAnimationIncluded();
void cGp_isMorphAnimationIncluded_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isPoseAnimationIncluded();
void cGp_isPoseAnimationIncluded_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setVertexTextureFetchRequired(bool r);
void cGp_setVertexTextureFetchRequired_c(struct hg3dclass_struct *classptr_c, int r_c);
// original function: bool isVertexTextureFetchRequired();
void cGp_isVertexTextureFetchRequired_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setAdjacencyInfoRequired(bool r);
void cGp_setAdjacencyInfoRequired_c(struct hg3dclass_struct *classptr_c, int r_c);
// original function: bool isAdjacencyInfoRequired();
void cGp_isAdjacencyInfoRequired_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasDefaultParameters();
void cGp_hasDefaultParameters_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool getPassSurfaceAndLightStates();
void cGp_getPassSurfaceAndLightStates_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool getPassFogStates();
void cGp_getPassFogStates_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool getPassTransformStates();
void cGp_getPassTransformStates_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: const String& getLanguage();
void cGp_getLanguage_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: bool hasCompileError();
void cGp_hasCompileError_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void resetCompileError();
void cGp_resetCompileError_c(struct hg3dclass_struct *classptr_c);
// original function: void setManualNamedConstantsFile(const String& paramDefFile);
void cGp_setManualNamedConstantsFile_c(struct hg3dclass_struct *classptr_c, char * paramDefFile_c);
// original function: const String& getManualNamedConstantsFile();
void cGp_getManualNamedConstantsFile_c(struct hg3dclass_struct *classptr_c, char * result_c);
