// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassLogManager.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreLogManager.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumLogMessageLevel.h"
#include "EnumLoggingLevel.h"


// original function: void destroyLog(const String& name);
void cLm_destroyLog_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void logMessage(const String& message, LogMessageLevel lml, bool maskDebug);
void cLm_logMessage_c(struct hg3dclass_struct *classptr_c, char * message_c, enum EnumLogMessageLevel lml_c, int maskDebug_c);
// original function: void logMessage(LogMessageLevel lml, const String& message, bool maskDebug);
void cLm_logMessage2_c(struct hg3dclass_struct *classptr_c, enum EnumLogMessageLevel lml_c, char * message_c, int maskDebug_c);
// original function: void setLogDetail(LoggingLevel ll);
void cLm_setLogDetail_c(struct hg3dclass_struct *classptr_c, enum EnumLoggingLevel ll_c);
