// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassManualObject.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreManualObject.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumOperationType.h"
#include "TypeVector3.h"
#include "TypeVector2.h"
#include "TypeVector4.h"
#include "TypeColour.h"
#include "TypeSharedPtr.h"


// original function: void clear();
void cMno_clear_c(struct hg3dclass_struct *classptr_c);
// original function: void estimateVertexCount(size_t vcount);
void cMno_estimateVertexCount_c(struct hg3dclass_struct *classptr_c, int vcount_c);
// original function: void estimateIndexCount(size_t icount);
void cMno_estimateIndexCount_c(struct hg3dclass_struct *classptr_c, int icount_c);
// original function: void begin(const String& materialName, RenderOperation::OperationType opType, const String & groupName);
void cMno_begin_c(struct hg3dclass_struct *classptr_c, char * materialName_c, enum EnumOperationType opType_c, char * groupName_c);
// original function: void setDynamic(bool dyn);
void cMno_setDynamic_c(struct hg3dclass_struct *classptr_c, int dyn_c);
// original function: bool getDynamic();
void cMno_getDynamic_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void beginUpdate(size_t sectionIndex);
void cMno_beginUpdate_c(struct hg3dclass_struct *classptr_c, int sectionIndex_c);
// original function: void position(const Vector3& pos);
void cMno_position_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * pos_c);
// original function: void position(Real x, Real y, Real z);
void cMno_position2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: void normal(const Vector3& norm);
void cMno_normal_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * norm_c);
// original function: void normal(Real x, Real y, Real z);
void cMno_normal2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: void tangent(const Vector3& tan);
void cMno_tangent_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * tan_c);
// original function: void tangent(Real x, Real y, Real z);
void cMno_tangent2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: void textureCoord(Real u);
void cMno_textureCoord_c(struct hg3dclass_struct *classptr_c, float u_c);
// original function: void textureCoord(Real u, Real v);
void cMno_textureCoord2_c(struct hg3dclass_struct *classptr_c, float u_c, float v_c);
// original function: void textureCoord(Real u, Real v, Real w);
void cMno_textureCoord3_c(struct hg3dclass_struct *classptr_c, float u_c, float v_c, float w_c);
// original function: void textureCoord(Real x, Real y, Real z, Real w);
void cMno_textureCoord4_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c, float w_c);
// original function: void textureCoord(const Vector2& uv);
void cMno_textureCoord5_c(struct hg3dclass_struct *classptr_c, struct vector2_struct * uv_c);
// original function: void textureCoord(const Vector3& uvw);
void cMno_textureCoord6_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * uvw_c);
// original function: void textureCoord(const Vector4& xyzw);
void cMno_textureCoord7_c(struct hg3dclass_struct *classptr_c, struct vector4_struct * xyzw_c);
// original function: void colour(const ColourValue& col);
void cMno_colour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * col_c);
// original function: void colour(Real r, Real g, Real b, Real a);
void cMno_colour2_c(struct hg3dclass_struct *classptr_c, float r_c, float g_c, float b_c, float a_c);
// original function: void index(uint32 idx);
void cMno_index_c(struct hg3dclass_struct *classptr_c, unsigned int idx_c);
// original function: void triangle(uint32 i1, uint32 i2, uint32 i3);
void cMno_triangle_c(struct hg3dclass_struct *classptr_c, unsigned int i1_c, unsigned int i2_c, unsigned int i3_c);
// original function: void quad(uint32 i1, uint32 i2, uint32 i3, uint32 i4);
void cMno_quad_c(struct hg3dclass_struct *classptr_c, unsigned int i1_c, unsigned int i2_c, unsigned int i3_c, unsigned int i4_c);
// original function: ManualObjectSection* end();
void cMno_end_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setMaterialName(size_t subindex, const String& name, const String & group);
void cMno_setMaterialName_c(struct hg3dclass_struct *classptr_c, int subindex_c, char * name_c, char * group_c);
// original function: MeshPtr convertToMesh(const String& meshName, const String& groupName);
void cMno_convertToMesh_c(struct hg3dclass_struct *classptr_c, char * meshName_c, char * groupName_c, struct sharedptr_struct * result_c);
// original function: void setUseIdentityProjection(bool useIdentityProjection);
void cMno_setUseIdentityProjection_c(struct hg3dclass_struct *classptr_c, int useIdentityProjection_c);
// original function: bool getUseIdentityProjection();
void cMno_getUseIdentityProjection_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setUseIdentityView(bool useIdentityView);
void cMno_setUseIdentityView_c(struct hg3dclass_struct *classptr_c, int useIdentityView_c);
// original function: bool getUseIdentityView();
void cMno_getUseIdentityView_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: ManualObjectSection* getSection(unsigned int index);
void cMno_getSection_c(struct hg3dclass_struct *classptr_c, unsigned int index_c, struct hg3dclass_struct * result_c);
// original function: unsigned int getNumSections();
void cMno_getNumSections_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setKeepDeclarationOrder(bool keepOrder);
void cMno_setKeepDeclarationOrder_c(struct hg3dclass_struct *classptr_c, int keepOrder_c);
// original function: bool getKeepDeclarationOrder();
void cMno_getKeepDeclarationOrder_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: const String& getMovableType();
void cMno_getMovableType_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: Real getBoundingRadius();
void cMno_getBoundingRadius_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: bool hasEdgeList();
void cMno_hasEdgeList_c(struct hg3dclass_struct *classptr_c, int * result_c);
