// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassMaterial.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreMaterial.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"
#include "TypeColour.h"
#include "EnumCompareFunction.h"
#include "EnumCullingMode.h"
#include "EnumManualCullingMode.h"
#include "EnumShadeOptions.h"
#include "EnumFogMode.h"
#include "EnumTextureFilterOptions.h"


// original function: bool isTransparent();
void cMt_isTransparent_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setReceiveShadows(bool enabled);
void cMt_setReceiveShadows_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getReceiveShadows();
void cMt_getReceiveShadows_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setTransparencyCastsShadows(bool enabled);
void cMt_setTransparencyCastsShadows_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getTransparencyCastsShadows();
void cMt_getTransparencyCastsShadows_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: Technique* createTechnique();
void cMt_createTechnique_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: Technique* getTechnique(unsigned short index);
void cMt_getTechnique_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: Technique* getTechnique(const String& name);
void cMt_getTechnique2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: unsigned short getNumTechniques();
void cMt_getNumTechniques_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: void removeTechnique(unsigned short index);
void cMt_removeTechnique_c(struct hg3dclass_struct *classptr_c, unsigned short index_c);
// original function: void removeAllTechniques();
void cMt_removeAllTechniques_c(struct hg3dclass_struct *classptr_c);
// original function: Technique* getSupportedTechnique(unsigned short index);
void cMt_getSupportedTechnique_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: unsigned short getNumSupportedTechniques();
void cMt_getNumSupportedTechniques_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: const String& getUnsupportedTechniquesExplanation();
void cMt_getUnsupportedTechniquesExplanation_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: unsigned short getNumLodLevels(unsigned short schemeIndex);
void cMt_getNumLodLevels_c(struct hg3dclass_struct *classptr_c, unsigned short schemeIndex_c, unsigned short * result_c);
// original function: unsigned short getNumLodLevels(const String& schemeName);
void cMt_getNumLodLevels2_c(struct hg3dclass_struct *classptr_c, char * schemeName_c, unsigned short * result_c);
// original function: MaterialPtr clone(const String& newName, bool changeGroup, const String& newGroup);
void cMt_clone_c(struct hg3dclass_struct *classptr_c, char * newName_c, int changeGroup_c, char * newGroup_c, struct sharedptr_struct * result_c);
// original function: void copyDetailsTo(MaterialPtr& mat);
void cMt_copyDetailsTo_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * mat_c);
// original function: void compile(bool autoManageTextureUnits);
void cMt_compile_c(struct hg3dclass_struct *classptr_c, int autoManageTextureUnits_c);
// original function: void setPointSize(Real ps);
void cMt_setPointSize_c(struct hg3dclass_struct *classptr_c, float ps_c);
// original function: void setAmbient(Real red, Real green, Real blue);
void cMt_setAmbient_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c);
// original function: void setAmbient(const ColourValue& ambient);
void cMt_setAmbient2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * ambient_c);
// original function: void setDiffuse(Real red, Real green, Real blue, Real alpha);
void cMt_setDiffuse_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c, float alpha_c);
// original function: void setDiffuse(const ColourValue& diffuse);
void cMt_setDiffuse2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * diffuse_c);
// original function: void setSpecular(Real red, Real green, Real blue, Real alpha);
void cMt_setSpecular_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c, float alpha_c);
// original function: void setSpecular(const ColourValue& specular);
void cMt_setSpecular2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * specular_c);
// original function: void setShininess(Real val);
void cMt_setShininess_c(struct hg3dclass_struct *classptr_c, float val_c);
// original function: void setSelfIllumination(Real red, Real green, Real blue);
void cMt_setSelfIllumination_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c);
// original function: void setSelfIllumination(const ColourValue& selfIllum);
void cMt_setSelfIllumination2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * selfIllum_c);
// original function: void setDepthCheckEnabled(bool enabled);
void cMt_setDepthCheckEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: void setDepthWriteEnabled(bool enabled);
void cMt_setDepthWriteEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: void setDepthFunction(CompareFunction func);
void cMt_setDepthFunction_c(struct hg3dclass_struct *classptr_c, enum EnumCompareFunction func_c);
// original function: void setColourWriteEnabled(bool enabled);
void cMt_setColourWriteEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: void setCullingMode(CullingMode mode);
void cMt_setCullingMode_c(struct hg3dclass_struct *classptr_c, enum EnumCullingMode mode_c);
// original function: void setManualCullingMode(ManualCullingMode mode);
void cMt_setManualCullingMode_c(struct hg3dclass_struct *classptr_c, enum EnumManualCullingMode mode_c);
// original function: void setLightingEnabled(bool enabled);
void cMt_setLightingEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: void setShadingMode(ShadeOptions mode);
void cMt_setShadingMode_c(struct hg3dclass_struct *classptr_c, enum EnumShadeOptions mode_c);
// original function: void setFog(bool overrideScene, FogMode mode, const ColourValue& colour, Real expDensity, Real linearStart, Real linearEnd);
void cMt_setFog_c(struct hg3dclass_struct *classptr_c, int overrideScene_c, enum EnumFogMode mode_c, struct colourvalue_struct * colour_c, float expDensity_c, float linearStart_c, float linearEnd_c);
// original function: void setDepthBias(float constantBias, float slopeScaleBias);
void cMt_setDepthBias_c(struct hg3dclass_struct *classptr_c, float constantBias_c, float slopeScaleBias_c);
// original function: void setTextureFiltering(TextureFilterOptions filterType);
void cMt_setTextureFiltering_c(struct hg3dclass_struct *classptr_c, enum EnumTextureFilterOptions filterType_c);
// original function: void setTextureAnisotropy(int maxAniso);
void cMt_setTextureAnisotropy_c(struct hg3dclass_struct *classptr_c, int maxAniso_c);
// original function: void _notifyNeedsRecompile();
void cMt__notifyNeedsRecompile_c(struct hg3dclass_struct *classptr_c);
// original function: void touch();
void cMt_touch_c(struct hg3dclass_struct *classptr_c);
// original function: bool getCompilationRequired();
void cMt_getCompilationRequired_c(struct hg3dclass_struct *classptr_c, int * result_c);
