// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassMaterialManager.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreMaterialManager.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"
#include "EnumTextureFilterOptions.h"
#include "EnumFilterType.h"
#include "EnumFilterOptions.h"


// original function: void initialise();
void cMtm_initialise_c(struct hg3dclass_struct *classptr_c);
// original function: void parseScript(DataStreamPtr& stream, const String& groupName);
void cMtm_parseScript_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * stream_c, char * groupName_c);
// original function: void setDefaultTextureFiltering(TextureFilterOptions fo);
void cMtm_setDefaultTextureFiltering_c(struct hg3dclass_struct *classptr_c, enum EnumTextureFilterOptions fo_c);
// original function: void setDefaultTextureFiltering(FilterType ftype, FilterOptions opts);
void cMtm_setDefaultTextureFiltering2_c(struct hg3dclass_struct *classptr_c, enum EnumFilterType ftype_c, enum EnumFilterOptions opts_c);
// original function: void setDefaultTextureFiltering(FilterOptions minFilter, FilterOptions magFilter, FilterOptions mipFilter);
void cMtm_setDefaultTextureFiltering3_c(struct hg3dclass_struct *classptr_c, enum EnumFilterOptions minFilter_c, enum EnumFilterOptions magFilter_c, enum EnumFilterOptions mipFilter_c);
// original function: FilterOptions getDefaultTextureFiltering(FilterType ftype);
void cMtm_getDefaultTextureFiltering_c(struct hg3dclass_struct *classptr_c, enum EnumFilterType ftype_c, enum EnumFilterOptions * result_c);
// original function: void setDefaultAnisotropy(unsigned int maxAniso);
void cMtm_setDefaultAnisotropy_c(struct hg3dclass_struct *classptr_c, unsigned int maxAniso_c);
// original function: unsigned int getDefaultAnisotropy();
void cMtm_getDefaultAnisotropy_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: MaterialPtr getDefaultSettings();
void cMtm_getDefaultSettings_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: unsigned short _getSchemeIndex(const String& name);
void cMtm__getSchemeIndex_c(struct hg3dclass_struct *classptr_c, char * name_c, unsigned short * result_c);
// original function: const String& _getSchemeName(unsigned short index);
void cMtm__getSchemeName_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, char * result_c);
// original function: unsigned short _getActiveSchemeIndex();
void cMtm__getActiveSchemeIndex_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: const String& getActiveScheme();
void cMtm_getActiveScheme_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setActiveScheme(const String& schemeName);
void cMtm_setActiveScheme_c(struct hg3dclass_struct *classptr_c, char * schemeName_c);
