// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassMesh.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreMesh.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"
#include "EnumVertexElementSemantic.h"
#include "EnumVertexAnimationType.h"


// original function: SubMesh* createSubMesh();
void cM_createSubMesh_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: SubMesh* createSubMesh(const String& name);
void cM_createSubMesh2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: void unnameSubMesh(const String& name);
void cM_unnameSubMesh_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: unsigned short getNumSubMeshes();
void cM_getNumSubMeshes_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: SubMesh* getSubMesh(unsigned short index);
void cM_getSubMesh_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: SubMesh* getSubMesh(const String& name);
void cM_getSubMesh2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: void destroySubMesh(unsigned short index);
void cM_destroySubMesh_c(struct hg3dclass_struct *classptr_c, unsigned short index_c);
// original function: void destroySubMesh(const String& name);
void cM_destroySubMesh2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: MeshPtr clone(const String& newName, const String& newGroup);
void cM_clone_c(struct hg3dclass_struct *classptr_c, char * newName_c, char * newGroup_c, struct sharedptr_struct * result_c);
// original function: Real getBoundingSphereRadius();
void cM_getBoundingSphereRadius_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void _setBoundingSphereRadius(Real radius);
void cM__setBoundingSphereRadius_c(struct hg3dclass_struct *classptr_c, float radius_c);
// original function: void setSkeletonName(const String& skelName);
void cM_setSkeletonName_c(struct hg3dclass_struct *classptr_c, char * skelName_c);
// original function: bool hasSkeleton();
void cM_hasSkeleton_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasVertexAnimation();
void cM_hasVertexAnimation_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: const SkeletonPtr& getSkeleton();
void cM_getSkeleton_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: const String& getSkeletonName();
void cM_getSkeletonName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void clearBoneAssignments();
void cM_clearBoneAssignments_c(struct hg3dclass_struct *classptr_c);
// original function: void _notifySkeleton(SkeletonPtr& pSkel);
void cM__notifySkeleton_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * pSkel_c);
// original function: void createManualLodLevel(Real value, const String& meshName, const String& groupName);
void cM_createManualLodLevel_c(struct hg3dclass_struct *classptr_c, float value_c, char * meshName_c, char * groupName_c);
// original function: bool isLodManual();
void cM_isLodManual_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _setLodInfo(unsigned short numLevels, bool isManual);
void cM__setLodInfo_c(struct hg3dclass_struct *classptr_c, unsigned short numLevels_c, int isManual_c);
// original function: void removeLodLevels();
void cM_removeLodLevels_c(struct hg3dclass_struct *classptr_c);
// original function: bool isVertexBufferShadowed();
void cM_isVertexBufferShadowed_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isIndexBufferShadowed();
void cM_isIndexBufferShadowed_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _compileBoneAssignments();
void cM__compileBoneAssignments_c(struct hg3dclass_struct *classptr_c);
// original function: void _updateCompiledBoneAssignments();
void cM__updateCompiledBoneAssignments_c(struct hg3dclass_struct *classptr_c);
// original function: void buildTangentVectors(VertexElementSemantic targetSemantic, unsigned short sourceTexCoordSet, unsigned short index, bool splitMirrored, bool splitRotated, bool storeParityInW);
void cM_buildTangentVectors_c(struct hg3dclass_struct *classptr_c, enum EnumVertexElementSemantic targetSemantic_c, unsigned short sourceTexCoordSet_c, unsigned short index_c, int splitMirrored_c, int splitRotated_c, int storeParityInW_c);
// original function: void buildEdgeList();
void cM_buildEdgeList_c(struct hg3dclass_struct *classptr_c);
// original function: void freeEdgeList();
void cM_freeEdgeList_c(struct hg3dclass_struct *classptr_c);
// original function: void prepareForShadowVolume();
void cM_prepareForShadowVolume_c(struct hg3dclass_struct *classptr_c);
// original function: bool isPreparedForShadowVolumes();
void cM_isPreparedForShadowVolumes_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isEdgeListBuilt();
void cM_isEdgeListBuilt_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setAutoBuildEdgeLists(bool autobuild);
void cM_setAutoBuildEdgeLists_c(struct hg3dclass_struct *classptr_c, int autobuild_c);
// original function: bool getAutoBuildEdgeLists();
void cM_getAutoBuildEdgeLists_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: VertexAnimationType getSharedVertexDataAnimationType();
void cM_getSharedVertexDataAnimationType_c(struct hg3dclass_struct *classptr_c, enum EnumVertexAnimationType * result_c);
// original function: Animation* createAnimation(const String& name, Real length);
void cM_createAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c, float length_c, struct hg3dclass_struct * result_c);
// original function: Animation* getAnimation(const String& name);
void cM_getAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: Animation* _getAnimationImpl(const String& name);
void cM__getAnimationImpl_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasAnimation(const String& name);
void cM_hasAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void removeAnimation(const String& name);
void cM_removeAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: unsigned short getNumAnimations();
void cM_getNumAnimations_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: Animation* getAnimation(unsigned short index);
void cM_getAnimation2_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: void removeAllAnimations();
void cM_removeAllAnimations_c(struct hg3dclass_struct *classptr_c);
// original function: void updateMaterialForAllSubMeshes();
void cM_updateMaterialForAllSubMeshes_c(struct hg3dclass_struct *classptr_c);
// original function: void _determineAnimationTypes();
void cM__determineAnimationTypes_c(struct hg3dclass_struct *classptr_c);
// original function: bool _getAnimationTypesDirty();
void cM__getAnimationTypesDirty_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: size_t getPoseCount();
void cM_getPoseCount_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void removePose(const String& name);
void cM_removePose2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void removeAllPoses();
void cM_removeAllPoses_c(struct hg3dclass_struct *classptr_c);
