// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassMovableObject.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreMovableObject.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"


// original function: void _notifyCreator(MovableObjectFactory* fact);
void cMo__notifyCreator_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * fact_c);
// original function: MovableObjectFactory* _getCreator();
void cMo__getCreator_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void _notifyManager(SceneManager* man);
void cMo__notifyManager_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * man_c);
// original function: SceneManager* _getManager();
void cMo__getManager_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: const String& getName();
void cMo_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const String& getMovableType();
void cMo_getMovableType_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: Node* getParentNode();
void cMo_getParentNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: SceneNode* getParentSceneNode();
void cMo_getParentSceneNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: bool isParentTagPoint();
void cMo_isParentTagPoint_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _notifyAttached(Node* parent, bool isTagPoint);
void cMo__notifyAttached_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * parent_c, int isTagPoint_c);
// original function: bool isAttached();
void cMo_isAttached_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void detachFromParent();
void cMo_detachFromParent_c(struct hg3dclass_struct *classptr_c);
// original function: bool isInScene();
void cMo_isInScene_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _notifyMoved();
void cMo__notifyMoved_c(struct hg3dclass_struct *classptr_c);
// original function: void _notifyCurrentCamera(Camera* cam);
void cMo__notifyCurrentCamera_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cam_c);
// original function: Real getBoundingRadius();
void cMo_getBoundingRadius_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setVisible(bool visible);
void cMo_setVisible_c(struct hg3dclass_struct *classptr_c, int visible_c);
// original function: bool getVisible();
void cMo_getVisible_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isVisible();
void cMo_isVisible_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setRenderingDistance(Real dist);
void cMo_setRenderingDistance_c(struct hg3dclass_struct *classptr_c, float dist_c);
// original function: Real getRenderingDistance();
void cMo_getRenderingDistance_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setQueryFlags(uint32 flags);
void cMo_setQueryFlags_c(struct hg3dclass_struct *classptr_c, unsigned int flags_c);
// original function: void addQueryFlags(uint32 flags);
void cMo_addQueryFlags_c(struct hg3dclass_struct *classptr_c, unsigned int flags_c);
// original function: void removeQueryFlags(uint32 flags);
void cMo_removeQueryFlags_c(struct hg3dclass_struct *classptr_c, unsigned int flags_c);
// original function: uint32 getQueryFlags();
void cMo_getQueryFlags_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setVisibilityFlags(uint32 flags);
void cMo_setVisibilityFlags_c(struct hg3dclass_struct *classptr_c, unsigned int flags_c);
// original function: void addVisibilityFlags(uint32 flags);
void cMo_addVisibilityFlags_c(struct hg3dclass_struct *classptr_c, unsigned int flags_c);
// original function: void removeVisibilityFlags(uint32 flags);
void cMo_removeVisibilityFlags_c(struct hg3dclass_struct *classptr_c, unsigned int flags_c);
// original function: uint32 getVisibilityFlags();
void cMo_getVisibilityFlags_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: uint32 getLightMask();
void cMo_getLightMask_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setLightMask(uint32 lightMask);
void cMo_setLightMask_c(struct hg3dclass_struct *classptr_c, unsigned int lightMask_c);
// original function: bool hasEdgeList();
void cMo_hasEdgeList_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setCastShadows(bool enabled);
void cMo_setCastShadows_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getCastShadows();
void cMo_getCastShadows_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool getReceivesShadows();
void cMo_getReceivesShadows_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: uint32 getTypeFlags();
void cMo_getTypeFlags_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setDebugDisplayEnabled(bool enabled);
void cMo_setDebugDisplayEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool isDebugDisplayEnabled();
void cMo_isDebugDisplayEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
