// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassNode.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreNode.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeQuaternion.h"
#include "TypeVector3.h"
#include "EnumTransformSpace.h"
#include "TypeRadian.h"


// original function: const String& getName();
void cN_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: Node* getParent();
void cN_getParent_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: const Quaternion & getOrientation();
void cN_getOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * result_c);
// original function: void setOrientation(const Quaternion& q);
void cN_setOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * q_c);
// original function: void setOrientation(Real w, Real x, Real y, Real z);
void cN_setOrientation2_c(struct hg3dclass_struct *classptr_c, float w_c, float x_c, float y_c, float z_c);
// original function: void resetOrientation();
void cN_resetOrientation_c(struct hg3dclass_struct *classptr_c);
// original function: void setPosition(const Vector3& pos);
void cN_setPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * pos_c);
// original function: void setPosition(Real x, Real y, Real z);
void cN_setPosition2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: const Vector3 & getPosition();
void cN_getPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void setScale(const Vector3& scale);
void cN_setScale_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * scale_c);
// original function: void setScale(Real x, Real y, Real z);
void cN_setScale2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: const Vector3 & getScale();
void cN_getScale_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void setInheritOrientation(bool inherit);
void cN_setInheritOrientation_c(struct hg3dclass_struct *classptr_c, int inherit_c);
// original function: bool getInheritOrientation();
void cN_getInheritOrientation_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setInheritScale(bool inherit);
void cN_setInheritScale_c(struct hg3dclass_struct *classptr_c, int inherit_c);
// original function: bool getInheritScale();
void cN_getInheritScale_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void scale(const Vector3& scale);
void cN_scale_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * scale_c);
// original function: void scale(Real x, Real y, Real z);
void cN_scale2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c);
// original function: void translate(const Vector3& d, TransformSpace relativeTo);
void cN_translate_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * d_c, enum EnumTransformSpace relativeTo_c);
// original function: void translate(Real x, Real y, Real z, TransformSpace relativeTo);
void cN_translate2_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c, enum EnumTransformSpace relativeTo_c);
// original function: void roll(const Radian& angle, TransformSpace relativeTo);
void cN_roll_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c, enum EnumTransformSpace relativeTo_c);
// original function: void pitch(const Radian& angle, TransformSpace relativeTo);
void cN_pitch_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c, enum EnumTransformSpace relativeTo_c);
// original function: void yaw(const Radian& angle, TransformSpace relativeTo);
void cN_yaw_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c, enum EnumTransformSpace relativeTo_c);
// original function: void rotate(const Vector3& axis, const Radian& angle, TransformSpace relativeTo);
void cN_rotate_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * axis_c, struct radian_struct * angle_c, enum EnumTransformSpace relativeTo_c);
// original function: void rotate(const Quaternion& q, TransformSpace relativeTo);
void cN_rotate2_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * q_c, enum EnumTransformSpace relativeTo_c);
// original function: Node* createChild(const Vector3& translate, const Quaternion& rotate);
void cN_createChild_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * translate_c, struct quaternion_struct * rotate_c, struct hg3dclass_struct * result_c);
// original function: Node* createChild(const String& name, const Vector3& translate, const Quaternion& rotate);
void cN_createChild2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct vector3_struct * translate_c, struct quaternion_struct * rotate_c, struct hg3dclass_struct * result_c);
// original function: void addChild(Node* child);
void cN_addChild_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * child_c);
// original function: unsigned short numChildren();
void cN_numChildren_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: Node* getChild(unsigned short index);
void cN_getChild_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: Node* getChild(const String& name);
void cN_getChild2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: Node* removeChild(unsigned short index);
void cN_removeChild_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: Node* removeChild(Node* child);
void cN_removeChild2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * child_c, struct hg3dclass_struct * result_c);
// original function: Node* removeChild(const String& name);
void cN_removeChild3_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: void removeAllChildren();
void cN_removeAllChildren_c(struct hg3dclass_struct *classptr_c);
// original function: void _setDerivedPosition(const Vector3& pos);
void cN__setDerivedPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * pos_c);
// original function: void _setDerivedOrientation(const Quaternion& q);
void cN__setDerivedOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * q_c);
// original function: const Quaternion & _getDerivedOrientation();
void cN__getDerivedOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * result_c);
// original function: const Vector3 & _getDerivedPosition();
void cN__getDerivedPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: const Vector3 & _getDerivedScale();
void cN__getDerivedScale_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void _update(bool updateChildren, bool parentHasChanged);
void cN__update_c(struct hg3dclass_struct *classptr_c, int updateChildren_c, int parentHasChanged_c);
// original function: void setInitialState();
void cN_setInitialState_c(struct hg3dclass_struct *classptr_c);
// original function: void resetToInitialState();
void cN_resetToInitialState_c(struct hg3dclass_struct *classptr_c);
// original function: const Vector3& getInitialPosition();
void cN_getInitialPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: Vector3 convertWorldToLocalPosition(const Vector3 & worldPos);
void cN_convertWorldToLocalPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * worldPos_c, struct vector3_struct * result_c);
// original function: Vector3 convertLocalToWorldPosition(const Vector3 & localPos);
void cN_convertLocalToWorldPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * localPos_c, struct vector3_struct * result_c);
// original function: Quaternion convertWorldToLocalOrientation(const Quaternion & worldOrientation);
void cN_convertWorldToLocalOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * worldOrientation_c, struct quaternion_struct * result_c);
// original function: Quaternion convertLocalToWorldOrientation(const Quaternion & localOrientation);
void cN_convertLocalToWorldOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * localOrientation_c, struct quaternion_struct * result_c);
// original function: const Quaternion& getInitialOrientation();
void cN_getInitialOrientation_c(struct hg3dclass_struct *classptr_c, struct quaternion_struct * result_c);
// original function: const Vector3& getInitialScale();
void cN_getInitialScale_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void needUpdate(bool forceParentUpdate);
void cN_needUpdate_c(struct hg3dclass_struct *classptr_c, int forceParentUpdate_c);
// original function: void requestUpdate(Node* child, bool forceParentUpdate);
void cN_requestUpdate_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * child_c, int forceParentUpdate_c);
// original function: void cancelUpdate(Node* child);
void cN_cancelUpdate_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * child_c);
