// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassOverlay.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreOverlay.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeRadian.h"


// original function: const String& getName();
void cO_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: bool isVisible();
void cO_isVisible_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isInitialised();
void cO_isInitialised_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void show();
void cO_show_c(struct hg3dclass_struct *classptr_c);
// original function: void hide();
void cO_hide_c(struct hg3dclass_struct *classptr_c);
// original function: void add2D(OverlayContainer* cont);
void cO_add2D_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cont_c);
// original function: void remove2D(OverlayContainer* cont);
void cO_remove2D_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cont_c);
// original function: void add3D(SceneNode* node);
void cO_add3D_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * node_c);
// original function: void remove3D(SceneNode* node);
void cO_remove3D_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * node_c);
// original function: void clear();
void cO_clear_c(struct hg3dclass_struct *classptr_c);
// original function: void setScroll(Real x, Real y);
void cO_setScroll_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c);
// original function: Real getScrollX();
void cO_getScrollX_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getScrollY();
void cO_getScrollY_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void scroll(Real xoff, Real yoff);
void cO_scroll_c(struct hg3dclass_struct *classptr_c, float xoff_c, float yoff_c);
// original function: void setRotate(const Radian& angle);
void cO_setRotate_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c);
// original function: const Radian & getRotate();
void cO_getRotate_c(struct hg3dclass_struct *classptr_c, struct radian_struct * result_c);
// original function: void rotate(const Radian& angle);
void cO_rotate_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c);
// original function: void setScale(Real x, Real y);
void cO_setScale_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c);
// original function: Real getScaleX();
void cO_getScaleX_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getScaleY();
void cO_getScaleY_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: const String& getOrigin();
void cO_getOrigin_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void _notifyOrigin(const String& origin);
void cO__notifyOrigin_c(struct hg3dclass_struct *classptr_c, char * origin_c);
