// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassOverlayManager.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreOverlayManager.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"
#include "EnumOrientationMode.h"


// original function: void parseScript(DataStreamPtr& stream, const String& groupName);
void cOm_parseScript_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * stream_c, char * groupName_c);
// original function: Real getLoadingOrder();
void cOm_getLoadingOrder_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Overlay* create(const String& name);
void cOm_create_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: Overlay* getByName(const String& name);
void cOm_getByName_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: void destroy(const String& name);
void cOm_destroy_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroy(Overlay* overlay);
void cOm_destroy2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * overlay_c);
// original function: void destroyAll();
void cOm_destroyAll_c(struct hg3dclass_struct *classptr_c);
// original function: bool hasViewportChanged();
void cOm_hasViewportChanged_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: int getViewportHeight();
void cOm_getViewportHeight_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: int getViewportWidth();
void cOm_getViewportWidth_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: OrientationMode getViewportOrientationMode();
void cOm_getViewportOrientationMode_c(struct hg3dclass_struct *classptr_c, enum EnumOrientationMode * result_c);
// original function: bool hasOverlayElement(const String& name, bool isTemplate);
void cOm_hasOverlayElement_c(struct hg3dclass_struct *classptr_c, char * name_c, int isTemplate_c, int * result_c);
// original function: void destroyOverlayElement(const String& instanceName, bool isTemplate);
void cOm_destroyOverlayElement_c(struct hg3dclass_struct *classptr_c, char * instanceName_c, int isTemplate_c);
// original function: void destroyAllOverlayElements(bool isTemplate);
void cOm_destroyAllOverlayElements_c(struct hg3dclass_struct *classptr_c, int isTemplate_c);
