// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassParticleEmitter.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreParticleEmitter.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeVector3.h"
#include "TypeRadian.h"
#include "TypeColour.h"


// original function: void setPosition(const Vector3& pos);
void cPe_setPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * pos_c);
// original function: const Vector3& getPosition();
void cPe_getPosition_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void setDirection(const Vector3& direction);
void cPe_setDirection_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * direction_c);
// original function: const Vector3& getDirection();
void cPe_getDirection_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void setAngle(const Radian& angle);
void cPe_setAngle_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c);
// original function: const Radian& getAngle();
void cPe_getAngle_c(struct hg3dclass_struct *classptr_c, struct radian_struct * result_c);
// original function: void setParticleVelocity(Real speed);
void cPe_setParticleVelocity_c(struct hg3dclass_struct *classptr_c, float speed_c);
// original function: void setParticleVelocity(Real min, Real max);
void cPe_setParticleVelocity2_c(struct hg3dclass_struct *classptr_c, float min_c, float max_c);
// original function: void setMinParticleVelocity(Real min);
void cPe_setMinParticleVelocity_c(struct hg3dclass_struct *classptr_c, float min_c);
// original function: void setMaxParticleVelocity(Real max);
void cPe_setMaxParticleVelocity_c(struct hg3dclass_struct *classptr_c, float max_c);
// original function: Real getParticleVelocity();
void cPe_getParticleVelocity_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getMinParticleVelocity();
void cPe_getMinParticleVelocity_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getMaxParticleVelocity();
void cPe_getMaxParticleVelocity_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setEmissionRate(Real particlesPerSecond);
void cPe_setEmissionRate_c(struct hg3dclass_struct *classptr_c, float particlesPerSecond_c);
// original function: Real getEmissionRate();
void cPe_getEmissionRate_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setTimeToLive(Real ttl);
void cPe_setTimeToLive_c(struct hg3dclass_struct *classptr_c, float ttl_c);
// original function: void setTimeToLive(Real minTtl, Real maxTtl);
void cPe_setTimeToLive2_c(struct hg3dclass_struct *classptr_c, float minTtl_c, float maxTtl_c);
// original function: void setMinTimeToLive(Real min);
void cPe_setMinTimeToLive_c(struct hg3dclass_struct *classptr_c, float min_c);
// original function: void setMaxTimeToLive(Real max);
void cPe_setMaxTimeToLive_c(struct hg3dclass_struct *classptr_c, float max_c);
// original function: Real getTimeToLive();
void cPe_getTimeToLive_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getMinTimeToLive();
void cPe_getMinTimeToLive_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getMaxTimeToLive();
void cPe_getMaxTimeToLive_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setColour(const ColourValue& colour);
void cPe_setColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colour_c);
// original function: void setColour(const ColourValue& colourStart, const ColourValue& colourEnd);
void cPe_setColour2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colourStart_c, struct colourvalue_struct * colourEnd_c);
// original function: void setColourRangeStart(const ColourValue& colour);
void cPe_setColourRangeStart_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colour_c);
// original function: void setColourRangeEnd(const ColourValue& colour);
void cPe_setColourRangeEnd_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colour_c);
// original function: const ColourValue& getColour();
void cPe_getColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: const ColourValue& getColourRangeStart();
void cPe_getColourRangeStart_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: const ColourValue& getColourRangeEnd();
void cPe_getColourRangeEnd_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: unsigned short _getEmissionCount(Real timeElapsed);
void cPe__getEmissionCount_c(struct hg3dclass_struct *classptr_c, float timeElapsed_c, unsigned short * result_c);
// original function: const String & getType();
void cPe_getType_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setEnabled(bool enabled);
void cPe_setEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getEnabled();
void cPe_getEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setStartTime(Real startTime);
void cPe_setStartTime_c(struct hg3dclass_struct *classptr_c, float startTime_c);
// original function: Real getStartTime();
void cPe_getStartTime_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setDuration(Real duration);
void cPe_setDuration_c(struct hg3dclass_struct *classptr_c, float duration_c);
// original function: Real getDuration();
void cPe_getDuration_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setDuration(Real min, Real max);
void cPe_setDuration2_c(struct hg3dclass_struct *classptr_c, float min_c, float max_c);
// original function: void setMinDuration(Real min);
void cPe_setMinDuration_c(struct hg3dclass_struct *classptr_c, float min_c);
// original function: void setMaxDuration(Real max);
void cPe_setMaxDuration_c(struct hg3dclass_struct *classptr_c, float max_c);
// original function: Real getMinDuration();
void cPe_getMinDuration_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getMaxDuration();
void cPe_getMaxDuration_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setRepeatDelay(Real duration);
void cPe_setRepeatDelay_c(struct hg3dclass_struct *classptr_c, float duration_c);
// original function: Real getRepeatDelay();
void cPe_getRepeatDelay_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setRepeatDelay(Real min, Real max);
void cPe_setRepeatDelay2_c(struct hg3dclass_struct *classptr_c, float min_c, float max_c);
// original function: void setMinRepeatDelay(Real min);
void cPe_setMinRepeatDelay_c(struct hg3dclass_struct *classptr_c, float min_c);
// original function: void setMaxRepeatDelay(Real max);
void cPe_setMaxRepeatDelay_c(struct hg3dclass_struct *classptr_c, float max_c);
// original function: Real getMinRepeatDelay();
void cPe_getMinRepeatDelay_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getMaxRepeatDelay();
void cPe_getMaxRepeatDelay_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: const String & getName();
void cPe_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setName(const String& newName);
void cPe_setName_c(struct hg3dclass_struct *classptr_c, char * newName_c);
// original function: const String & getEmittedEmitter();
void cPe_getEmittedEmitter_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setEmittedEmitter(const String& emittedEmitter);
void cPe_setEmittedEmitter_c(struct hg3dclass_struct *classptr_c, char * emittedEmitter_c);
// original function: bool isEmitted();
void cPe_isEmitted_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setEmitted(bool emitted);
void cPe_setEmitted_c(struct hg3dclass_struct *classptr_c, int emitted_c);
