// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassPass.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgrePass.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeColour.h"
#include "EnumSceneBlendFactor.h"
#include "EnumSceneBlendOperation.h"
#include "EnumCompareFunction.h"
#include "EnumCullingMode.h"
#include "EnumManualCullingMode.h"
#include "EnumShadeOptions.h"
#include "EnumPolygonMode.h"
#include "EnumFogMode.h"
#include "EnumLightTypes.h"
#include "TypeSharedPtr.h"
#include "EnumContentType.h"
#include "EnumTextureFilterOptions.h"
#include "EnumIlluminationStage.h"


// original function: bool isProgrammable();
void cP_isProgrammable_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasVertexProgram();
void cP_hasVertexProgram_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasFragmentProgram();
void cP_hasFragmentProgram_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasGeometryProgram();
void cP_hasGeometryProgram_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasShadowCasterVertexProgram();
void cP_hasShadowCasterVertexProgram_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasShadowReceiverVertexProgram();
void cP_hasShadowReceiverVertexProgram_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasShadowReceiverFragmentProgram();
void cP_hasShadowReceiverFragmentProgram_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: unsigned short getIndex();
void cP_getIndex_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: const String& getName();
void cP_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setAmbient(Real red, Real green, Real blue);
void cP_setAmbient_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c);
// original function: void setAmbient(const ColourValue& ambient);
void cP_setAmbient2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * ambient_c);
// original function: void setDiffuse(Real red, Real green, Real blue, Real alpha);
void cP_setDiffuse_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c, float alpha_c);
// original function: void setDiffuse(const ColourValue& diffuse);
void cP_setDiffuse2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * diffuse_c);
// original function: void setSpecular(Real red, Real green, Real blue, Real alpha);
void cP_setSpecular_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c, float alpha_c);
// original function: void setSpecular(const ColourValue& specular);
void cP_setSpecular2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * specular_c);
// original function: void setShininess(Real val);
void cP_setShininess_c(struct hg3dclass_struct *classptr_c, float val_c);
// original function: void setSelfIllumination(Real red, Real green, Real blue);
void cP_setSelfIllumination_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c);
// original function: void setSelfIllumination(const ColourValue& selfIllum);
void cP_setSelfIllumination2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * selfIllum_c);
// original function: Real getPointSize();
void cP_getPointSize_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setPointSize(Real ps);
void cP_setPointSize_c(struct hg3dclass_struct *classptr_c, float ps_c);
// original function: void setPointSpritesEnabled(bool enabled);
void cP_setPointSpritesEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getPointSpritesEnabled();
void cP_getPointSpritesEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setPointAttenuation(bool enabled, Real constant, Real linear, Real quadratic);
void cP_setPointAttenuation_c(struct hg3dclass_struct *classptr_c, int enabled_c, float constant_c, float linear_c, float quadratic_c);
// original function: bool isPointAttenuationEnabled();
void cP_isPointAttenuationEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: Real getPointAttenuationConstant();
void cP_getPointAttenuationConstant_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getPointAttenuationLinear();
void cP_getPointAttenuationLinear_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getPointAttenuationQuadratic();
void cP_getPointAttenuationQuadratic_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setPointMinSize(Real min);
void cP_setPointMinSize_c(struct hg3dclass_struct *classptr_c, float min_c);
// original function: Real getPointMinSize();
void cP_getPointMinSize_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setPointMaxSize(Real max);
void cP_setPointMaxSize_c(struct hg3dclass_struct *classptr_c, float max_c);
// original function: Real getPointMaxSize();
void cP_getPointMaxSize_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: const ColourValue& getAmbient();
void cP_getAmbient_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: const ColourValue& getDiffuse();
void cP_getDiffuse_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: const ColourValue& getSpecular();
void cP_getSpecular_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: const ColourValue& getSelfIllumination();
void cP_getSelfIllumination_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: Real getShininess();
void cP_getShininess_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: TextureUnitState* createTextureUnitState();
void cP_createTextureUnitState_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: TextureUnitState* createTextureUnitState(const String& textureName, unsigned short texCoordSet);
void cP_createTextureUnitState2_c(struct hg3dclass_struct *classptr_c, char * textureName_c, unsigned short texCoordSet_c, struct hg3dclass_struct * result_c);
// original function: void addTextureUnitState(TextureUnitState* state);
void cP_addTextureUnitState_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * state_c);
// original function: TextureUnitState* getTextureUnitState(unsigned short index);
void cP_getTextureUnitState_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: TextureUnitState* getTextureUnitState(const String& name);
void cP_getTextureUnitState2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: void removeTextureUnitState(unsigned short index);
void cP_removeTextureUnitState_c(struct hg3dclass_struct *classptr_c, unsigned short index_c);
// original function: void removeAllTextureUnitStates();
void cP_removeAllTextureUnitStates_c(struct hg3dclass_struct *classptr_c);
// original function: unsigned short getNumTextureUnitStates();
void cP_getNumTextureUnitStates_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: bool hasSeparateSceneBlending();
void cP_hasSeparateSceneBlending_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: SceneBlendFactor getSourceBlendFactor();
void cP_getSourceBlendFactor_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendFactor * result_c);
// original function: SceneBlendFactor getDestBlendFactor();
void cP_getDestBlendFactor_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendFactor * result_c);
// original function: SceneBlendFactor getSourceBlendFactorAlpha();
void cP_getSourceBlendFactorAlpha_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendFactor * result_c);
// original function: SceneBlendFactor getDestBlendFactorAlpha();
void cP_getDestBlendFactorAlpha_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendFactor * result_c);
// original function: void setSceneBlendingOperation(SceneBlendOperation op);
void cP_setSceneBlendingOperation_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendOperation op_c);
// original function: void setSeparateSceneBlendingOperation(SceneBlendOperation op, SceneBlendOperation alphaOp);
void cP_setSeparateSceneBlendingOperation_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendOperation op_c, enum EnumSceneBlendOperation alphaOp_c);
// original function: bool hasSeparateSceneBlendingOperations();
void cP_hasSeparateSceneBlendingOperations_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: SceneBlendOperation getSceneBlendingOperation();
void cP_getSceneBlendingOperation_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendOperation * result_c);
// original function: SceneBlendOperation getSceneBlendingOperationAlpha();
void cP_getSceneBlendingOperationAlpha_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendOperation * result_c);
// original function: bool isTransparent();
void cP_isTransparent_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setDepthCheckEnabled(bool enabled);
void cP_setDepthCheckEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getDepthCheckEnabled();
void cP_getDepthCheckEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setDepthWriteEnabled(bool enabled);
void cP_setDepthWriteEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getDepthWriteEnabled();
void cP_getDepthWriteEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setDepthFunction(CompareFunction func);
void cP_setDepthFunction_c(struct hg3dclass_struct *classptr_c, enum EnumCompareFunction func_c);
// original function: CompareFunction getDepthFunction();
void cP_getDepthFunction_c(struct hg3dclass_struct *classptr_c, enum EnumCompareFunction * result_c);
// original function: void setColourWriteEnabled(bool enabled);
void cP_setColourWriteEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getColourWriteEnabled();
void cP_getColourWriteEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setCullingMode(CullingMode mode);
void cP_setCullingMode_c(struct hg3dclass_struct *classptr_c, enum EnumCullingMode mode_c);
// original function: CullingMode getCullingMode();
void cP_getCullingMode_c(struct hg3dclass_struct *classptr_c, enum EnumCullingMode * result_c);
// original function: void setManualCullingMode(ManualCullingMode mode);
void cP_setManualCullingMode_c(struct hg3dclass_struct *classptr_c, enum EnumManualCullingMode mode_c);
// original function: ManualCullingMode getManualCullingMode();
void cP_getManualCullingMode_c(struct hg3dclass_struct *classptr_c, enum EnumManualCullingMode * result_c);
// original function: void setLightingEnabled(bool enabled);
void cP_setLightingEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getLightingEnabled();
void cP_getLightingEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setMaxSimultaneousLights(unsigned short maxLights);
void cP_setMaxSimultaneousLights_c(struct hg3dclass_struct *classptr_c, unsigned short maxLights_c);
// original function: unsigned short getMaxSimultaneousLights();
void cP_getMaxSimultaneousLights_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: void setStartLight(unsigned short startLight);
void cP_setStartLight_c(struct hg3dclass_struct *classptr_c, unsigned short startLight_c);
// original function: unsigned short getStartLight();
void cP_getStartLight_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: void setShadingMode(ShadeOptions mode);
void cP_setShadingMode_c(struct hg3dclass_struct *classptr_c, enum EnumShadeOptions mode_c);
// original function: ShadeOptions getShadingMode();
void cP_getShadingMode_c(struct hg3dclass_struct *classptr_c, enum EnumShadeOptions * result_c);
// original function: void setPolygonMode(PolygonMode mode);
void cP_setPolygonMode_c(struct hg3dclass_struct *classptr_c, enum EnumPolygonMode mode_c);
// original function: PolygonMode getPolygonMode();
void cP_getPolygonMode_c(struct hg3dclass_struct *classptr_c, enum EnumPolygonMode * result_c);
// original function: void setPolygonModeOverrideable(bool override);
void cP_setPolygonModeOverrideable_c(struct hg3dclass_struct *classptr_c, int override_c);
// original function: bool getPolygonModeOverrideable();
void cP_getPolygonModeOverrideable_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setFog(bool overrideScene, FogMode mode, const ColourValue& colour, Real expDensity, Real linearStart, Real linearEnd);
void cP_setFog_c(struct hg3dclass_struct *classptr_c, int overrideScene_c, enum EnumFogMode mode_c, struct colourvalue_struct * colour_c, float expDensity_c, float linearStart_c, float linearEnd_c);
// original function: bool getFogOverride();
void cP_getFogOverride_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: FogMode getFogMode();
void cP_getFogMode_c(struct hg3dclass_struct *classptr_c, enum EnumFogMode * result_c);
// original function: const ColourValue& getFogColour();
void cP_getFogColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: Real getFogStart();
void cP_getFogStart_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getFogEnd();
void cP_getFogEnd_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getFogDensity();
void cP_getFogDensity_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setDepthBias(float constantBias, float slopeScaleBias);
void cP_setDepthBias_c(struct hg3dclass_struct *classptr_c, float constantBias_c, float slopeScaleBias_c);
// original function: float getDepthBiasConstant();
void cP_getDepthBiasConstant_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: float getDepthBiasSlopeScale();
void cP_getDepthBiasSlopeScale_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setIterationDepthBias(float biasPerIteration);
void cP_setIterationDepthBias_c(struct hg3dclass_struct *classptr_c, float biasPerIteration_c);
// original function: float getIterationDepthBias();
void cP_getIterationDepthBias_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setAlphaRejectFunction(CompareFunction func);
void cP_setAlphaRejectFunction_c(struct hg3dclass_struct *classptr_c, enum EnumCompareFunction func_c);
// original function: CompareFunction getAlphaRejectFunction();
void cP_getAlphaRejectFunction_c(struct hg3dclass_struct *classptr_c, enum EnumCompareFunction * result_c);
// original function: void setAlphaToCoverageEnabled(bool enabled);
void cP_setAlphaToCoverageEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool isAlphaToCoverageEnabled();
void cP_isAlphaToCoverageEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setTransparentSortingEnabled(bool enabled);
void cP_setTransparentSortingEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getTransparentSortingEnabled();
void cP_getTransparentSortingEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setTransparentSortingForced(bool enabled);
void cP_setTransparentSortingForced_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getTransparentSortingForced();
void cP_getTransparentSortingForced_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setIteratePerLight(bool enabled, bool onlyForOneLightType, Light::LightTypes lightType);
void cP_setIteratePerLight_c(struct hg3dclass_struct *classptr_c, int enabled_c, int onlyForOneLightType_c, enum EnumLightTypes lightType_c);
// original function: bool getIteratePerLight();
void cP_getIteratePerLight_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool getRunOnlyForOneLightType();
void cP_getRunOnlyForOneLightType_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: Light::LightTypes getOnlyLightType();
void cP_getOnlyLightType_c(struct hg3dclass_struct *classptr_c, enum EnumLightTypes * result_c);
// original function: void setLightCountPerIteration(unsigned short c);
void cP_setLightCountPerIteration_c(struct hg3dclass_struct *classptr_c, unsigned short c_c);
// original function: unsigned short getLightCountPerIteration();
void cP_getLightCountPerIteration_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: Technique* getParent();
void cP_getParent_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: const String& getResourceGroup();
void cP_getResourceGroup_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setVertexProgram(const String& name, bool resetParams);
void cP_setVertexProgram_c(struct hg3dclass_struct *classptr_c, char * name_c, int resetParams_c);
// original function: const String& getVertexProgramName();
void cP_getVertexProgramName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const GpuProgramPtr& getVertexProgram();
void cP_getVertexProgram_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: void setShadowCasterVertexProgram(const String& name);
void cP_setShadowCasterVertexProgram_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: const String& getShadowCasterVertexProgramName();
void cP_getShadowCasterVertexProgramName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const GpuProgramPtr& getShadowCasterVertexProgram();
void cP_getShadowCasterVertexProgram_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: void setShadowReceiverVertexProgram(const String& name);
void cP_setShadowReceiverVertexProgram_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void setShadowReceiverFragmentProgram(const String& name);
void cP_setShadowReceiverFragmentProgram_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: const String& getShadowReceiverVertexProgramName();
void cP_getShadowReceiverVertexProgramName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const GpuProgramPtr& getShadowReceiverVertexProgram();
void cP_getShadowReceiverVertexProgram_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: const String& getShadowReceiverFragmentProgramName();
void cP_getShadowReceiverFragmentProgramName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const GpuProgramPtr& getShadowReceiverFragmentProgram();
void cP_getShadowReceiverFragmentProgram_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: void setFragmentProgram(const String& name, bool resetParams);
void cP_setFragmentProgram_c(struct hg3dclass_struct *classptr_c, char * name_c, int resetParams_c);
// original function: const String& getFragmentProgramName();
void cP_getFragmentProgramName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const GpuProgramPtr& getFragmentProgram();
void cP_getFragmentProgram_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: void setGeometryProgram(const String& name, bool resetParams);
void cP_setGeometryProgram_c(struct hg3dclass_struct *classptr_c, char * name_c, int resetParams_c);
// original function: const String& getGeometryProgramName();
void cP_getGeometryProgramName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const GpuProgramPtr& getGeometryProgram();
void cP_getGeometryProgram_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: Pass* _split(unsigned short numUnits);
void cP__split_c(struct hg3dclass_struct *classptr_c, unsigned short numUnits_c, struct hg3dclass_struct * result_c);
// original function: void _notifyIndex(unsigned short index);
void cP__notifyIndex_c(struct hg3dclass_struct *classptr_c, unsigned short index_c);
// original function: void _prepare();
void cP__prepare_c(struct hg3dclass_struct *classptr_c);
// original function: void _unprepare();
void cP__unprepare_c(struct hg3dclass_struct *classptr_c);
// original function: void _load();
void cP__load_c(struct hg3dclass_struct *classptr_c);
// original function: void _unload();
void cP__unload_c(struct hg3dclass_struct *classptr_c);
// original function: bool isLoaded();
void cP_isLoaded_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: uint32 getHash();
void cP_getHash_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void _dirtyHash();
void cP__dirtyHash_c(struct hg3dclass_struct *classptr_c);
// original function: void _recalculateHash();
void cP__recalculateHash_c(struct hg3dclass_struct *classptr_c);
// original function: void _notifyNeedsRecompile();
void cP__notifyNeedsRecompile_c(struct hg3dclass_struct *classptr_c);
// original function: unsigned short _getTextureUnitWithContentTypeIndex(TextureUnitState::ContentType contentType, unsigned short index);
void cP__getTextureUnitWithContentTypeIndex_c(struct hg3dclass_struct *classptr_c, enum EnumContentType contentType_c, unsigned short index_c, unsigned short * result_c);
// original function: void setTextureFiltering(TextureFilterOptions filterType);
void cP_setTextureFiltering_c(struct hg3dclass_struct *classptr_c, enum EnumTextureFilterOptions filterType_c);
// original function: void setTextureAnisotropy(unsigned int maxAniso);
void cP_setTextureAnisotropy_c(struct hg3dclass_struct *classptr_c, unsigned int maxAniso_c);
// original function: void setNormaliseNormals(bool normalise);
void cP_setNormaliseNormals_c(struct hg3dclass_struct *classptr_c, int normalise_c);
// original function: bool getNormaliseNormals();
void cP_getNormaliseNormals_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void queueForDeletion();
void cP_queueForDeletion_c(struct hg3dclass_struct *classptr_c);
// original function: bool isAmbientOnly();
void cP_isAmbientOnly_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setPassIterationCount(const size_t count);
void cP_setPassIterationCount_c(struct hg3dclass_struct *classptr_c, int count_c);
// original function: size_t getPassIterationCount();
void cP_getPassIterationCount_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setLightScissoringEnabled(bool enabled);
void cP_setLightScissoringEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getLightScissoringEnabled();
void cP_getLightScissoringEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setLightClipPlanesEnabled(bool enabled);
void cP_setLightClipPlanesEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getLightClipPlanesEnabled();
void cP_getLightClipPlanesEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setIlluminationStage(IlluminationStage is);
void cP_setIlluminationStage_c(struct hg3dclass_struct *classptr_c, enum EnumIlluminationStage is_c);
// original function: IlluminationStage getIlluminationStage();
void cP_getIlluminationStage_c(struct hg3dclass_struct *classptr_c, enum EnumIlluminationStage * result_c);
