/*
This source file is part of HGamer3D
(A project to enable 3D game development in Haskell)
For the latest info, see http://www.althainz.de/HGamer3D.html

(c) 2011 Peter Althainz

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

typedef struct hg3dclass_struct {
	void *ptr;
	void *fptr;
} hg3dclass_struct;

void *getOgreClassPtr(hg3dclass_struct inSt, const char* className);

typedef void ClassItemIdentityException; 
hg3dclass_struct getOgreClass_ItemIdentityException(void *ptrIn);

typedef void ClassResourceGroupManager; 
hg3dclass_struct getOgreClass_ResourceGroupManager(void *ptrIn);

typedef void ClassMultiRenderTarget; 
hg3dclass_struct getOgreClass_MultiRenderTarget(void *ptrIn);

typedef void ClassTempBlendedBufferInfo; 
hg3dclass_struct getOgreClass_TempBlendedBufferInfo(void *ptrIn);

typedef void ClassCompositor; 
hg3dclass_struct getOgreClass_Compositor(void *ptrIn);

typedef void ClassTransformKeyFrame; 
hg3dclass_struct getOgreClass_TransformKeyFrame(void *ptrIn);

typedef void ClassSceneManager; 
hg3dclass_struct getOgreClass_SceneManager(void *ptrIn);

typedef void ClassRenderTarget; 
hg3dclass_struct getOgreClass_RenderTarget(void *ptrIn);

typedef void ClassInvalidStateException; 
hg3dclass_struct getOgreClass_InvalidStateException(void *ptrIn);

typedef void ClassBillboardSet; 
hg3dclass_struct getOgreClass_BillboardSet(void *ptrIn);

typedef void ClassSimpleRenderable; 
hg3dclass_struct getOgreClass_SimpleRenderable(void *ptrIn);

typedef void ClassMovableObjectFactory; 
hg3dclass_struct getOgreClass_MovableObjectFactory(void *ptrIn);

typedef void ClassParticleSystemFactory; 
hg3dclass_struct getOgreClass_ParticleSystemFactory(void *ptrIn);

typedef void ClassHardwareBufferLicensee; 
hg3dclass_struct getOgreClass_HardwareBufferLicensee(void *ptrIn);

typedef void ClassPlaneOptimalShadowCameraSetup; 
hg3dclass_struct getOgreClass_PlaneOptimalShadowCameraSetup(void *ptrIn);

typedef void ClassFileStreamDataStream; 
hg3dclass_struct getOgreClass_FileStreamDataStream(void *ptrIn);

typedef void ClassPatchMesh; 
hg3dclass_struct getOgreClass_PatchMesh(void *ptrIn);

typedef void ClassRenderQueueInvocation; 
hg3dclass_struct getOgreClass_RenderQueueInvocation(void *ptrIn);

typedef void ClassDefaultRaySceneQuery; 
hg3dclass_struct getOgreClass_DefaultRaySceneQuery(void *ptrIn);

typedef void ClassTextureManager; 
hg3dclass_struct getOgreClass_TextureManager(void *ptrIn);

typedef void ClassHardwareBufferManagerBase; 
hg3dclass_struct getOgreClass_HardwareBufferManagerBase(void *ptrIn);

typedef void ClassSubMesh; 
hg3dclass_struct getOgreClass_SubMesh(void *ptrIn);

typedef void ClassBillboardChain; 
hg3dclass_struct getOgreClass_BillboardChain(void *ptrIn);

typedef void ClassParticleAffector; 
hg3dclass_struct getOgreClass_ParticleAffector(void *ptrIn);

typedef void ClassMesh; 
hg3dclass_struct getOgreClass_Mesh(void *ptrIn);

typedef void ClassHighLevelGpuProgramFactory; 
hg3dclass_struct getOgreClass_HighLevelGpuProgramFactory(void *ptrIn);

typedef void ClassMaterialBucket; 
hg3dclass_struct getOgreClass_MaterialBucket(void *ptrIn);

typedef void ClassElement; 
hg3dclass_struct getOgreClass_Element(void *ptrIn);

typedef void ClassCompositorInstance; 
hg3dclass_struct getOgreClass_CompositorInstance(void *ptrIn);

typedef void ClassInvalidParametersException; 
hg3dclass_struct getOgreClass_InvalidParametersException(void *ptrIn);

typedef void ClassParticleEmitter; 
hg3dclass_struct getOgreClass_ParticleEmitter(void *ptrIn);

typedef void ClassDefaultSphereSceneQuery; 
hg3dclass_struct getOgreClass_DefaultSphereSceneQuery(void *ptrIn);

typedef void ClassException; 
hg3dclass_struct getOgreClass_Exception(void *ptrIn);

typedef void ClassHardwareBufferManager; 
hg3dclass_struct getOgreClass_HardwareBufferManager(void *ptrIn);

typedef void ClassKeyFrame; 
hg3dclass_struct getOgreClass_KeyFrame(void *ptrIn);

typedef void ClassOverlayManager; 
hg3dclass_struct getOgreClass_OverlayManager(void *ptrIn);

typedef void ClassDefaultSceneManagerFactory; 
hg3dclass_struct getOgreClass_DefaultSceneManagerFactory(void *ptrIn);

typedef void ClassLogManager; 
hg3dclass_struct getOgreClass_LogManager(void *ptrIn);

typedef void ClassCompositionTechnique; 
hg3dclass_struct getOgreClass_CompositionTechnique(void *ptrIn);

typedef void ClassFrustum; 
hg3dclass_struct getOgreClass_Frustum(void *ptrIn);

typedef void ClassMaterial; 
hg3dclass_struct getOgreClass_Material(void *ptrIn);

typedef void ClassFileHandleDataStream; 
hg3dclass_struct getOgreClass_FileHandleDataStream(void *ptrIn);

typedef void ClassDefaultSceneManager; 
hg3dclass_struct getOgreClass_DefaultSceneManager(void *ptrIn);

typedef void ClassGpuProgram; 
hg3dclass_struct getOgreClass_GpuProgram(void *ptrIn);

typedef void ClassCompositorChain; 
hg3dclass_struct getOgreClass_CompositorChain(void *ptrIn);

typedef void ClassBillboardSetFactory; 
hg3dclass_struct getOgreClass_BillboardSetFactory(void *ptrIn);

typedef void ClassMovableObject; 
hg3dclass_struct getOgreClass_MovableObject(void *ptrIn);

typedef void ClassIOException; 
hg3dclass_struct getOgreClass_IOException(void *ptrIn);

typedef void ClassLODBucket; 
hg3dclass_struct getOgreClass_LODBucket(void *ptrIn);

typedef void ClassBone; 
hg3dclass_struct getOgreClass_Bone(void *ptrIn);

typedef void ClassFileNotFoundException; 
hg3dclass_struct getOgreClass_FileNotFoundException(void *ptrIn);

typedef void ClassArchive; 
hg3dclass_struct getOgreClass_Archive(void *ptrIn);

typedef void ClassBillboardChainFactory; 
hg3dclass_struct getOgreClass_BillboardChainFactory(void *ptrIn);

typedef void ClassInternalErrorException; 
hg3dclass_struct getOgreClass_InternalErrorException(void *ptrIn);

typedef void ClassStringConverter; 
hg3dclass_struct getOgreClass_StringConverter(void *ptrIn);

typedef void ClassVertexPoseKeyFrame; 
hg3dclass_struct getOgreClass_VertexPoseKeyFrame(void *ptrIn);

typedef void ClassBillboard; 
hg3dclass_struct getOgreClass_Billboard(void *ptrIn);

typedef void ClassStringUtil; 
hg3dclass_struct getOgreClass_StringUtil(void *ptrIn);

typedef void ClassResourceGroupListener; 
hg3dclass_struct getOgreClass_ResourceGroupListener(void *ptrIn);

typedef void ClassAnimation; 
hg3dclass_struct getOgreClass_Animation(void *ptrIn);

typedef void ClassSceneNode; 
hg3dclass_struct getOgreClass_SceneNode(void *ptrIn);

typedef void ClassTimeIndex; 
hg3dclass_struct getOgreClass_TimeIndex(void *ptrIn);

typedef void ClassAnimationTrack; 
hg3dclass_struct getOgreClass_AnimationTrack(void *ptrIn);

typedef void ClassRegion; 
hg3dclass_struct getOgreClass_Region(void *ptrIn);

typedef void ClassHighLevelGpuProgram; 
hg3dclass_struct getOgreClass_HighLevelGpuProgram(void *ptrIn);

typedef void ClassLightFactory; 
hg3dclass_struct getOgreClass_LightFactory(void *ptrIn);

typedef void ClassLiSPSMShadowCameraSetup; 
hg3dclass_struct getOgreClass_LiSPSMShadowCameraSetup(void *ptrIn);

typedef void ClassPass; 
hg3dclass_struct getOgreClass_Pass(void *ptrIn);

typedef void ClassTextureUnitState; 
hg3dclass_struct getOgreClass_TextureUnitState(void *ptrIn);

typedef void ClassNumericAnimationTrack; 
hg3dclass_struct getOgreClass_NumericAnimationTrack(void *ptrIn);

typedef void ClassCmdManualNamedConstsFile; 
hg3dclass_struct getOgreClass_CmdManualNamedConstsFile(void *ptrIn);

typedef void ClassSkeletonInstance; 
hg3dclass_struct getOgreClass_SkeletonInstance(void *ptrIn);

typedef void ClassMeshSerializer; 
hg3dclass_struct getOgreClass_MeshSerializer(void *ptrIn);

typedef void ClassAnimationState; 
hg3dclass_struct getOgreClass_AnimationState(void *ptrIn);

typedef void ClassSceneManagerEnumerator; 
hg3dclass_struct getOgreClass_SceneManagerEnumerator(void *ptrIn);

typedef void ClassRenderingAPIException; 
hg3dclass_struct getOgreClass_RenderingAPIException(void *ptrIn);

typedef void ClassCmdPose; 
hg3dclass_struct getOgreClass_CmdPose(void *ptrIn);

typedef void ClassTechnique; 
hg3dclass_struct getOgreClass_Technique(void *ptrIn);

typedef void ClassManualObjectSectionShadowRenderable; 
hg3dclass_struct getOgreClass_ManualObjectSectionShadowRenderable(void *ptrIn);

typedef void ClassEntity; 
hg3dclass_struct getOgreClass_Entity(void *ptrIn);

typedef void ClassSceneManagerFactory; 
hg3dclass_struct getOgreClass_SceneManagerFactory(void *ptrIn);

typedef void ClassRenderWindow; 
hg3dclass_struct getOgreClass_RenderWindow(void *ptrIn);

typedef void ClassShadowCameraSetup; 
hg3dclass_struct getOgreClass_ShadowCameraSetup(void *ptrIn);

typedef void ClassRuntimeAssertionException; 
hg3dclass_struct getOgreClass_RuntimeAssertionException(void *ptrIn);

typedef void ClassRibbonTrailFactory; 
hg3dclass_struct getOgreClass_RibbonTrailFactory(void *ptrIn);

typedef void ClassSubEntity; 
hg3dclass_struct getOgreClass_SubEntity(void *ptrIn);

typedef void ClassManualObject; 
hg3dclass_struct getOgreClass_ManualObject(void *ptrIn);

typedef void ClassWindowEventListener; 
hg3dclass_struct getOgreClass_WindowEventListener(void *ptrIn);

typedef void ClassHardwareIndexBuffer; 
hg3dclass_struct getOgreClass_HardwareIndexBuffer(void *ptrIn);

typedef void ClassGpuProgramManager; 
hg3dclass_struct getOgreClass_GpuProgramManager(void *ptrIn);

typedef void ClassOverlay; 
hg3dclass_struct getOgreClass_Overlay(void *ptrIn);

typedef void ClassStaticGeometry; 
hg3dclass_struct getOgreClass_StaticGeometry(void *ptrIn);

typedef void ClassRibbonTrail; 
hg3dclass_struct getOgreClass_RibbonTrail(void *ptrIn);

typedef void ClassManualObjectSection; 
hg3dclass_struct getOgreClass_ManualObjectSection(void *ptrIn);

typedef void ClassVertexAnimationTrack; 
hg3dclass_struct getOgreClass_VertexAnimationTrack(void *ptrIn);

typedef void ClassArchiveManager; 
hg3dclass_struct getOgreClass_ArchiveManager(void *ptrIn);

typedef void ClassSkeleton; 
hg3dclass_struct getOgreClass_Skeleton(void *ptrIn);

typedef void ClassSkeletonSerializer; 
hg3dclass_struct getOgreClass_SkeletonSerializer(void *ptrIn);

typedef void ClassConfigFile; 
hg3dclass_struct getOgreClass_ConfigFile(void *ptrIn);

typedef void ClassRoot; 
hg3dclass_struct getOgreClass_Root(void *ptrIn);

typedef void ClassHardwarePixelBuffer; 
hg3dclass_struct getOgreClass_HardwarePixelBuffer(void *ptrIn);

typedef void ClassResourceManager; 
hg3dclass_struct getOgreClass_ResourceManager(void *ptrIn);

typedef void ClassOverlayContainer; 
hg3dclass_struct getOgreClass_OverlayContainer(void *ptrIn);

typedef void ClassWindowEventUtilities; 
hg3dclass_struct getOgreClass_WindowEventUtilities(void *ptrIn);

typedef void ClassControllerManager; 
hg3dclass_struct getOgreClass_ControllerManager(void *ptrIn);

typedef void ClassMaterialSerializer; 
hg3dclass_struct getOgreClass_MaterialSerializer(void *ptrIn);

typedef void ClassNodeAnimationTrack; 
hg3dclass_struct getOgreClass_NodeAnimationTrack(void *ptrIn);

typedef void ClassLight; 
hg3dclass_struct getOgreClass_Light(void *ptrIn);

typedef void ClassDefaultShadowCameraSetup; 
hg3dclass_struct getOgreClass_DefaultShadowCameraSetup(void *ptrIn);

typedef void ClassCompositionTargetPass; 
hg3dclass_struct getOgreClass_CompositionTargetPass(void *ptrIn);

typedef void ClassRenderTexture; 
hg3dclass_struct getOgreClass_RenderTexture(void *ptrIn);

typedef void ClassCompositorManager; 
hg3dclass_struct getOgreClass_CompositorManager(void *ptrIn);

typedef void ClassEntityFactory; 
hg3dclass_struct getOgreClass_EntityFactory(void *ptrIn);

typedef void ClassMemoryDataStream; 
hg3dclass_struct getOgreClass_MemoryDataStream(void *ptrIn);

typedef void ClassHardwareOcclusionQuery; 
hg3dclass_struct getOgreClass_HardwareOcclusionQuery(void *ptrIn);

typedef void ClassPSSMShadowCameraSetup; 
hg3dclass_struct getOgreClass_PSSMShadowCameraSetup(void *ptrIn);

typedef void ClassVertexMorphKeyFrame; 
hg3dclass_struct getOgreClass_VertexMorphKeyFrame(void *ptrIn);

typedef void ClassNode; 
hg3dclass_struct getOgreClass_Node(void *ptrIn);

typedef void ClassPatchSurface; 
hg3dclass_struct getOgreClass_PatchSurface(void *ptrIn);

typedef void ClassManualObjectFactory; 
hg3dclass_struct getOgreClass_ManualObjectFactory(void *ptrIn);

typedef void ClassNumericKeyFrame; 
hg3dclass_struct getOgreClass_NumericKeyFrame(void *ptrIn);

typedef void ClassDataStream; 
hg3dclass_struct getOgreClass_DataStream(void *ptrIn);

typedef void ClassRenderObjectListener; 
hg3dclass_struct getOgreClass_RenderObjectListener(void *ptrIn);

typedef void ClassGeometryBucket; 
hg3dclass_struct getOgreClass_GeometryBucket(void *ptrIn);

typedef void ClassViewport; 
hg3dclass_struct getOgreClass_Viewport(void *ptrIn);

typedef void ClassDefaultPlaneBoundedVolumeListSceneQuery; 
hg3dclass_struct getOgreClass_DefaultPlaneBoundedVolumeListSceneQuery(void *ptrIn);

typedef void ClassCompositionPass; 
hg3dclass_struct getOgreClass_CompositionPass(void *ptrIn);

typedef void ClassSceneMgrQueuedRenderableVisitor; 
hg3dclass_struct getOgreClass_SceneMgrQueuedRenderableVisitor(void *ptrIn);

typedef void ClassRenderSystemOperation; 
hg3dclass_struct getOgreClass_RenderSystemOperation(void *ptrIn);

typedef void ClassUnimplementedException; 
hg3dclass_struct getOgreClass_UnimplementedException(void *ptrIn);

typedef void ClassRenderQueueInvocationSequence; 
hg3dclass_struct getOgreClass_RenderQueueInvocationSequence(void *ptrIn);

typedef void ClassDefaultAxisAlignedBoxSceneQuery; 
hg3dclass_struct getOgreClass_DefaultAxisAlignedBoxSceneQuery(void *ptrIn);

typedef void ClassMaterialManager; 
hg3dclass_struct getOgreClass_MaterialManager(void *ptrIn);

typedef void ClassCamera; 
hg3dclass_struct getOgreClass_Camera(void *ptrIn);

