// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassRenderTarget.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreRenderTarget.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumPixelFormat.h"


// original function: const String& getName();
void cRt_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void update(bool swapBuffers);
void cRt_update_c(struct hg3dclass_struct *classptr_c, int swapBuffers_c);
// original function: void swapBuffers(bool waitForVSync);
void cRt_swapBuffers_c(struct hg3dclass_struct *classptr_c, int waitForVSync_c);
// original function: Viewport* addViewport(Camera* cam, int ZOrder, float left, float top, float width, float height);
void cRt_addViewport_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cam_c, int ZOrder_c, float left_c, float top_c, float width_c, float height_c, struct hg3dclass_struct * result_c);
// original function: unsigned short getNumViewports();
void cRt_getNumViewports_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: Viewport* getViewport(unsigned short index);
void cRt_getViewport_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: void removeViewport(int ZOrder);
void cRt_removeViewport_c(struct hg3dclass_struct *classptr_c, int ZOrder_c);
// original function: void removeAllViewports();
void cRt_removeAllViewports_c(struct hg3dclass_struct *classptr_c);
// original function: float getLastFPS();
void cRt_getLastFPS_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: float getAverageFPS();
void cRt_getAverageFPS_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: float getBestFPS();
void cRt_getBestFPS_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: float getWorstFPS();
void cRt_getWorstFPS_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: float getBestFrameTime();
void cRt_getBestFrameTime_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: float getWorstFrameTime();
void cRt_getWorstFrameTime_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void resetStatistics();
void cRt_resetStatistics_c(struct hg3dclass_struct *classptr_c);
// original function: void removeAllListeners();
void cRt_removeAllListeners_c(struct hg3dclass_struct *classptr_c);
// original function: bool isActive();
void cRt_isActive_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setActive(bool state);
void cRt_setActive_c(struct hg3dclass_struct *classptr_c, int state_c);
// original function: void setAutoUpdated(bool autoupdate);
void cRt_setAutoUpdated_c(struct hg3dclass_struct *classptr_c, int autoupdate_c);
// original function: bool isAutoUpdated();
void cRt_isAutoUpdated_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: PixelFormat suggestPixelFormat();
void cRt_suggestPixelFormat_c(struct hg3dclass_struct *classptr_c, enum EnumPixelFormat * result_c);
// original function: void writeContentsToFile(const String& filename);
void cRt_writeContentsToFile_c(struct hg3dclass_struct *classptr_c, char * filename_c);
// original function: String writeContentsToTimestampedFile(const String& filenamePrefix, const String& filenameSuffix);
void cRt_writeContentsToTimestampedFile_c(struct hg3dclass_struct *classptr_c, char * filenamePrefix_c, char * filenameSuffix_c, char * result_c);
// original function: size_t getTriangleCount();
void cRt_getTriangleCount_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: size_t getBatchCount();
void cRt_getBatchCount_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isPrimary();
void cRt_isPrimary_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isHardwareGammaEnabled();
void cRt_isHardwareGammaEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: uint getFSAA();
void cRt_getFSAA_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: const String& getFSAAHint();
void cRt_getFSAAHint_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void _beginUpdate();
void cRt__beginUpdate_c(struct hg3dclass_struct *classptr_c);
// original function: void _updateViewport(int zorder, bool updateStatistics);
void cRt__updateViewport_c(struct hg3dclass_struct *classptr_c, int zorder_c, int updateStatistics_c);
// original function: void _updateViewport(Viewport* viewport, bool updateStatistics);
void cRt__updateViewport2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * viewport_c, int updateStatistics_c);
// original function: void _updateAutoUpdatedViewports(bool updateStatistics);
void cRt__updateAutoUpdatedViewports_c(struct hg3dclass_struct *classptr_c, int updateStatistics_c);
