// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassRenderWindow.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreRenderWindow.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumPixelFormat.h"


// original function: void setFullscreen(bool fullScreen, unsigned int width, unsigned int height);
void cRw_setFullscreen_c(struct hg3dclass_struct *classptr_c, int fullScreen_c, unsigned int width_c, unsigned int height_c);
// original function: void destroy();
void cRw_destroy_c(struct hg3dclass_struct *classptr_c);
// original function: void resize(unsigned int width, unsigned int height);
void cRw_resize_c(struct hg3dclass_struct *classptr_c, unsigned int width_c, unsigned int height_c);
// original function: void windowMovedOrResized();
void cRw_windowMovedOrResized_c(struct hg3dclass_struct *classptr_c);
// original function: void reposition(int left, int top);
void cRw_reposition_c(struct hg3dclass_struct *classptr_c, int left_c, int top_c);
// original function: bool isVisible();
void cRw_isVisible_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setVisible(bool visible);
void cRw_setVisible_c(struct hg3dclass_struct *classptr_c, int visible_c);
// original function: bool isActive();
void cRw_isActive_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isClosed();
void cRw_isClosed_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isPrimary();
void cRw_isPrimary_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isFullScreen();
void cRw_isFullScreen_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: PixelFormat suggestPixelFormat();
void cRw_suggestPixelFormat_c(struct hg3dclass_struct *classptr_c, enum EnumPixelFormat * result_c);
// original function: bool isDeactivatedOnFocusChange();
void cRw_isDeactivatedOnFocusChange_c(struct hg3dclass_struct *classptr_c, int * result_c);
