// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassResourceGroupListener.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreResourceGroupManager.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"


// original function: void resourceGroupScriptingStarted(const String& groupName, size_t scriptCount);
void cRgl_resourceGroupScriptingStarted_c(struct hg3dclass_struct *classptr_c, char * groupName_c, int scriptCount_c);
// original function: void scriptParseEnded(const String& scriptName, bool skipped);
void cRgl_scriptParseEnded_c(struct hg3dclass_struct *classptr_c, char * scriptName_c, int skipped_c);
// original function: void resourceGroupScriptingEnded(const String& groupName);
void cRgl_resourceGroupScriptingEnded_c(struct hg3dclass_struct *classptr_c, char * groupName_c);
// original function: void resourceGroupPrepareStarted(const String& groupName, size_t resourceCount);
void cRgl_resourceGroupPrepareStarted_c(struct hg3dclass_struct *classptr_c, char * groupName_c, int resourceCount_c);
// original function: void resourcePrepareStarted(const ResourcePtr& resource);
void cRgl_resourcePrepareStarted_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * resource_c);
// original function: void resourcePrepareEnded();
void cRgl_resourcePrepareEnded_c(struct hg3dclass_struct *classptr_c);
// original function: void worldGeometryPrepareStageStarted(const String& description);
void cRgl_worldGeometryPrepareStageStarted_c(struct hg3dclass_struct *classptr_c, char * description_c);
// original function: void worldGeometryPrepareStageEnded();
void cRgl_worldGeometryPrepareStageEnded_c(struct hg3dclass_struct *classptr_c);
// original function: void resourceGroupPrepareEnded(const String& groupName);
void cRgl_resourceGroupPrepareEnded_c(struct hg3dclass_struct *classptr_c, char * groupName_c);
// original function: void resourceGroupLoadStarted(const String& groupName, size_t resourceCount);
void cRgl_resourceGroupLoadStarted_c(struct hg3dclass_struct *classptr_c, char * groupName_c, int resourceCount_c);
// original function: void resourceLoadStarted(const ResourcePtr& resource);
void cRgl_resourceLoadStarted_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * resource_c);
// original function: void resourceLoadEnded();
void cRgl_resourceLoadEnded_c(struct hg3dclass_struct *classptr_c);
// original function: void worldGeometryStageStarted(const String& description);
void cRgl_worldGeometryStageStarted_c(struct hg3dclass_struct *classptr_c, char * description_c);
// original function: void worldGeometryStageEnded();
void cRgl_worldGeometryStageEnded_c(struct hg3dclass_struct *classptr_c);
// original function: void resourceGroupLoadEnded(const String& groupName);
void cRgl_resourceGroupLoadEnded_c(struct hg3dclass_struct *classptr_c, char * groupName_c);
