// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassResourceGroupManager.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreResourceGroupManager.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"


// original function: void createResourceGroup(const String& name, const bool inGlobalPool);
void cRgm_createResourceGroup_c(struct hg3dclass_struct *classptr_c, char * name_c, int inGlobalPool_c);
// original function: void initialiseResourceGroup(const String& name);
void cRgm_initialiseResourceGroup_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void initialiseAllResourceGroups();
void cRgm_initialiseAllResourceGroups_c(struct hg3dclass_struct *classptr_c);
// original function: void prepareResourceGroup(const String& name, bool prepareMainResources, bool prepareWorldGeom);
void cRgm_prepareResourceGroup_c(struct hg3dclass_struct *classptr_c, char * name_c, int prepareMainResources_c, int prepareWorldGeom_c);
// original function: void loadResourceGroup(const String& name, bool loadMainResources, bool loadWorldGeom);
void cRgm_loadResourceGroup_c(struct hg3dclass_struct *classptr_c, char * name_c, int loadMainResources_c, int loadWorldGeom_c);
// original function: void unloadResourceGroup(const String& name, bool reloadableOnly);
void cRgm_unloadResourceGroup_c(struct hg3dclass_struct *classptr_c, char * name_c, int reloadableOnly_c);
// original function: void unloadUnreferencedResourcesInGroup(const String& name, bool reloadableOnly);
void cRgm_unloadUnreferencedResourcesInGroup_c(struct hg3dclass_struct *classptr_c, char * name_c, int reloadableOnly_c);
// original function: void clearResourceGroup(const String& name);
void cRgm_clearResourceGroup_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyResourceGroup(const String& name);
void cRgm_destroyResourceGroup_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: bool isResourceGroupInitialised(const String& name);
void cRgm_isResourceGroupInitialised_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: bool isResourceGroupLoaded(const String& name);
void cRgm_isResourceGroupLoaded_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: bool resourceGroupExists(const String& name);
void cRgm_resourceGroupExists_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void addResourceLocation(const String& name, const String& locType, const String& resGroup, bool recursive);
void cRgm_addResourceLocation_c(struct hg3dclass_struct *classptr_c, char * name_c, char * locType_c, char * resGroup_c, int recursive_c);
// original function: void removeResourceLocation(const String& name, const String& resGroup);
void cRgm_removeResourceLocation_c(struct hg3dclass_struct *classptr_c, char * name_c, char * resGroup_c);
// original function: bool resourceLocationExists(const String& name, const String& resGroup);
void cRgm_resourceLocationExists_c(struct hg3dclass_struct *classptr_c, char * name_c, char * resGroup_c, int * result_c);
// original function: void undeclareResource(const String& name, const String& groupName);
void cRgm_undeclareResource_c(struct hg3dclass_struct *classptr_c, char * name_c, char * groupName_c);
// original function: DataStreamListPtr openResources(const String& pattern, const String& groupName);
void cRgm_openResources_c(struct hg3dclass_struct *classptr_c, char * pattern_c, char * groupName_c, struct sharedptr_struct * result_c);
// original function: StringVectorPtr listResourceNames(const String& groupName, bool dirs);
void cRgm_listResourceNames_c(struct hg3dclass_struct *classptr_c, char * groupName_c, int dirs_c, struct sharedptr_struct * result_c);
// original function: FileInfoListPtr listResourceFileInfo(const String& groupName, bool dirs);
void cRgm_listResourceFileInfo_c(struct hg3dclass_struct *classptr_c, char * groupName_c, int dirs_c, struct sharedptr_struct * result_c);
// original function: StringVectorPtr findResourceNames(const String& groupName, const String& pattern, bool dirs);
void cRgm_findResourceNames_c(struct hg3dclass_struct *classptr_c, char * groupName_c, char * pattern_c, int dirs_c, struct sharedptr_struct * result_c);
// original function: bool resourceExists(const String& group, const String& filename);
void cRgm_resourceExists_c(struct hg3dclass_struct *classptr_c, char * group_c, char * filename_c, int * result_c);
// original function: bool resourceExistsInAnyGroup(const String& filename);
void cRgm_resourceExistsInAnyGroup_c(struct hg3dclass_struct *classptr_c, char * filename_c, int * result_c);
// original function: const String& findGroupContainingResource(const String& filename);
void cRgm_findGroupContainingResource_c(struct hg3dclass_struct *classptr_c, char * filename_c, char * result_c);
// original function: FileInfoListPtr findResourceFileInfo(const String& group, const String& pattern, bool dirs);
void cRgm_findResourceFileInfo_c(struct hg3dclass_struct *classptr_c, char * group_c, char * pattern_c, int dirs_c, struct sharedptr_struct * result_c);
// original function: StringVectorPtr listResourceLocations(const String& groupName);
void cRgm_listResourceLocations_c(struct hg3dclass_struct *classptr_c, char * groupName_c, struct sharedptr_struct * result_c);
// original function: StringVectorPtr findResourceLocation(const String& groupName, const String& pattern);
void cRgm_findResourceLocation_c(struct hg3dclass_struct *classptr_c, char * groupName_c, char * pattern_c, struct sharedptr_struct * result_c);
// original function: DataStreamPtr createResource(const String& filename, const String& groupName, bool overwrite, const String& locationPattern);
void cRgm_createResource_c(struct hg3dclass_struct *classptr_c, char * filename_c, char * groupName_c, int overwrite_c, char * locationPattern_c, struct sharedptr_struct * result_c);
// original function: void deleteResource(const String& filename, const String& groupName, const String& locationPattern);
void cRgm_deleteResource_c(struct hg3dclass_struct *classptr_c, char * filename_c, char * groupName_c, char * locationPattern_c);
// original function: void deleteMatchingResources(const String& filePattern, const String& groupName, const String& locationPattern);
void cRgm_deleteMatchingResources_c(struct hg3dclass_struct *classptr_c, char * filePattern_c, char * groupName_c, char * locationPattern_c);
// original function: void addResourceGroupListener(ResourceGroupListener* l);
void cRgm_addResourceGroupListener_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * l_c);
// original function: void removeResourceGroupListener(ResourceGroupListener* l);
void cRgm_removeResourceGroupListener_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * l_c);
// original function: void setWorldResourceGroupName(const String& groupName);
void cRgm_setWorldResourceGroupName_c(struct hg3dclass_struct *classptr_c, char * groupName_c);
// original function: const String& getWorldResourceGroupName();
void cRgm_getWorldResourceGroupName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void linkWorldGeometryToResourceGroup(const String& group, const String& worldGeometry, SceneManager* sceneManager);
void cRgm_linkWorldGeometryToResourceGroup_c(struct hg3dclass_struct *classptr_c, char * group_c, char * worldGeometry_c, struct hg3dclass_struct * sceneManager_c);
// original function: void unlinkWorldGeometryFromResourceGroup(const String& group);
void cRgm_unlinkWorldGeometryFromResourceGroup_c(struct hg3dclass_struct *classptr_c, char * group_c);
// original function: bool isResourceGroupInGlobalPool(const String& name);
void cRgm_isResourceGroupInGlobalPool_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void shutdownAll();
void cRgm_shutdownAll_c(struct hg3dclass_struct *classptr_c);
// original function: void _registerResourceManager(const String& resourceType, ResourceManager* rm);
void cRgm__registerResourceManager_c(struct hg3dclass_struct *classptr_c, char * resourceType_c, struct hg3dclass_struct * rm_c);
// original function: void _unregisterResourceManager(const String& resourceType);
void cRgm__unregisterResourceManager_c(struct hg3dclass_struct *classptr_c, char * resourceType_c);
// original function: ResourceManager* _getResourceManager(const String& resourceType);
void cRgm__getResourceManager_c(struct hg3dclass_struct *classptr_c, char * resourceType_c, struct hg3dclass_struct * result_c);
// original function: void _notifyResourceCreated(ResourcePtr& res);
void cRgm__notifyResourceCreated_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * res_c);
// original function: void _notifyResourceRemoved(ResourcePtr& res);
void cRgm__notifyResourceRemoved_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * res_c);
// original function: void _notifyAllResourcesRemoved(ResourceManager* manager);
void cRgm__notifyAllResourcesRemoved_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * manager_c);
// original function: void _notifyWorldGeometryStageStarted(const String& description);
void cRgm__notifyWorldGeometryStageStarted_c(struct hg3dclass_struct *classptr_c, char * description_c);
// original function: void _notifyWorldGeometryStageEnded();
void cRgm__notifyWorldGeometryStageEnded_c(struct hg3dclass_struct *classptr_c);
// created singleton getSingletonPtr function
void cRgm_getSingletonPtr_c(struct hg3dclass_struct *result_c);
