// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassResourceManager.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreResourceManager.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"


// original function: void setMemoryBudget(size_t bytes);
void cRm_setMemoryBudget_c(struct hg3dclass_struct *classptr_c, int bytes_c);
// original function: size_t getMemoryBudget();
void cRm_getMemoryBudget_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: size_t getMemoryUsage();
void cRm_getMemoryUsage_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void unload(const String& name);
void cRm_unload_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void unloadAll(bool reloadableOnly);
void cRm_unloadAll_c(struct hg3dclass_struct *classptr_c, int reloadableOnly_c);
// original function: void reloadAll(bool reloadableOnly);
void cRm_reloadAll_c(struct hg3dclass_struct *classptr_c, int reloadableOnly_c);
// original function: void unloadUnreferencedResources(bool reloadableOnly);
void cRm_unloadUnreferencedResources_c(struct hg3dclass_struct *classptr_c, int reloadableOnly_c);
// original function: void reloadUnreferencedResources(bool reloadableOnly);
void cRm_reloadUnreferencedResources_c(struct hg3dclass_struct *classptr_c, int reloadableOnly_c);
// original function: void remove(ResourcePtr& r);
void cRm_remove_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * r_c);
// original function: void remove(const String& name);
void cRm_remove2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void removeAll();
void cRm_removeAll_c(struct hg3dclass_struct *classptr_c);
// original function: void removeUnreferencedResources(bool reloadableOnly);
void cRm_removeUnreferencedResources_c(struct hg3dclass_struct *classptr_c, int reloadableOnly_c);
// original function: ResourcePtr getByName(const String& name, const String& groupName);
void cRm_getByName_c(struct hg3dclass_struct *classptr_c, char * name_c, char * groupName_c, struct sharedptr_struct * result_c);
// original function: bool resourceExists(const String& name);
void cRm_resourceExists_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void parseScript(DataStreamPtr& stream, const String& groupName);
void cRm_parseScript_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * stream_c, char * groupName_c);
// original function: Real getLoadingOrder();
void cRm_getLoadingOrder_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: const String& getResourceType();
void cRm_getResourceType_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setVerbose(bool v);
void cRm_setVerbose_c(struct hg3dclass_struct *classptr_c, int v_c);
// original function: bool getVerbose();
void cRm_getVerbose_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void destroyResourcePool(const String& name);
void cRm_destroyResourcePool2_c(struct hg3dclass_struct *classptr_c, char * name_c);
