// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassRibbonTrail.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreRibbonTrail.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeColour.h"


// original function: void addNode(Node* n);
void cRtr_addNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * n_c);
// original function: void removeNode(Node* n);
void cRtr_removeNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * n_c);
// original function: void setTrailLength(Real len);
void cRtr_setTrailLength_c(struct hg3dclass_struct *classptr_c, float len_c);
// original function: Real getTrailLength();
void cRtr_getTrailLength_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setMaxChainElements(size_t maxElements);
void cRtr_setMaxChainElements_c(struct hg3dclass_struct *classptr_c, int maxElements_c);
// original function: void setNumberOfChains(size_t numChains);
void cRtr_setNumberOfChains_c(struct hg3dclass_struct *classptr_c, int numChains_c);
// original function: void clearChain(size_t chainIndex);
void cRtr_clearChain_c(struct hg3dclass_struct *classptr_c, int chainIndex_c);
// original function: void setInitialColour(size_t chainIndex, const ColourValue& col);
void cRtr_setInitialColour_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, struct colourvalue_struct * col_c);
// original function: void setInitialColour(size_t chainIndex, Real r, Real g, Real b, Real a);
void cRtr_setInitialColour2_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, float r_c, float g_c, float b_c, float a_c);
// original function: const ColourValue& getInitialColour(size_t chainIndex);
void cRtr_getInitialColour_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, struct colourvalue_struct * result_c);
// original function: void setColourChange(size_t chainIndex, const ColourValue& valuePerSecond);
void cRtr_setColourChange_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, struct colourvalue_struct * valuePerSecond_c);
// original function: void setInitialWidth(size_t chainIndex, Real width);
void cRtr_setInitialWidth_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, float width_c);
// original function: Real getInitialWidth(size_t chainIndex);
void cRtr_getInitialWidth_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, float * result_c);
// original function: void setWidthChange(size_t chainIndex, Real widthDeltaPerSecond);
void cRtr_setWidthChange_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, float widthDeltaPerSecond_c);
// original function: Real getWidthChange(size_t chainIndex);
void cRtr_getWidthChange_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, float * result_c);
// original function: void setColourChange(size_t chainIndex, Real r, Real g, Real b, Real a);
void cRtr_setColourChange2_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, float r_c, float g_c, float b_c, float a_c);
// original function: const ColourValue& getColourChange(size_t chainIndex);
void cRtr_getColourChange_c(struct hg3dclass_struct *classptr_c, int chainIndex_c, struct colourvalue_struct * result_c);
// original function: void _timeUpdate(Real time);
void cRtr__timeUpdate_c(struct hg3dclass_struct *classptr_c, float time_c);
