// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassRoot.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreRoot.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"
#include "TypeColour.h"


// original function: void saveConfig();
void cR_saveConfig_c(struct hg3dclass_struct *classptr_c);
// original function: bool restoreConfig();
void cR_restoreConfig_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool showConfigDialog();
void cR_showConfigDialog_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: RenderWindow* initialise(bool autoCreateWindow, const String& windowTitle, const String& customCapabilitiesConfig);
void cR_initialise_c(struct hg3dclass_struct *classptr_c, int autoCreateWindow_c, char * windowTitle_c, char * customCapabilitiesConfig_c, struct hg3dclass_struct * result_c);
// original function: bool isInitialised();
void cR_isInitialised_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool getRemoveRenderQueueStructuresOnClear();
void cR_getRemoveRenderQueueStructuresOnClear_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setRemoveRenderQueueStructuresOnClear(bool r);
void cR_setRemoveRenderQueueStructuresOnClear_c(struct hg3dclass_struct *classptr_c, int r_c);
// original function: void addSceneManagerFactory(SceneManagerFactory* fact);
void cR_addSceneManagerFactory_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * fact_c);
// original function: void removeSceneManagerFactory(SceneManagerFactory* fact);
void cR_removeSceneManagerFactory_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * fact_c);
// original function: SceneManager* createSceneManager(const String& typeName, const String& instanceName);
void cR_createSceneManager_c(struct hg3dclass_struct *classptr_c, char * typeName_c, char * instanceName_c, struct hg3dclass_struct * result_c);
// original function: SceneManager* createSceneManager(SceneTypeMask typeMask, const String& instanceName);
void cR_createSceneManager2_c(struct hg3dclass_struct *classptr_c, unsigned short typeMask_c, char * instanceName_c, struct hg3dclass_struct * result_c);
// original function: void destroySceneManager(SceneManager* sm);
void cR_destroySceneManager_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * sm_c);
// original function: SceneManager* getSceneManager(const String& instanceName);
void cR_getSceneManager_c(struct hg3dclass_struct *classptr_c, char * instanceName_c, struct hg3dclass_struct * result_c);
// original function: bool hasSceneManager(const String& instanceName);
void cR_hasSceneManager_c(struct hg3dclass_struct *classptr_c, char * instanceName_c, int * result_c);
// original function: TextureManager* getTextureManager();
void cR_getTextureManager_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: String getErrorDescription(long errorNumber);
void cR_getErrorDescription_c(struct hg3dclass_struct *classptr_c, int errorNumber_c, char * result_c);
// original function: void queueEndRendering();
void cR_queueEndRendering_c(struct hg3dclass_struct *classptr_c);
// original function: void startRendering();
void cR_startRendering_c(struct hg3dclass_struct *classptr_c);
// original function: bool renderOneFrame();
void cR_renderOneFrame_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool renderOneFrame(Real timeSinceLastFrame);
void cR_renderOneFrame2_c(struct hg3dclass_struct *classptr_c, float timeSinceLastFrame_c, int * result_c);
// original function: void shutdown();
void cR_shutdown_c(struct hg3dclass_struct *classptr_c);
// original function: void addResourceLocation(const String& name, const String& locType, const String& groupName, bool recursive);
void cR_addResourceLocation_c(struct hg3dclass_struct *classptr_c, char * name_c, char * locType_c, char * groupName_c, int recursive_c);
// original function: void removeResourceLocation(const String& name, const String& groupName);
void cR_removeResourceLocation_c(struct hg3dclass_struct *classptr_c, char * name_c, char * groupName_c);
// original function: DataStreamPtr createFileStream(const String& filename, const String& groupName, bool overwrite, const String& locationPattern);
void cR_createFileStream_c(struct hg3dclass_struct *classptr_c, char * filename_c, char * groupName_c, int overwrite_c, char * locationPattern_c, struct sharedptr_struct * result_c);
// original function: DataStreamPtr openFileStream(const String& filename, const String& groupName, const String& locationPattern);
void cR_openFileStream_c(struct hg3dclass_struct *classptr_c, char * filename_c, char * groupName_c, char * locationPattern_c, struct sharedptr_struct * result_c);
// original function: void convertColourValue(const ColourValue& colour, uint32* pDest);
void cR_convertColourValue_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colour_c, unsigned int * pDest_c);
// original function: RenderWindow* getAutoCreatedWindow();
void cR_getAutoCreatedWindow_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void detachRenderTarget(RenderTarget* pWin);
void cR_detachRenderTarget_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * pWin_c);
// original function: void detachRenderTarget(const String & name);
void cR_detachRenderTarget2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyRenderTarget(RenderTarget* target);
void cR_destroyRenderTarget_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * target_c);
// original function: void destroyRenderTarget(const String & name);
void cR_destroyRenderTarget2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: RenderTarget * getRenderTarget(const String & name);
void cR_getRenderTarget_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: void loadPlugin(const String& pluginName);
void cR_loadPlugin_c(struct hg3dclass_struct *classptr_c, char * pluginName_c);
// original function: void unloadPlugin(const String& pluginName);
void cR_unloadPlugin_c(struct hg3dclass_struct *classptr_c, char * pluginName_c);
// original function: bool _fireFrameStarted();
void cR__fireFrameStarted2_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool _fireFrameRenderingQueued();
void cR__fireFrameRenderingQueued2_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool _fireFrameEnded();
void cR__fireFrameEnded2_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: SceneManager* _getCurrentSceneManager();
void cR__getCurrentSceneManager_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void _pushCurrentSceneManager(SceneManager* sm);
void cR__pushCurrentSceneManager_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * sm_c);
// original function: void _popCurrentSceneManager(SceneManager* sm);
void cR__popCurrentSceneManager_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * sm_c);
// original function: bool _updateAllRenderTargets();
void cR__updateAllRenderTargets_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: RenderQueueInvocationSequence* createRenderQueueInvocationSequence(const String& name);
void cR_createRenderQueueInvocationSequence_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: RenderQueueInvocationSequence* getRenderQueueInvocationSequence(const String& name);
void cR_getRenderQueueInvocationSequence_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: void destroyRenderQueueInvocationSequence(const String& name);
void cR_destroyRenderQueueInvocationSequence_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllRenderQueueInvocationSequences();
void cR_destroyAllRenderQueueInvocationSequences_c(struct hg3dclass_struct *classptr_c);
// original function: void clearEventTimes();
void cR_clearEventTimes_c(struct hg3dclass_struct *classptr_c);
// original function: void setFrameSmoothingPeriod(Real period);
void cR_setFrameSmoothingPeriod_c(struct hg3dclass_struct *classptr_c, float period_c);
// original function: Real getFrameSmoothingPeriod();
void cR_getFrameSmoothingPeriod_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void addMovableObjectFactory(MovableObjectFactory* fact, bool overrideExisting);
void cR_addMovableObjectFactory_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * fact_c, int overrideExisting_c);
// original function: void removeMovableObjectFactory(MovableObjectFactory* fact);
void cR_removeMovableObjectFactory_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * fact_c);
// original function: bool hasMovableObjectFactory(const String& typeName);
void cR_hasMovableObjectFactory_c(struct hg3dclass_struct *classptr_c, char * typeName_c, int * result_c);
// original function: MovableObjectFactory* getMovableObjectFactory(const String& typeName);
void cR_getMovableObjectFactory_c(struct hg3dclass_struct *classptr_c, char * typeName_c, struct hg3dclass_struct * result_c);
// original function: uint32 _allocateNextMovableObjectTypeFlag();
void cR__allocateNextMovableObjectTypeFlag_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: unsigned int getDisplayMonitorCount();
void cR_getDisplayMonitorCount_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// created constructor function from default constructor
void cR_newRoot_c(struct hg3dclass_struct *result_c);
