// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassSceneManager.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreSceneManager.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumPrefabType.h"
#include "TypeColour.h"
#include "TypeSharedPtr.h"
#include "TypeQuaternion.h"
#include "EnumFogMode.h"
#include "EnumSpecialCaseRenderQueueMode.h"
#include "EnumShadowTechnique.h"
#include "EnumPixelFormat.h"
#include "EnumLightTypes.h"


// original function: const String& getName();
void cSm_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const String& getTypeName();
void cSm_getTypeName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: Camera* createCamera(const String& name);
void cSm_createCamera_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: Camera* getCamera(const String& name);
void cSm_getCamera_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasCamera(const String& name);
void cSm_hasCamera_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyCamera(Camera * cam);
void cSm_destroyCamera_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cam_c);
// original function: void destroyCamera(const String& name);
void cSm_destroyCamera2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllCameras();
void cSm_destroyAllCameras_c(struct hg3dclass_struct *classptr_c);
// original function: Light* createLight(const String& name);
void cSm_createLight_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: Light* createLight();
void cSm_createLight2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: Light* getLight(const String& name);
void cSm_getLight_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasLight(const String& name);
void cSm_hasLight_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyLight(const String& name);
void cSm_destroyLight_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyLight(Light* light);
void cSm_destroyLight2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * light_c);
// original function: void destroyAllLights();
void cSm_destroyAllLights_c(struct hg3dclass_struct *classptr_c);
// original function: void _notifyLightsDirty();
void cSm__notifyLightsDirty_c(struct hg3dclass_struct *classptr_c);
// original function: SceneNode* createSceneNode();
void cSm_createSceneNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: SceneNode* createSceneNode(const String& name);
void cSm_createSceneNode2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: void destroySceneNode(const String& name);
void cSm_destroySceneNode_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroySceneNode(SceneNode* sn);
void cSm_destroySceneNode2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * sn_c);
// original function: SceneNode* getRootSceneNode();
void cSm_getRootSceneNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: SceneNode* getSceneNode(const String& name);
void cSm_getSceneNode_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasSceneNode(const String& name);
void cSm_hasSceneNode_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: Entity* createEntity(const String& entityName, const String& meshName, const String& groupName);
void cSm_createEntity_c(struct hg3dclass_struct *classptr_c, char * entityName_c, char * meshName_c, char * groupName_c, struct hg3dclass_struct * result_c);
// original function: Entity* createEntity(const String& meshName);
void cSm_createEntity2_c(struct hg3dclass_struct *classptr_c, char * meshName_c, struct hg3dclass_struct * result_c);
// original function: Entity* createEntity(const String& entityName, PrefabType ptype);
void cSm_createEntity3_c(struct hg3dclass_struct *classptr_c, char * entityName_c, enum EnumPrefabType ptype_c, struct hg3dclass_struct * result_c);
// original function: Entity* createEntity(PrefabType ptype);
void cSm_createEntity4_c(struct hg3dclass_struct *classptr_c, enum EnumPrefabType ptype_c, struct hg3dclass_struct * result_c);
// original function: Entity* getEntity(const String& name);
void cSm_getEntity_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasEntity(const String& name);
void cSm_hasEntity_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyEntity(Entity* ent);
void cSm_destroyEntity_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * ent_c);
// original function: void destroyEntity(const String& name);
void cSm_destroyEntity2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllEntities();
void cSm_destroyAllEntities_c(struct hg3dclass_struct *classptr_c);
// original function: ManualObject* createManualObject(const String& name);
void cSm_createManualObject_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: ManualObject* createManualObject();
void cSm_createManualObject2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: ManualObject* getManualObject(const String& name);
void cSm_getManualObject_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasManualObject(const String& name);
void cSm_hasManualObject_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyManualObject(ManualObject* obj);
void cSm_destroyManualObject_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * obj_c);
// original function: void destroyManualObject(const String& name);
void cSm_destroyManualObject2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllManualObjects();
void cSm_destroyAllManualObjects_c(struct hg3dclass_struct *classptr_c);
// original function: BillboardChain* createBillboardChain(const String& name);
void cSm_createBillboardChain_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: BillboardChain* createBillboardChain();
void cSm_createBillboardChain2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: BillboardChain* getBillboardChain(const String& name);
void cSm_getBillboardChain_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasBillboardChain(const String& name);
void cSm_hasBillboardChain_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyBillboardChain(BillboardChain* obj);
void cSm_destroyBillboardChain_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * obj_c);
// original function: void destroyBillboardChain(const String& name);
void cSm_destroyBillboardChain2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllBillboardChains();
void cSm_destroyAllBillboardChains_c(struct hg3dclass_struct *classptr_c);
// original function: RibbonTrail* createRibbonTrail(const String& name);
void cSm_createRibbonTrail_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: RibbonTrail* createRibbonTrail();
void cSm_createRibbonTrail2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: RibbonTrail* getRibbonTrail(const String& name);
void cSm_getRibbonTrail_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasRibbonTrail(const String& name);
void cSm_hasRibbonTrail_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyRibbonTrail(RibbonTrail* obj);
void cSm_destroyRibbonTrail_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * obj_c);
// original function: void destroyRibbonTrail(const String& name);
void cSm_destroyRibbonTrail2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllRibbonTrails();
void cSm_destroyAllRibbonTrails_c(struct hg3dclass_struct *classptr_c);
// original function: bool hasParticleSystem(const String& name);
void cSm_hasParticleSystem_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyParticleSystem(const String& name);
void cSm_destroyParticleSystem2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllParticleSystems();
void cSm_destroyAllParticleSystems_c(struct hg3dclass_struct *classptr_c);
// original function: void clearScene();
void cSm_clearScene_c(struct hg3dclass_struct *classptr_c);
// original function: void setAmbientLight(const ColourValue& colour);
void cSm_setAmbientLight_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colour_c);
// original function: const ColourValue& getAmbientLight();
void cSm_getAmbientLight_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: void prepareWorldGeometry(const String& filename);
void cSm_prepareWorldGeometry_c(struct hg3dclass_struct *classptr_c, char * filename_c);
// original function: void prepareWorldGeometry(DataStreamPtr& stream, const String& typeName);
void cSm_prepareWorldGeometry2_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * stream_c, char * typeName_c);
// original function: void setWorldGeometry(const String& filename);
void cSm_setWorldGeometry_c(struct hg3dclass_struct *classptr_c, char * filename_c);
// original function: void setWorldGeometry(DataStreamPtr& stream, const String& typeName);
void cSm_setWorldGeometry2_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * stream_c, char * typeName_c);
// original function: size_t estimateWorldGeometry(const String& filename);
void cSm_estimateWorldGeometry_c(struct hg3dclass_struct *classptr_c, char * filename_c, int * result_c);
// original function: size_t estimateWorldGeometry(DataStreamPtr& stream, const String& typeName);
void cSm_estimateWorldGeometry2_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * stream_c, char * typeName_c, int * result_c);
// original function: bool hasOption(const String& strKey);
void cSm_hasOption_c(struct hg3dclass_struct *classptr_c, char * strKey_c, int * result_c);
// original function: void _updateSceneGraph(Camera* cam);
void cSm__updateSceneGraph_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cam_c);
// original function: void _applySceneAnimations();
void cSm__applySceneAnimations_c(struct hg3dclass_struct *classptr_c);
// original function: void _renderVisibleObjects();
void cSm__renderVisibleObjects_c(struct hg3dclass_struct *classptr_c);
// original function: void _renderScene(Camera* camera, Viewport* vp, bool includeOverlays);
void cSm__renderScene_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * camera_c, struct hg3dclass_struct * vp_c, int includeOverlays_c);
// original function: void _queueSkiesForRendering(Camera* cam);
void cSm__queueSkiesForRendering_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cam_c);
// original function: void setSkyPlaneEnabled(bool enable);
void cSm_setSkyPlaneEnabled_c(struct hg3dclass_struct *classptr_c, int enable_c);
// original function: bool isSkyPlaneEnabled();
void cSm_isSkyPlaneEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: SceneNode* getSkyPlaneNode();
void cSm_getSkyPlaneNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setSkyBox(bool enable, const String& materialName, Real distance, bool drawFirst, const Quaternion& orientation, const String& groupName);
void cSm_setSkyBox_c(struct hg3dclass_struct *classptr_c, int enable_c, char * materialName_c, float distance_c, int drawFirst_c, struct quaternion_struct * orientation_c, char * groupName_c);
// original function: void setSkyBoxEnabled(bool enable);
void cSm_setSkyBoxEnabled_c(struct hg3dclass_struct *classptr_c, int enable_c);
// original function: bool isSkyBoxEnabled();
void cSm_isSkyBoxEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: SceneNode* getSkyBoxNode();
void cSm_getSkyBoxNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setSkyDome(bool enable, const String& materialName, Real curvature, Real tiling, Real distance, bool drawFirst, const Quaternion& orientation, int xsegments, int ysegments, int ysegments_keep, const String& groupName);
void cSm_setSkyDome_c(struct hg3dclass_struct *classptr_c, int enable_c, char * materialName_c, float curvature_c, float tiling_c, float distance_c, int drawFirst_c, struct quaternion_struct * orientation_c, int xsegments_c, int ysegments_c, int ysegments_keep_c, char * groupName_c);
// original function: void setSkyDomeEnabled(bool enable);
void cSm_setSkyDomeEnabled_c(struct hg3dclass_struct *classptr_c, int enable_c);
// original function: bool isSkyDomeEnabled();
void cSm_isSkyDomeEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: SceneNode* getSkyDomeNode();
void cSm_getSkyDomeNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setFog(FogMode mode, const ColourValue& colour, Real expDensity, Real linearStart, Real linearEnd);
void cSm_setFog_c(struct hg3dclass_struct *classptr_c, enum EnumFogMode mode_c, struct colourvalue_struct * colour_c, float expDensity_c, float linearStart_c, float linearEnd_c);
// original function: FogMode getFogMode();
void cSm_getFogMode_c(struct hg3dclass_struct *classptr_c, enum EnumFogMode * result_c);
// original function: const ColourValue& getFogColour();
void cSm_getFogColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: Real getFogStart();
void cSm_getFogStart_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getFogEnd();
void cSm_getFogEnd_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getFogDensity();
void cSm_getFogDensity_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: BillboardSet* createBillboardSet(const String& name, unsigned int poolSize);
void cSm_createBillboardSet_c(struct hg3dclass_struct *classptr_c, char * name_c, unsigned int poolSize_c, struct hg3dclass_struct * result_c);
// original function: BillboardSet* createBillboardSet(unsigned int poolSize);
void cSm_createBillboardSet2_c(struct hg3dclass_struct *classptr_c, unsigned int poolSize_c, struct hg3dclass_struct * result_c);
// original function: BillboardSet* getBillboardSet(const String& name);
void cSm_getBillboardSet_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasBillboardSet(const String& name);
void cSm_hasBillboardSet_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyBillboardSet(BillboardSet* set);
void cSm_destroyBillboardSet_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * set_c);
// original function: void destroyBillboardSet(const String& name);
void cSm_destroyBillboardSet2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllBillboardSets();
void cSm_destroyAllBillboardSets_c(struct hg3dclass_struct *classptr_c);
// original function: void setDisplaySceneNodes(bool display);
void cSm_setDisplaySceneNodes_c(struct hg3dclass_struct *classptr_c, int display_c);
// original function: bool getDisplaySceneNodes();
void cSm_getDisplaySceneNodes_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: Animation* createAnimation(const String& name, Real length);
void cSm_createAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c, float length_c, struct hg3dclass_struct * result_c);
// original function: Animation* getAnimation(const String& name);
void cSm_getAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasAnimation(const String& name);
void cSm_hasAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyAnimation(const String& name);
void cSm_destroyAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllAnimations();
void cSm_destroyAllAnimations_c(struct hg3dclass_struct *classptr_c);
// original function: AnimationState* createAnimationState(const String& animName);
void cSm_createAnimationState_c(struct hg3dclass_struct *classptr_c, char * animName_c, struct hg3dclass_struct * result_c);
// original function: AnimationState* getAnimationState(const String& animName);
void cSm_getAnimationState_c(struct hg3dclass_struct *classptr_c, char * animName_c, struct hg3dclass_struct * result_c);
// original function: bool hasAnimationState(const String& name);
void cSm_hasAnimationState_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyAnimationState(const String& name);
void cSm_destroyAnimationState_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllAnimationStates();
void cSm_destroyAllAnimationStates_c(struct hg3dclass_struct *classptr_c);
// original function: void addRenderObjectListener(RenderObjectListener* newListener);
void cSm_addRenderObjectListener_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * newListener_c);
// original function: void removeRenderObjectListener(RenderObjectListener* delListener);
void cSm_removeRenderObjectListener_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * delListener_c);
// original function: void clearSpecialCaseRenderQueues();
void cSm_clearSpecialCaseRenderQueues_c(struct hg3dclass_struct *classptr_c);
// original function: void setSpecialCaseRenderQueueMode(SpecialCaseRenderQueueMode mode);
void cSm_setSpecialCaseRenderQueueMode_c(struct hg3dclass_struct *classptr_c, enum EnumSpecialCaseRenderQueueMode mode_c);
// original function: SpecialCaseRenderQueueMode getSpecialCaseRenderQueueMode();
void cSm_getSpecialCaseRenderQueueMode_c(struct hg3dclass_struct *classptr_c, enum EnumSpecialCaseRenderQueueMode * result_c);
// original function: void showBoundingBoxes(bool bShow);
void cSm_showBoundingBoxes_c(struct hg3dclass_struct *classptr_c, int bShow_c);
// original function: bool getShowBoundingBoxes();
void cSm_getShowBoundingBoxes_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _notifyAutotrackingSceneNode(SceneNode* node, bool autoTrack);
void cSm__notifyAutotrackingSceneNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * node_c, int autoTrack_c);
// original function: void setShadowTechnique(ShadowTechnique technique);
void cSm_setShadowTechnique_c(struct hg3dclass_struct *classptr_c, enum EnumShadowTechnique technique_c);
// original function: ShadowTechnique getShadowTechnique();
void cSm_getShadowTechnique_c(struct hg3dclass_struct *classptr_c, enum EnumShadowTechnique * result_c);
// original function: void setShowDebugShadows(bool debug);
void cSm_setShowDebugShadows_c(struct hg3dclass_struct *classptr_c, int debug_c);
// original function: bool getShowDebugShadows();
void cSm_getShowDebugShadows_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setShadowColour(const ColourValue& colour);
void cSm_setShadowColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colour_c);
// original function: const ColourValue& getShadowColour();
void cSm_getShadowColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: void setShadowDirectionalLightExtrusionDistance(Real dist);
void cSm_setShadowDirectionalLightExtrusionDistance_c(struct hg3dclass_struct *classptr_c, float dist_c);
// original function: Real getShadowDirectionalLightExtrusionDistance();
void cSm_getShadowDirectionalLightExtrusionDistance_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setShadowFarDistance(Real distance);
void cSm_setShadowFarDistance_c(struct hg3dclass_struct *classptr_c, float distance_c);
// original function: Real getShadowFarDistance();
void cSm_getShadowFarDistance_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setShadowIndexBufferSize(size_t size);
void cSm_setShadowIndexBufferSize_c(struct hg3dclass_struct *classptr_c, int size_c);
// original function: size_t getShadowIndexBufferSize();
void cSm_getShadowIndexBufferSize_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setShadowTextureSize(unsigned short size);
void cSm_setShadowTextureSize_c(struct hg3dclass_struct *classptr_c, unsigned short size_c);
// original function: void setShadowTextureConfig(size_t shadowIndex, unsigned short width, unsigned short height, PixelFormat format);
void cSm_setShadowTextureConfig_c(struct hg3dclass_struct *classptr_c, int shadowIndex_c, unsigned short width_c, unsigned short height_c, enum EnumPixelFormat format_c);
// original function: void setShadowTexturePixelFormat(PixelFormat fmt);
void cSm_setShadowTexturePixelFormat_c(struct hg3dclass_struct *classptr_c, enum EnumPixelFormat fmt_c);
// original function: void setShadowTextureCount(size_t count);
void cSm_setShadowTextureCount_c(struct hg3dclass_struct *classptr_c, int count_c);
// original function: size_t getShadowTextureCount();
void cSm_getShadowTextureCount_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setShadowTextureCountPerLightType(Light::LightTypes type, size_t count);
void cSm_setShadowTextureCountPerLightType_c(struct hg3dclass_struct *classptr_c, enum EnumLightTypes type_c, int count_c);
// original function: size_t getShadowTextureCountPerLightType(Light::LightTypes type);
void cSm_getShadowTextureCountPerLightType_c(struct hg3dclass_struct *classptr_c, enum EnumLightTypes type_c, int * result_c);
// original function: void setShadowTextureSettings(unsigned short size, unsigned short count, PixelFormat fmt);
void cSm_setShadowTextureSettings_c(struct hg3dclass_struct *classptr_c, unsigned short size_c, unsigned short count_c, enum EnumPixelFormat fmt_c);
// original function: const TexturePtr& getShadowTexture(size_t shadowIndex);
void cSm_getShadowTexture_c(struct hg3dclass_struct *classptr_c, int shadowIndex_c, struct sharedptr_struct * result_c);
// original function: void setShadowDirLightTextureOffset(Real offset);
void cSm_setShadowDirLightTextureOffset_c(struct hg3dclass_struct *classptr_c, float offset_c);
// original function: Real getShadowDirLightTextureOffset();
void cSm_getShadowDirLightTextureOffset_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setShadowTextureFadeStart(Real fadeStart);
void cSm_setShadowTextureFadeStart_c(struct hg3dclass_struct *classptr_c, float fadeStart_c);
// original function: void setShadowTextureFadeEnd(Real fadeEnd);
void cSm_setShadowTextureFadeEnd_c(struct hg3dclass_struct *classptr_c, float fadeEnd_c);
// original function: void setShadowTextureSelfShadow(bool selfShadow);
void cSm_setShadowTextureSelfShadow_c(struct hg3dclass_struct *classptr_c, int selfShadow_c);
// original function: bool getShadowTextureSelfShadow();
void cSm_getShadowTextureSelfShadow_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setShadowTextureCasterMaterial(const String& name);
void cSm_setShadowTextureCasterMaterial_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void setShadowTextureReceiverMaterial(const String& name);
void cSm_setShadowTextureReceiverMaterial_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void setShadowCasterRenderBackFaces(bool bf);
void cSm_setShadowCasterRenderBackFaces_c(struct hg3dclass_struct *classptr_c, int bf_c);
// original function: bool getShadowCasterRenderBackFaces();
void cSm_getShadowCasterRenderBackFaces_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setShadowUseInfiniteFarPlane(bool enable);
void cSm_setShadowUseInfiniteFarPlane_c(struct hg3dclass_struct *classptr_c, int enable_c);
// original function: bool isShadowTechniqueStencilBased();
void cSm_isShadowTechniqueStencilBased_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isShadowTechniqueTextureBased();
void cSm_isShadowTechniqueTextureBased_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isShadowTechniqueModulative();
void cSm_isShadowTechniqueModulative_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isShadowTechniqueAdditive();
void cSm_isShadowTechniqueAdditive_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isShadowTechniqueIntegrated();
void cSm_isShadowTechniqueIntegrated_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isShadowTechniqueInUse();
void cSm_isShadowTechniqueInUse_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setShadowUseLightClipPlanes(bool enabled);
void cSm_setShadowUseLightClipPlanes_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getShadowUseLightClipPlanes();
void cSm_getShadowUseLightClipPlanes_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _setActiveCompositorChain(CompositorChain* chain);
void cSm__setActiveCompositorChain_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * chain_c);
// original function: void setLateMaterialResolving(bool isLate);
void cSm_setLateMaterialResolving_c(struct hg3dclass_struct *classptr_c, int isLate_c);
// original function: bool isLateMaterialResolving();
void cSm_isLateMaterialResolving_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: CompositorChain* _getActiveCompositorChain();
void cSm__getActiveCompositorChain_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: StaticGeometry* createStaticGeometry(const String& name);
void cSm_createStaticGeometry_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: StaticGeometry* getStaticGeometry(const String& name);
void cSm_getStaticGeometry_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasStaticGeometry(const String& name);
void cSm_hasStaticGeometry_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void destroyStaticGeometry(StaticGeometry* geom);
void cSm_destroyStaticGeometry_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * geom_c);
// original function: void destroyStaticGeometry(const String& name);
void cSm_destroyStaticGeometry2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllStaticGeometry();
void cSm_destroyAllStaticGeometry_c(struct hg3dclass_struct *classptr_c);
// original function: void destroyInstancedGeometry(const String& name);
void cSm_destroyInstancedGeometry2_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void destroyAllInstancedGeometry();
void cSm_destroyAllInstancedGeometry_c(struct hg3dclass_struct *classptr_c);
// original function: void destroyMovableObject(const String& name, const String& typeName);
void cSm_destroyMovableObject_c(struct hg3dclass_struct *classptr_c, char * name_c, char * typeName_c);
// original function: void destroyMovableObject(MovableObject* m);
void cSm_destroyMovableObject2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * m_c);
// original function: void destroyAllMovableObjectsByType(const String& typeName);
void cSm_destroyAllMovableObjectsByType_c(struct hg3dclass_struct *classptr_c, char * typeName_c);
// original function: void destroyAllMovableObjects();
void cSm_destroyAllMovableObjects_c(struct hg3dclass_struct *classptr_c);
// original function: MovableObject* getMovableObject(const String& name, const String& typeName);
void cSm_getMovableObject_c(struct hg3dclass_struct *classptr_c, char * name_c, char * typeName_c, struct hg3dclass_struct * result_c);
// original function: bool hasMovableObject(const String& name, const String& typeName);
void cSm_hasMovableObject_c(struct hg3dclass_struct *classptr_c, char * name_c, char * typeName_c, int * result_c);
// original function: void injectMovableObject(MovableObject* m);
void cSm_injectMovableObject_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * m_c);
// original function: void extractMovableObject(const String& name, const String& typeName);
void cSm_extractMovableObject_c(struct hg3dclass_struct *classptr_c, char * name_c, char * typeName_c);
// original function: void extractMovableObject(MovableObject* m);
void cSm_extractMovableObject2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * m_c);
// original function: void extractAllMovableObjectsByType(const String& typeName);
void cSm_extractAllMovableObjectsByType_c(struct hg3dclass_struct *classptr_c, char * typeName_c);
// original function: void setVisibilityMask(uint32 vmask);
void cSm_setVisibilityMask_c(struct hg3dclass_struct *classptr_c, unsigned int vmask_c);
// original function: uint32 getVisibilityMask();
void cSm_getVisibilityMask_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: uint32 _getCombinedVisibilityMask();
void cSm__getCombinedVisibilityMask_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setFindVisibleObjects(bool find);
void cSm_setFindVisibleObjects_c(struct hg3dclass_struct *classptr_c, int find_c);
// original function: bool getFindVisibleObjects();
void cSm_getFindVisibleObjects_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setNormaliseNormalsOnScale(bool n);
void cSm_setNormaliseNormalsOnScale_c(struct hg3dclass_struct *classptr_c, int n_c);
// original function: bool getNormaliseNormalsOnScale();
void cSm_getNormaliseNormalsOnScale_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setFlipCullingOnNegativeScale(bool n);
void cSm_setFlipCullingOnNegativeScale_c(struct hg3dclass_struct *classptr_c, int n_c);
// original function: bool getFlipCullingOnNegativeScale();
void cSm_getFlipCullingOnNegativeScale_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _suppressRenderStateChanges(bool suppress);
void cSm__suppressRenderStateChanges_c(struct hg3dclass_struct *classptr_c, int suppress_c);
// original function: bool _areRenderStateChangesSuppressed();
void cSm__areRenderStateChangesSuppressed_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _markGpuParamsDirty(uint16 mask);
void cSm__markGpuParamsDirty_c(struct hg3dclass_struct *classptr_c, unsigned short mask_c);
// original function: void _suppressShadows(bool suppress);
void cSm__suppressShadows_c(struct hg3dclass_struct *classptr_c, int suppress_c);
// original function: bool _areShadowsSuppressed();
void cSm__areShadowsSuppressed_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setQueuedRenderableVisitor(SceneMgrQueuedRenderableVisitor* visitor);
void cSm_setQueuedRenderableVisitor_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * visitor_c);
// original function: SceneMgrQueuedRenderableVisitor* getQueuedRenderableVisitor();
void cSm_getQueuedRenderableVisitor_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: Viewport* getCurrentViewport();
void cSm_getCurrentViewport_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setCameraRelativeRendering(bool rel);
void cSm_setCameraRelativeRendering_c(struct hg3dclass_struct *classptr_c, int rel_c);
// original function: bool getCameraRelativeRendering();
void cSm_getCameraRelativeRendering_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _handleLodEvents();
void cSm__handleLodEvents_c(struct hg3dclass_struct *classptr_c);
