// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassSceneNode.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreSceneNode.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeVector3.h"
#include "TypeQuaternion.h"
#include "TypeRadian.h"
#include "EnumTransformSpace.h"


// original function: void attachObject(MovableObject* obj);
void cSn_attachObject_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * obj_c);
// original function: unsigned short numAttachedObjects();
void cSn_numAttachedObjects_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: MovableObject* getAttachedObject(unsigned short index);
void cSn_getAttachedObject_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: MovableObject* getAttachedObject(const String& name);
void cSn_getAttachedObject2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: MovableObject* detachObject(unsigned short index);
void cSn_detachObject_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: void detachObject(MovableObject* obj);
void cSn_detachObject2_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * obj_c);
// original function: MovableObject* detachObject(const String& name);
void cSn_detachObject3_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: void detachAllObjects();
void cSn_detachAllObjects_c(struct hg3dclass_struct *classptr_c);
// original function: bool isInSceneGraph();
void cSn_isInSceneGraph_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _notifyRootNode();
void cSn__notifyRootNode_c(struct hg3dclass_struct *classptr_c);
// original function: void _update(bool updateChildren, bool parentHasChanged);
void cSn__update_c(struct hg3dclass_struct *classptr_c, int updateChildren_c, int parentHasChanged_c);
// original function: void _updateBounds();
void cSn__updateBounds_c(struct hg3dclass_struct *classptr_c);
// original function: SceneManager* getCreator();
void cSn_getCreator_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void removeAndDestroyChild(const String& name);
void cSn_removeAndDestroyChild_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void removeAndDestroyChild(unsigned short index);
void cSn_removeAndDestroyChild2_c(struct hg3dclass_struct *classptr_c, unsigned short index_c);
// original function: void removeAndDestroyAllChildren();
void cSn_removeAndDestroyAllChildren_c(struct hg3dclass_struct *classptr_c);
// original function: void showBoundingBox(bool bShow);
void cSn_showBoundingBox_c(struct hg3dclass_struct *classptr_c, int bShow_c);
// original function: void hideBoundingBox(bool bHide);
void cSn_hideBoundingBox_c(struct hg3dclass_struct *classptr_c, int bHide_c);
// original function: bool getShowBoundingBox();
void cSn_getShowBoundingBox_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: SceneNode* createChildSceneNode(const Vector3& translate, const Quaternion& rotate);
void cSn_createChildSceneNode_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * translate_c, struct quaternion_struct * rotate_c, struct hg3dclass_struct * result_c);
// original function: SceneNode* createChildSceneNode(const String& name, const Vector3& translate, const Quaternion& rotate);
void cSn_createChildSceneNode2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct vector3_struct * translate_c, struct quaternion_struct * rotate_c, struct hg3dclass_struct * result_c);
// original function: void setFixedYawAxis(bool useFixed, const Vector3& fixedAxis);
void cSn_setFixedYawAxis_c(struct hg3dclass_struct *classptr_c, int useFixed_c, struct vector3_struct * fixedAxis_c);
// original function: void yaw(const Radian& angle, TransformSpace relativeTo);
void cSn_yaw_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c, enum EnumTransformSpace relativeTo_c);
// original function: void setDirection(Real x, Real y, Real z, TransformSpace relativeTo, const Vector3& localDirectionVector);
void cSn_setDirection_c(struct hg3dclass_struct *classptr_c, float x_c, float y_c, float z_c, enum EnumTransformSpace relativeTo_c, struct vector3_struct * localDirectionVector_c);
// original function: void setDirection(const Vector3& vec, TransformSpace relativeTo, const Vector3& localDirectionVector);
void cSn_setDirection2_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * vec_c, enum EnumTransformSpace relativeTo_c, struct vector3_struct * localDirectionVector_c);
// original function: void lookAt(const Vector3& targetPoint, TransformSpace relativeTo, const Vector3& localDirectionVector);
void cSn_lookAt_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * targetPoint_c, enum EnumTransformSpace relativeTo_c, struct vector3_struct * localDirectionVector_c);
// original function: void setAutoTracking(bool enabled, SceneNode* target, const Vector3& localDirectionVector, const Vector3& offset);
void cSn_setAutoTracking_c(struct hg3dclass_struct *classptr_c, int enabled_c, struct hg3dclass_struct * target_c, struct vector3_struct * localDirectionVector_c, struct vector3_struct * offset_c);
// original function: SceneNode* getAutoTrackTarget();
void cSn_getAutoTrackTarget_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: const Vector3& getAutoTrackOffset();
void cSn_getAutoTrackOffset_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: const Vector3& getAutoTrackLocalDirection();
void cSn_getAutoTrackLocalDirection_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void _autoTrack();
void cSn__autoTrack_c(struct hg3dclass_struct *classptr_c);
// original function: SceneNode* getParentSceneNode();
void cSn_getParentSceneNode_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setVisible(bool visible, bool cascade);
void cSn_setVisible_c(struct hg3dclass_struct *classptr_c, int visible_c, int cascade_c);
// original function: void flipVisibility(bool cascade);
void cSn_flipVisibility_c(struct hg3dclass_struct *classptr_c, int cascade_c);
// original function: void setDebugDisplayEnabled(bool enabled, bool cascade);
void cSn_setDebugDisplayEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c, int cascade_c);
