// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassSkeleton.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreSkeleton.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumSkeletonAnimationBlendMode.h"


// original function: Bone* createBone();
void cS_createBone_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: Bone* createBone(unsigned short handle);
void cS_createBone2_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, struct hg3dclass_struct * result_c);
// original function: Bone* createBone(const String& name);
void cS_createBone3_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: Bone* createBone(const String& name, unsigned short handle);
void cS_createBone4_c(struct hg3dclass_struct *classptr_c, char * name_c, unsigned short handle_c, struct hg3dclass_struct * result_c);
// original function: unsigned short getNumBones();
void cS_getNumBones_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: Bone* getRootBone();
void cS_getRootBone_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: Bone* getBone(unsigned short handle);
void cS_getBone_c(struct hg3dclass_struct *classptr_c, unsigned short handle_c, struct hg3dclass_struct * result_c);
// original function: Bone* getBone(const String& name);
void cS_getBone2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: bool hasBone(const String& name);
void cS_hasBone_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void setBindingPose();
void cS_setBindingPose_c(struct hg3dclass_struct *classptr_c);
// original function: void reset(bool resetManualBones);
void cS_reset_c(struct hg3dclass_struct *classptr_c, int resetManualBones_c);
// original function: Animation* createAnimation(const String& name, Real length);
void cS_createAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c, float length_c, struct hg3dclass_struct * result_c);
// original function: bool hasAnimation(const String& name);
void cS_hasAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c, int * result_c);
// original function: void removeAnimation(const String& name);
void cS_removeAnimation_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: unsigned short getNumAnimations();
void cS_getNumAnimations_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: Animation* getAnimation(unsigned short index);
void cS_getAnimation2_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: SkeletonAnimationBlendMode getBlendMode();
void cS_getBlendMode_c(struct hg3dclass_struct *classptr_c, enum EnumSkeletonAnimationBlendMode * result_c);
// original function: void setBlendMode(SkeletonAnimationBlendMode state);
void cS_setBlendMode_c(struct hg3dclass_struct *classptr_c, enum EnumSkeletonAnimationBlendMode state_c);
// original function: void _updateTransforms();
void cS__updateTransforms_c(struct hg3dclass_struct *classptr_c);
// original function: void optimiseAllAnimations(bool preservingIdentityNodeTracks);
void cS_optimiseAllAnimations_c(struct hg3dclass_struct *classptr_c, int preservingIdentityNodeTracks_c);
// original function: void addLinkedSkeletonAnimationSource(const String& skelName, Real scale);
void cS_addLinkedSkeletonAnimationSource_c(struct hg3dclass_struct *classptr_c, char * skelName_c, float scale_c);
// original function: void removeAllLinkedSkeletonAnimationSources();
void cS_removeAllLinkedSkeletonAnimationSources_c(struct hg3dclass_struct *classptr_c);
// original function: void _notifyManualBonesDirty();
void cS__notifyManualBonesDirty_c(struct hg3dclass_struct *classptr_c);
// original function: void _notifyManualBoneStateChange(Bone* bone);
void cS__notifyManualBoneStateChange_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * bone_c);
// original function: bool getManualBonesDirty();
void cS_getManualBonesDirty_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasManualBones();
void cS_hasManualBones_c(struct hg3dclass_struct *classptr_c, int * result_c);
