// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassStaticGeometry.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreStaticGeometry.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeVector3.h"
#include "TypeQuaternion.h"


// original function: const String& getName();
void cSg_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void addEntity(Entity* ent, const Vector3& position, const Quaternion& orientation, const Vector3& scale);
void cSg_addEntity_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * ent_c, struct vector3_struct * position_c, struct quaternion_struct * orientation_c, struct vector3_struct * scale_c);
// original function: void build();
void cSg_build_c(struct hg3dclass_struct *classptr_c);
// original function: void destroy();
void cSg_destroy_c(struct hg3dclass_struct *classptr_c);
// original function: void reset();
void cSg_reset_c(struct hg3dclass_struct *classptr_c);
// original function: void setRenderingDistance(Real dist);
void cSg_setRenderingDistance_c(struct hg3dclass_struct *classptr_c, float dist_c);
// original function: Real getRenderingDistance();
void cSg_getRenderingDistance_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getSquaredRenderingDistance();
void cSg_getSquaredRenderingDistance_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setVisible(bool visible);
void cSg_setVisible_c(struct hg3dclass_struct *classptr_c, int visible_c);
// original function: bool isVisible();
void cSg_isVisible_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setCastShadows(bool castShadows);
void cSg_setCastShadows_c(struct hg3dclass_struct *classptr_c, int castShadows_c);
// original function: bool getCastShadows();
void cSg_getCastShadows_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setRegionDimensions(const Vector3& size);
void cSg_setRegionDimensions_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * size_c);
// original function: const Vector3& getRegionDimensions();
void cSg_getRegionDimensions_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void setOrigin(const Vector3& origin);
void cSg_setOrigin_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * origin_c);
// original function: const Vector3& getOrigin();
void cSg_getOrigin_c(struct hg3dclass_struct *classptr_c, struct vector3_struct * result_c);
// original function: void setVisibilityFlags(uint32 flags);
void cSg_setVisibilityFlags_c(struct hg3dclass_struct *classptr_c, unsigned int flags_c);
// original function: uint32 getVisibilityFlags();
void cSg_getVisibilityFlags_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void dump(const String& filename);
void cSg_dump_c(struct hg3dclass_struct *classptr_c, char * filename_c);
