// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassTechnique.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreTechnique.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeColour.h"
#include "EnumCompareFunction.h"
#include "EnumCullingMode.h"
#include "EnumManualCullingMode.h"
#include "EnumShadeOptions.h"
#include "EnumFogMode.h"
#include "EnumTextureFilterOptions.h"
#include "EnumGPUVendor.h"
#include "EnumIncludeOrExclude.h"


// original function: bool isSupported();
void cT_isSupported_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: String _compile(bool autoManageTextureUnits);
void cT__compile_c(struct hg3dclass_struct *classptr_c, int autoManageTextureUnits_c, char * result_c);
// original function: void _compileIlluminationPasses();
void cT__compileIlluminationPasses_c(struct hg3dclass_struct *classptr_c);
// original function: Pass* createPass();
void cT_createPass_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: Pass* getPass(unsigned short index);
void cT_getPass_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: Pass* getPass(const String& name);
void cT_getPass2_c(struct hg3dclass_struct *classptr_c, char * name_c, struct hg3dclass_struct * result_c);
// original function: unsigned short getNumPasses();
void cT_getNumPasses_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: void removePass(unsigned short index);
void cT_removePass_c(struct hg3dclass_struct *classptr_c, unsigned short index_c);
// original function: void removeAllPasses();
void cT_removeAllPasses_c(struct hg3dclass_struct *classptr_c);
// original function: bool movePass(const unsigned short sourceIndex, const unsigned short destinationIndex);
void cT_movePass_c(struct hg3dclass_struct *classptr_c, unsigned short sourceIndex_c, unsigned short destinationIndex_c, int * result_c);
// original function: Material* getParent();
void cT_getParent_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: const String& getResourceGroup();
void cT_getResourceGroup_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: bool isTransparent();
void cT_isTransparent_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isTransparentSortingEnabled();
void cT_isTransparentSortingEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isTransparentSortingForced();
void cT_isTransparentSortingForced_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _prepare();
void cT__prepare_c(struct hg3dclass_struct *classptr_c);
// original function: void _unprepare();
void cT__unprepare_c(struct hg3dclass_struct *classptr_c);
// original function: void _load();
void cT__load_c(struct hg3dclass_struct *classptr_c);
// original function: void _unload();
void cT__unload_c(struct hg3dclass_struct *classptr_c);
// original function: bool isLoaded();
void cT_isLoaded_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _notifyNeedsRecompile();
void cT__notifyNeedsRecompile_c(struct hg3dclass_struct *classptr_c);
// original function: void setPointSize(Real ps);
void cT_setPointSize_c(struct hg3dclass_struct *classptr_c, float ps_c);
// original function: void setAmbient(Real red, Real green, Real blue);
void cT_setAmbient_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c);
// original function: void setAmbient(const ColourValue& ambient);
void cT_setAmbient2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * ambient_c);
// original function: void setDiffuse(Real red, Real green, Real blue, Real alpha);
void cT_setDiffuse_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c, float alpha_c);
// original function: void setDiffuse(const ColourValue& diffuse);
void cT_setDiffuse2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * diffuse_c);
// original function: void setSpecular(Real red, Real green, Real blue, Real alpha);
void cT_setSpecular_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c, float alpha_c);
// original function: void setSpecular(const ColourValue& specular);
void cT_setSpecular2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * specular_c);
// original function: void setShininess(Real val);
void cT_setShininess_c(struct hg3dclass_struct *classptr_c, float val_c);
// original function: void setSelfIllumination(Real red, Real green, Real blue);
void cT_setSelfIllumination_c(struct hg3dclass_struct *classptr_c, float red_c, float green_c, float blue_c);
// original function: void setSelfIllumination(const ColourValue& selfIllum);
void cT_setSelfIllumination2_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * selfIllum_c);
// original function: void setDepthCheckEnabled(bool enabled);
void cT_setDepthCheckEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: void setDepthWriteEnabled(bool enabled);
void cT_setDepthWriteEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: void setDepthFunction(CompareFunction func);
void cT_setDepthFunction_c(struct hg3dclass_struct *classptr_c, enum EnumCompareFunction func_c);
// original function: void setColourWriteEnabled(bool enabled);
void cT_setColourWriteEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: void setCullingMode(CullingMode mode);
void cT_setCullingMode_c(struct hg3dclass_struct *classptr_c, enum EnumCullingMode mode_c);
// original function: void setManualCullingMode(ManualCullingMode mode);
void cT_setManualCullingMode_c(struct hg3dclass_struct *classptr_c, enum EnumManualCullingMode mode_c);
// original function: void setLightingEnabled(bool enabled);
void cT_setLightingEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: void setShadingMode(ShadeOptions mode);
void cT_setShadingMode_c(struct hg3dclass_struct *classptr_c, enum EnumShadeOptions mode_c);
// original function: void setFog(bool overrideScene, FogMode mode, const ColourValue& colour, Real expDensity, Real linearStart, Real linearEnd);
void cT_setFog_c(struct hg3dclass_struct *classptr_c, int overrideScene_c, enum EnumFogMode mode_c, struct colourvalue_struct * colour_c, float expDensity_c, float linearStart_c, float linearEnd_c);
// original function: void setDepthBias(float constantBias, float slopeScaleBias);
void cT_setDepthBias_c(struct hg3dclass_struct *classptr_c, float constantBias_c, float slopeScaleBias_c);
// original function: void setTextureFiltering(TextureFilterOptions filterType);
void cT_setTextureFiltering_c(struct hg3dclass_struct *classptr_c, enum EnumTextureFilterOptions filterType_c);
// original function: void setTextureAnisotropy(unsigned int maxAniso);
void cT_setTextureAnisotropy_c(struct hg3dclass_struct *classptr_c, unsigned int maxAniso_c);
// original function: void setLodIndex(unsigned short index);
void cT_setLodIndex_c(struct hg3dclass_struct *classptr_c, unsigned short index_c);
// original function: unsigned short getLodIndex();
void cT_getLodIndex_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: void setSchemeName(const String& schemeName);
void cT_setSchemeName_c(struct hg3dclass_struct *classptr_c, char * schemeName_c);
// original function: const String& getSchemeName();
void cT_getSchemeName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: unsigned short _getSchemeIndex();
void cT__getSchemeIndex_c(struct hg3dclass_struct *classptr_c, unsigned short * result_c);
// original function: bool isDepthWriteEnabled();
void cT_isDepthWriteEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isDepthCheckEnabled();
void cT_isDepthCheckEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool hasColourWriteDisabled();
void cT_hasColourWriteDisabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setName(const String& name);
void cT_setName_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: const String& getName();
void cT_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void addGPUVendorRule(GPUVendor vendor, IncludeOrExclude includeOrExclude);
void cT_addGPUVendorRule_c(struct hg3dclass_struct *classptr_c, enum EnumGPUVendor vendor_c, enum EnumIncludeOrExclude includeOrExclude_c);
// original function: void removeGPUVendorRule(GPUVendor vendor);
void cT_removeGPUVendorRule_c(struct hg3dclass_struct *classptr_c, enum EnumGPUVendor vendor_c);
// original function: void addGPUDeviceNameRule(const String& devicePattern, IncludeOrExclude includeOrExclude, bool caseSensitive);
void cT_addGPUDeviceNameRule_c(struct hg3dclass_struct *classptr_c, char * devicePattern_c, enum EnumIncludeOrExclude includeOrExclude_c, int caseSensitive_c);
// original function: void removeGPUDeviceNameRule(const String& devicePattern);
void cT_removeGPUDeviceNameRule_c(struct hg3dclass_struct *classptr_c, char * devicePattern_c);
