// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassTextureManager.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreTextureManager.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeSharedPtr.h"
#include "EnumTextureType.h"
#include "EnumPixelFormat.h"


// original function: TexturePtr prepare(const String& name, const String& group, TextureType texType, int numMipmaps, Real gamma, bool isAlpha, PixelFormat desiredFormat, bool hwGammaCorrection);
void cTm_prepare_c(struct hg3dclass_struct *classptr_c, char * name_c, char * group_c, enum EnumTextureType texType_c, int numMipmaps_c, float gamma_c, int isAlpha_c, enum EnumPixelFormat desiredFormat_c, int hwGammaCorrection_c, struct sharedptr_struct * result_c);
// original function: TexturePtr load(const String& name, const String& group, TextureType texType, int numMipmaps, Real gamma, bool isAlpha, PixelFormat desiredFormat, bool hwGammaCorrection);
void cTm_load_c(struct hg3dclass_struct *classptr_c, char * name_c, char * group_c, enum EnumTextureType texType_c, int numMipmaps_c, float gamma_c, int isAlpha_c, enum EnumPixelFormat desiredFormat_c, int hwGammaCorrection_c, struct sharedptr_struct * result_c);
// original function: bool isFormatSupported(TextureType ttype, PixelFormat format, int usage);
void cTm_isFormatSupported_c(struct hg3dclass_struct *classptr_c, enum EnumTextureType ttype_c, enum EnumPixelFormat format_c, int usage_c, int * result_c);
// original function: bool isEquivalentFormatSupported(TextureType ttype, PixelFormat format, int usage);
void cTm_isEquivalentFormatSupported_c(struct hg3dclass_struct *classptr_c, enum EnumTextureType ttype_c, enum EnumPixelFormat format_c, int usage_c, int * result_c);
// original function: PixelFormat getNativeFormat(TextureType ttype, PixelFormat format, int usage);
void cTm_getNativeFormat_c(struct hg3dclass_struct *classptr_c, enum EnumTextureType ttype_c, enum EnumPixelFormat format_c, int usage_c, enum EnumPixelFormat * result_c);
// original function: bool isHardwareFilteringSupported(TextureType ttype, PixelFormat format, int usage, bool preciseFormatOnly);
void cTm_isHardwareFilteringSupported_c(struct hg3dclass_struct *classptr_c, enum EnumTextureType ttype_c, enum EnumPixelFormat format_c, int usage_c, int preciseFormatOnly_c, int * result_c);
// original function: void setDefaultNumMipmaps(size_t num);
void cTm_setDefaultNumMipmaps_c(struct hg3dclass_struct *classptr_c, int num_c);
// original function: size_t getDefaultNumMipmaps();
void cTm_getDefaultNumMipmaps_c(struct hg3dclass_struct *classptr_c, int * result_c);
// created singleton getSingletonPtr function
void cTm_getSingletonPtr_c(struct hg3dclass_struct *result_c);
