// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassTextureUnitState.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreTextureUnitState.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumTextureType.h"
#include "EnumBindingType.h"
#include "EnumContentType.h"
#include "EnumPixelFormat.h"
#include "TypeRadian.h"
#include "EnumTextureAddressingMode.h"
#include "TypeColour.h"
#include "EnumLayerBlendOperationEx.h"
#include "EnumLayerBlendSource.h"
#include "EnumSceneBlendFactor.h"
#include "EnumEnvMapType.h"
#include "EnumTextureFilterOptions.h"
#include "EnumFilterType.h"
#include "EnumFilterOptions.h"
#include "TypeSharedPtr.h"


// original function: const String& getTextureName();
void cTus_getTextureName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setTextureName(const String& name, TextureType ttype);
void cTus_setTextureName_c(struct hg3dclass_struct *classptr_c, char * name_c, enum EnumTextureType ttype_c);
// original function: void setCubicTextureName(const String& name, bool forUVW);
void cTus_setCubicTextureName_c(struct hg3dclass_struct *classptr_c, char * name_c, int forUVW_c);
// original function: void setAnimatedTextureName(const String& name, unsigned int numFrames, Real duration);
void cTus_setAnimatedTextureName_c(struct hg3dclass_struct *classptr_c, char * name_c, unsigned int numFrames_c, float duration_c);
// original function: void setCurrentFrame(unsigned int frameNumber);
void cTus_setCurrentFrame_c(struct hg3dclass_struct *classptr_c, unsigned int frameNumber_c);
// original function: unsigned int getCurrentFrame();
void cTus_getCurrentFrame_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: const String& getFrameTextureName(unsigned int frameNumber);
void cTus_getFrameTextureName_c(struct hg3dclass_struct *classptr_c, unsigned int frameNumber_c, char * result_c);
// original function: void setFrameTextureName(const String& name, unsigned int frameNumber);
void cTus_setFrameTextureName_c(struct hg3dclass_struct *classptr_c, char * name_c, unsigned int frameNumber_c);
// original function: void addFrameTextureName(const String& name);
void cTus_addFrameTextureName_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: void deleteFrameTextureName(const size_t frameNumber);
void cTus_deleteFrameTextureName_c(struct hg3dclass_struct *classptr_c, int frameNumber_c);
// original function: unsigned int getNumFrames();
void cTus_getNumFrames_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setBindingType(BindingType bt);
void cTus_setBindingType_c(struct hg3dclass_struct *classptr_c, enum EnumBindingType bt_c);
// original function: BindingType getBindingType();
void cTus_getBindingType_c(struct hg3dclass_struct *classptr_c, enum EnumBindingType * result_c);
// original function: void setContentType(ContentType ct);
void cTus_setContentType_c(struct hg3dclass_struct *classptr_c, enum EnumContentType ct_c);
// original function: ContentType getContentType();
void cTus_getContentType_c(struct hg3dclass_struct *classptr_c, enum EnumContentType * result_c);
// original function: bool isCubic();
void cTus_isCubic_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool is3D();
void cTus_is3D_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: TextureType getTextureType();
void cTus_getTextureType_c(struct hg3dclass_struct *classptr_c, enum EnumTextureType * result_c);
// original function: void setDesiredFormat(PixelFormat desiredFormat);
void cTus_setDesiredFormat_c(struct hg3dclass_struct *classptr_c, enum EnumPixelFormat desiredFormat_c);
// original function: PixelFormat getDesiredFormat();
void cTus_getDesiredFormat_c(struct hg3dclass_struct *classptr_c, enum EnumPixelFormat * result_c);
// original function: void setNumMipmaps(int numMipmaps);
void cTus_setNumMipmaps_c(struct hg3dclass_struct *classptr_c, int numMipmaps_c);
// original function: int getNumMipmaps();
void cTus_getNumMipmaps_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setIsAlpha(bool isAlpha);
void cTus_setIsAlpha_c(struct hg3dclass_struct *classptr_c, int isAlpha_c);
// original function: bool getIsAlpha();
void cTus_getIsAlpha_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setHardwareGammaEnabled(bool enabled);
void cTus_setHardwareGammaEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool isHardwareGammaEnabled();
void cTus_isHardwareGammaEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: unsigned int getTextureCoordSet();
void cTus_getTextureCoordSet_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setTextureCoordSet(unsigned int set);
void cTus_setTextureCoordSet_c(struct hg3dclass_struct *classptr_c, unsigned int set_c);
// original function: void setTextureScroll(Real u, Real v);
void cTus_setTextureScroll_c(struct hg3dclass_struct *classptr_c, float u_c, float v_c);
// original function: void setTextureUScroll(Real value);
void cTus_setTextureUScroll_c(struct hg3dclass_struct *classptr_c, float value_c);
// original function: Real getTextureUScroll();
void cTus_getTextureUScroll_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setTextureVScroll(Real value);
void cTus_setTextureVScroll_c(struct hg3dclass_struct *classptr_c, float value_c);
// original function: Real getTextureVScroll();
void cTus_getTextureVScroll_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setTextureUScale(Real value);
void cTus_setTextureUScale_c(struct hg3dclass_struct *classptr_c, float value_c);
// original function: Real getTextureUScale();
void cTus_getTextureUScale_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setTextureVScale(Real value);
void cTus_setTextureVScale_c(struct hg3dclass_struct *classptr_c, float value_c);
// original function: Real getTextureVScale();
void cTus_getTextureVScale_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setTextureScale(Real uScale, Real vScale);
void cTus_setTextureScale_c(struct hg3dclass_struct *classptr_c, float uScale_c, float vScale_c);
// original function: void setTextureRotate(const Radian& angle);
void cTus_setTextureRotate_c(struct hg3dclass_struct *classptr_c, struct radian_struct * angle_c);
// original function: const Radian& getTextureRotate();
void cTus_getTextureRotate_c(struct hg3dclass_struct *classptr_c, struct radian_struct * result_c);
// original function: void setTextureAddressingMode(TextureAddressingMode tam);
void cTus_setTextureAddressingMode_c(struct hg3dclass_struct *classptr_c, enum EnumTextureAddressingMode tam_c);
// original function: void setTextureAddressingMode(TextureAddressingMode u, TextureAddressingMode v, TextureAddressingMode w);
void cTus_setTextureAddressingMode2_c(struct hg3dclass_struct *classptr_c, enum EnumTextureAddressingMode u_c, enum EnumTextureAddressingMode v_c, enum EnumTextureAddressingMode w_c);
// original function: void setTextureBorderColour(const ColourValue& colour);
void cTus_setTextureBorderColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colour_c);
// original function: const ColourValue& getTextureBorderColour();
void cTus_getTextureBorderColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: void setColourOperationEx(LayerBlendOperationEx op, LayerBlendSource source1, LayerBlendSource source2, const ColourValue& arg1, const ColourValue& arg2, Real manualBlend);
void cTus_setColourOperationEx_c(struct hg3dclass_struct *classptr_c, enum EnumLayerBlendOperationEx op_c, enum EnumLayerBlendSource source1_c, enum EnumLayerBlendSource source2_c, struct colourvalue_struct * arg1_c, struct colourvalue_struct * arg2_c, float manualBlend_c);
// original function: SceneBlendFactor getColourBlendFallbackSrc();
void cTus_getColourBlendFallbackSrc_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendFactor * result_c);
// original function: SceneBlendFactor getColourBlendFallbackDest();
void cTus_getColourBlendFallbackDest_c(struct hg3dclass_struct *classptr_c, enum EnumSceneBlendFactor * result_c);
// original function: void setAlphaOperation(LayerBlendOperationEx op, LayerBlendSource source1, LayerBlendSource source2, Real arg1, Real arg2, Real manualBlend);
void cTus_setAlphaOperation_c(struct hg3dclass_struct *classptr_c, enum EnumLayerBlendOperationEx op_c, enum EnumLayerBlendSource source1_c, enum EnumLayerBlendSource source2_c, float arg1_c, float arg2_c, float manualBlend_c);
// original function: void setEnvironmentMap(bool enable, EnvMapType envMapType);
void cTus_setEnvironmentMap_c(struct hg3dclass_struct *classptr_c, int enable_c, enum EnumEnvMapType envMapType_c);
// original function: void setScrollAnimation(Real uSpeed, Real vSpeed);
void cTus_setScrollAnimation_c(struct hg3dclass_struct *classptr_c, float uSpeed_c, float vSpeed_c);
// original function: void setRotateAnimation(Real speed);
void cTus_setRotateAnimation_c(struct hg3dclass_struct *classptr_c, float speed_c);
// original function: void removeAllEffects();
void cTus_removeAllEffects_c(struct hg3dclass_struct *classptr_c);
// original function: bool isBlank();
void cTus_isBlank_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setBlank();
void cTus_setBlank_c(struct hg3dclass_struct *classptr_c);
// original function: bool isTextureLoadFailing();
void cTus_isTextureLoadFailing_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void retryTextureLoad();
void cTus_retryTextureLoad_c(struct hg3dclass_struct *classptr_c);
// original function: Real getAnimationDuration();
void cTus_getAnimationDuration_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setTextureFiltering(TextureFilterOptions filterType);
void cTus_setTextureFiltering_c(struct hg3dclass_struct *classptr_c, enum EnumTextureFilterOptions filterType_c);
// original function: void setTextureFiltering(FilterType ftype, FilterOptions opts);
void cTus_setTextureFiltering2_c(struct hg3dclass_struct *classptr_c, enum EnumFilterType ftype_c, enum EnumFilterOptions opts_c);
// original function: void setTextureFiltering(FilterOptions minFilter, FilterOptions magFilter, FilterOptions mipFilter);
void cTus_setTextureFiltering3_c(struct hg3dclass_struct *classptr_c, enum EnumFilterOptions minFilter_c, enum EnumFilterOptions magFilter_c, enum EnumFilterOptions mipFilter_c);
// original function: FilterOptions getTextureFiltering(FilterType ftpye);
void cTus_getTextureFiltering_c(struct hg3dclass_struct *classptr_c, enum EnumFilterType ftpye_c, enum EnumFilterOptions * result_c);
// original function: void setTextureAnisotropy(unsigned int maxAniso);
void cTus_setTextureAnisotropy_c(struct hg3dclass_struct *classptr_c, unsigned int maxAniso_c);
// original function: unsigned int getTextureAnisotropy();
void cTus_getTextureAnisotropy_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setTextureMipmapBias(float bias);
void cTus_setTextureMipmapBias_c(struct hg3dclass_struct *classptr_c, float bias_c);
// original function: float getTextureMipmapBias();
void cTus_getTextureMipmapBias_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: void setCompositorReference(const String& compositorName, const String& textureName, size_t mrtIndex);
void cTus_setCompositorReference_c(struct hg3dclass_struct *classptr_c, char * compositorName_c, char * textureName_c, int mrtIndex_c);
// original function: const String& getReferencedCompositorName();
void cTus_getReferencedCompositorName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: const String& getReferencedTextureName();
void cTus_getReferencedTextureName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: size_t getReferencedMRTIndex();
void cTus_getReferencedMRTIndex_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: Pass* getParent();
void cTus_getParent_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void _prepare();
void cTus__prepare_c(struct hg3dclass_struct *classptr_c);
// original function: void _unprepare();
void cTus__unprepare_c(struct hg3dclass_struct *classptr_c);
// original function: void _load();
void cTus__load_c(struct hg3dclass_struct *classptr_c);
// original function: void _unload();
void cTus__unload_c(struct hg3dclass_struct *classptr_c);
// original function: bool hasViewRelativeTextureCoordinateGeneration();
void cTus_hasViewRelativeTextureCoordinateGeneration_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: bool isLoaded();
void cTus_isLoaded_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void _notifyNeedsRecompile();
void cTus__notifyNeedsRecompile_c(struct hg3dclass_struct *classptr_c);
// original function: void setName(const String& name);
void cTus_setName_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: const String& getName();
void cTus_getName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void setTextureNameAlias(const String& name);
void cTus_setTextureNameAlias_c(struct hg3dclass_struct *classptr_c, char * name_c);
// original function: const String& getTextureNameAlias();
void cTus_getTextureNameAlias_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: void _notifyParent(Pass* parent);
void cTus__notifyParent_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * parent_c);
// original function: const TexturePtr& _getTexturePtr();
void cTus__getTexturePtr_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * result_c);
// original function: const TexturePtr& _getTexturePtr(size_t frame);
void cTus__getTexturePtr2_c(struct hg3dclass_struct *classptr_c, int frame_c, struct sharedptr_struct * result_c);
// original function: void _setTexturePtr(const TexturePtr& texptr);
void cTus__setTexturePtr_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * texptr_c);
// original function: void _setTexturePtr(const TexturePtr& texptr, size_t frame);
void cTus__setTexturePtr2_c(struct hg3dclass_struct *classptr_c, struct sharedptr_struct * texptr_c, int frame_c);
