// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassVertexAnimationTrack.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreAnimationTrack.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "EnumVertexAnimationType.h"
#include "EnumTargetMode.h"


// original function: VertexAnimationType getAnimationType();
void cVant_getAnimationType_c(struct hg3dclass_struct *classptr_c, enum EnumVertexAnimationType * result_c);
// original function: VertexMorphKeyFrame* createVertexMorphKeyFrame(Real timePos);
void cVant_createVertexMorphKeyFrame_c(struct hg3dclass_struct *classptr_c, float timePos_c, struct hg3dclass_struct * result_c);
// original function: VertexPoseKeyFrame* createVertexPoseKeyFrame(Real timePos);
void cVant_createVertexPoseKeyFrame_c(struct hg3dclass_struct *classptr_c, float timePos_c, struct hg3dclass_struct * result_c);
// original function: VertexMorphKeyFrame* getVertexMorphKeyFrame(unsigned short index);
void cVant_getVertexMorphKeyFrame_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: VertexPoseKeyFrame* getVertexPoseKeyFrame(unsigned short index);
void cVant_getVertexPoseKeyFrame_c(struct hg3dclass_struct *classptr_c, unsigned short index_c, struct hg3dclass_struct * result_c);
// original function: void setTargetMode(TargetMode m);
void cVant_setTargetMode_c(struct hg3dclass_struct *classptr_c, enum EnumTargetMode m_c);
// original function: TargetMode getTargetMode();
void cVant_getTargetMode_c(struct hg3dclass_struct *classptr_c, enum EnumTargetMode * result_c);
// original function: bool hasNonZeroKeyFrames();
void cVant_hasNonZeroKeyFrames_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void optimise();
void cVant_optimise_c(struct hg3dclass_struct *classptr_c);
