// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// ClassViewport.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreViewport.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"
#include "ClassPtr.h"
#include "Utils.h"
#include "TypeColour.h"
#include "EnumOrientationMode.h"


// original function: void _updateDimensions();
void cVp__updateDimensions_c(struct hg3dclass_struct *classptr_c);
// original function: void update();
void cVp_update_c(struct hg3dclass_struct *classptr_c);
// original function: void clear(unsigned int buffers, const ColourValue& colour, Real depth, unsigned short stencil);
void cVp_clear_c(struct hg3dclass_struct *classptr_c, unsigned int buffers_c, struct colourvalue_struct * colour_c, float depth_c, unsigned short stencil_c);
// original function: RenderTarget* getTarget();
void cVp_getTarget_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: Camera* getCamera();
void cVp_getCamera_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
// original function: void setCamera(Camera* cam);
void cVp_setCamera_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * cam_c);
// original function: int getZOrder();
void cVp_getZOrder_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: Real getLeft();
void cVp_getLeft_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getTop();
void cVp_getTop_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getWidth();
void cVp_getWidth_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: Real getHeight();
void cVp_getHeight_c(struct hg3dclass_struct *classptr_c, float * result_c);
// original function: int getActualLeft();
void cVp_getActualLeft_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: int getActualTop();
void cVp_getActualTop_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: int getActualWidth();
void cVp_getActualWidth_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: int getActualHeight();
void cVp_getActualHeight_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setDimensions(Real left, Real top, Real width, Real height);
void cVp_setDimensions_c(struct hg3dclass_struct *classptr_c, float left_c, float top_c, float width_c, float height_c);
// original function: void setOrientationMode(OrientationMode orientationMode, bool setDefault);
void cVp_setOrientationMode_c(struct hg3dclass_struct *classptr_c, enum EnumOrientationMode orientationMode_c, int setDefault_c);
// original function: OrientationMode getOrientationMode();
void cVp_getOrientationMode_c(struct hg3dclass_struct *classptr_c, enum EnumOrientationMode * result_c);
// original function: void setBackgroundColour(const ColourValue& colour);
void cVp_setBackgroundColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * colour_c);
// original function: const ColourValue& getBackgroundColour();
void cVp_getBackgroundColour_c(struct hg3dclass_struct *classptr_c, struct colourvalue_struct * result_c);
// original function: void setClearEveryFrame(bool clear, unsigned int buffers);
void cVp_setClearEveryFrame_c(struct hg3dclass_struct *classptr_c, int clear_c, unsigned int buffers_c);
// original function: bool getClearEveryFrame();
void cVp_getClearEveryFrame_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: unsigned int getClearBuffers();
void cVp_getClearBuffers_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setAutoUpdated(bool autoupdate);
void cVp_setAutoUpdated_c(struct hg3dclass_struct *classptr_c, int autoupdate_c);
// original function: bool isAutoUpdated();
void cVp_isAutoUpdated_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setMaterialScheme(const String& schemeName);
void cVp_setMaterialScheme_c(struct hg3dclass_struct *classptr_c, char * schemeName_c);
// original function: const String& getMaterialScheme();
void cVp_getMaterialScheme_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: unsigned int _getNumRenderedFaces();
void cVp__getNumRenderedFaces_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: unsigned int _getNumRenderedBatches();
void cVp__getNumRenderedBatches_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setOverlaysEnabled(bool enabled);
void cVp_setOverlaysEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getOverlaysEnabled();
void cVp_getOverlaysEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setSkiesEnabled(bool enabled);
void cVp_setSkiesEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getSkiesEnabled();
void cVp_getSkiesEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setShadowsEnabled(bool enabled);
void cVp_setShadowsEnabled_c(struct hg3dclass_struct *classptr_c, int enabled_c);
// original function: bool getShadowsEnabled();
void cVp_getShadowsEnabled_c(struct hg3dclass_struct *classptr_c, int * result_c);
// original function: void setVisibilityMask(uint32 mask);
void cVp_setVisibilityMask_c(struct hg3dclass_struct *classptr_c, unsigned int mask_c);
// original function: uint getVisibilityMask();
void cVp_getVisibilityMask_c(struct hg3dclass_struct *classptr_c, unsigned int * result_c);
// original function: void setRenderQueueInvocationSequenceName(const String& sequenceName);
void cVp_setRenderQueueInvocationSequenceName_c(struct hg3dclass_struct *classptr_c, char * sequenceName_c);
// original function: const String& getRenderQueueInvocationSequenceName();
void cVp_getRenderQueueInvocationSequenceName_c(struct hg3dclass_struct *classptr_c, char * result_c);
// original function: RenderQueueInvocationSequence* _getRenderQueueInvocationSequence();
void cVp__getRenderQueueInvocationSequence_c(struct hg3dclass_struct *classptr_c, struct hg3dclass_struct * result_c);
