// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// EnumGpuParamVariability.h
// 
// 
// 
// 
// File for type, method, enum or function stubs  
// in: "Dep-OgreSDK/include/OGRE\OgreGpuProgramParams.h"
// 
// each stub combines the following files: 
//     a C++ implementation file, transforming cpp calls into C-functions
//     a C-header file, making this C-functions available for the C2HS parser
//     a chs file, give instructions to the C2HS parser.
// 
// 

#include "wchar.h"



//  enum from Dep-OgreSDK/include/OGRE\OgreGpuProgramParams.h line:83
	enum EnumGpuParamVariability
	{
		/// No variation except by manual setting - the default
		GPV_GLOBAL = 1, 
		/// Varies per object (based on an auto param usually), but not per light setup
		GPV_PER_OBJECT = 2, 
		/// Varies with light setup
		GPV_LIGHTS = 4, 
		/// Varies with pass iteration number
		GPV_PASS_ITERATION_NUMBER = 8,


		/// Full mask (16-bit)
		GPV_ALL = 0xFFFF

	};
